/********************************************************************************
*                                                                               *
*                                 Create ArrowButton              *
*                                                                               *
*********************************************************************************
* Copyright (C) 2001 by Anastasios Sarris.   All Rights Reserved.             *
*********************************************************************************/
#ifndef ARROWDIALOG_H
#define ARROWDIALOG_H
/*******************************************************************************/


// Mini application object
class ArrowDialog : public FXDialogBox
 {
  FXDECLARE(ArrowDialog)
private:
  FXArrowButton*	sample;
  FXStatusbar*		statusbar;
  FXHorizontalFrame*	buttons;
  FXToolbar*	mdiTools;
  FXFont*	mainFont;
  FXText*	txtResults;
  FXColorDialog* colordlg;
  FXColor	ArrowColor;
  FXTextField*	txtOwner;
  FXTextField*	txtName;
  FXTextField*	txtTarget;
  FXTextField*	txtIcon;
  FXTextField*	txtSelector;
  FXComboBox*	arrowdirection;
  FXGIFIcon*	coloricon;
  FXCheckButton*	chkDeclare;
  FXCheckButton*	chkToolStyle;
  FXCheckButton*	chkColors;
 FXSpinner*	spinw;
 FXSpinner*	spinh;
 FXSpinner*	spinPosX;
 FXSpinner*	spinPosY;
 FXColor	BaseColor;
 FXColor	ShadowColor;
 FXColor	BorderColor;
 FXColor	HiliteColor;
 FXColor	BackColor;
 FXColor	TextColor;
 FXButton* btnBaseColor;
 FXButton* btnShadowColor;
 FXButton* btnBorderColor;
 FXButton* btnHiliteColor;
 FXButton* btnBackColor;
 FXButton* btnTextColor;
 FXComboBox*	comboiconpos;
 FXComboBox*	comboalign;
 FXComboBox*	combolayout;
 FXComboBox*	comboframe;
 FXComboBox*	combostyle;
 FXButton*	btnOK;
 FXButton*	btnCancel;

private:
  ArrowDialog(){}
public:
  enum {
    ID_RESULTS=FXDialogBox::ID_LAST,
    ID_WIDTH,
    ID_HEIGHT,
    ID_POSX,
    ID_POSY,
    ID_OWNER,
    ID_NAME,
    ID_ALIGN,
    ID_LAYOUT,
    ID_FRAME,
    ID_TARGET,
    ID_SELECTOR,
    ID_ARROW_DIR,
    ID_ARROW_COLOR,
    ID_BASE_COLOR,
    ID_HILITE_COLOR,
    ID_SHADOW_COLOR,
    ID_BORDER_COLOR,
    ID_BACK_COLOR,
    ID_TOOLBARGRIP,
    ID_DECLARE,
    ID_COLOR_DECLARE
    };

public:
  long onCmdName(FXObject*,FXSelector,void*);
  long onCmdWidth(FXObject*,FXSelector,void*);
  long onCmdHeight(FXObject*,FXSelector,void*);
  long onCmdPosX(FXObject*,FXSelector,void*);
  long onCmdPosY(FXObject*,FXSelector,void*);
  long onCmdAlign(FXObject*,FXSelector,void*);
  long onCmdResults(FXObject*,FXSelector,void*);
  long onCmdLayout(FXObject*,FXSelector,void*);
  long onCmdFrame(FXObject*,FXSelector,void*);
  long onCmdTarget(FXObject*,FXSelector,void*);
  long onCmdArrowDir(FXObject*,FXSelector,void*);
  long onCmdArrowColor(FXObject*,FXSelector,void*);
  long onCmdDeclare(FXObject*,FXSelector,void*);
  long onCmdBaseColor(FXObject*,FXSelector,void*);
  long onCmdBorderColor(FXObject*,FXSelector,void*);
  long onCmdHiliteColor(FXObject*,FXSelector,void*);
  long onCmdShadowColor(FXObject*,FXSelector,void*);
  long onCmdBackColor(FXObject*,FXSelector,void*);
  long onCmdColorDeclare(FXObject*,FXSelector,void*);
  long onCmdSelector(FXObject*,FXSelector,void*);

public:
  ArrowDialog(FXWindow* owner);
  virtual ~ArrowDialog();
  };

#endif
