/********************************************************************************
*                                                                               *
*                                 CheckButton  Creator           *
*                                                                              *
*********************************************************************************
* Copyright (C) 2001 by Sarris Anastasios.   All Rights Reserved.             *
*********************************************************************************/
#ifndef CHECKDIALOG_H
#define CHECKDIALOG_H
		
class CheckDialog: public FXDialogBox
{
	FXDECLARE(CheckDialog)
	protected:
		FXHorizontalFrame*	buttons;
		FXFont* mainFont;
		FXColorDialog* colordlg;
		FXFontDialog*	fontdlg;
		FXFont*	myfont;
		FXToolbar* mdiTools;
		FXButton*	btnFont;
		FXTextField*	txtTooltip;
		FXTextField* txtName;
		FXTextField* txtOwner;
		FXTextField* txtLabel;
		FXTextField* txtTarget;
		FXTextField*	txtSelector;
		FXComboBox* combolayout;
		FXComboBox* comboalign;
		FXComboBox* comboiconpos;
		FXComboBox* comboframe;
		FXCheckButton* sample;
		FXColor	TextColor;
		FXColor	BaseColor;
		FXColor	ShadowColor;
		FXColor	BorderColor;
		FXColor	HiliteColor;
		FXColor	BackColor;
		FXSpinner*	spinw;
		FXSpinner*	spinh;
		FXSpinner*	spinPosX;
		FXSpinner*	spinPosY;
		FXButton* btnBaseColor;
		FXButton* btnShadowColor;
		FXButton* btnBorderColor;
		FXButton* btnHiliteColor;
		FXButton* btnBackColor;
		FXButton* btnTextColor;
		FXCheckButton*	chkDeclare;
		FXCheckButton*	chkFont;
		FXCheckButton* chkColors;
		FXButton*	btnOK;
		FXButton*	btnCancel;
		
	private:
	CheckDialog(){}
	public:
	enum {
		ID_NAME=FXDialogBox::ID_LAST,
		ID_OWNER,
		ID_LABEL,
		ID_FONT,
		ID_TEXT,
		ID_TEXT_COLOR,
		ID_TARGET,
		ID_SELECTOR,
		ID_LAYOUT,
		ID_FRAME,
		ID_ICONPOS,
		ID_ALIGN,
		ID_WIDTH,
		ID_HEIGHT,
		ID_POSX,
		ID_POSY,
		ID_RESULTS,
		ID_DECLARE,
		ID_FONT_DECLARE,
		ID_COLOR_DECLARE,
		ID_BASE_COLOR,
 		ID_HILITE_COLOR,
		ID_SHADOW_COLOR,
		ID_BORDER_COLOR,
		ID_BACK_COLOR,
		ID_TOOLTIP,
		ID_TOOLBARGRIP
};
	public:
		long onCmdName(FXObject*,FXSelector,void*);
		long onCmdOwner(FXObject*,FXSelector,void*);
		long onCmdLabel(FXObject*,FXSelector,void*);
		long onCmdTarget(FXObject*,FXSelector,void*);
		long onCmdSelector(FXObject*,FXSelector,void*);
		long onCmdLayout(FXObject*,FXSelector,void*);
		long onCmdIconPos(FXObject*,FXSelector,void*);
		long onCmdAlign(FXObject*,FXSelector,void*);
		long onCmdWidth(FXObject*,FXSelector,void*);
		long onCmdHeight(FXObject*,FXSelector,void*);
		long onCmdPosX(FXObject*,FXSelector,void*);
		long onCmdPosY(FXObject*,FXSelector,void*);
		long onCmdFrame(FXObject*,FXSelector,void*);
		long onCmdResults(FXObject*,FXSelector,void*);
		long onCmdFont(FXObject*,FXSelector,void*);
		long onCmdTextColor(FXObject*,FXSelector,void*);
		long onCmdDeclare(FXObject*,FXSelector,void*);
		long onCmdFontDeclare(FXObject*,FXSelector,void*);
		long onCmdBaseColor(FXObject*,FXSelector,void*);
		long onCmdBorderColor(FXObject*,FXSelector,void*);
		long onCmdHiliteColor(FXObject*,FXSelector,void*);
		long onCmdShadowColor(FXObject*,FXSelector,void*);
		long onCmdBackColor(FXObject*,FXSelector,void*);
		
	public:
	CheckDialog(FXWindow* owner);
	virtual ~CheckDialog();
};

#endif