// inludes
#ifndef CLASSDIALOG_H
#define CLASSDIALOG_H

class ClassDialog : public FXDialogBox
 {
  FXDECLARE(ClassDialog)
protected:
  FXStatusbar*	statusbar;
  FXToolbar*	toolbar;
  FXToolbar*	toolbox;
  FXMatrix*	controls;
  FXHorizontalFrame*	buttons;
  FXText*	txtResults;
  FXIcon*	createicon;
  FXIcon*	copyicon;
  FXFont*	mainFont;

  FXList*	lstVars;
  FXList*	lstEnums;
  FXList*	lstMethods;
  FXList*	lstVarTypes;
  FXList*	lstClassTypes;

  FXTextField*	txtClassName;
  FXTextField*	txtAddVar;
  FXTextField*	txtAddEnum;
  FXTextField*	txtAddMethod;
  FXString	Total;
  FXButton*	btnOK;
  FXButton*	btnCancel;
  FXTabItem*	tab1;	FXTabItem*	tab2;
  FXTabItem*	tab3;	FXTabItem*	tab4;

private:
  ClassDialog(){}
public:
  enum {
    ID_CANCEL=FXDialogBox::ID_LAST,
    ID_COPY,
    ID_COPY_SEL,
    ID_CLASS_NAME,
    ID_CLASS_TYPE,
    ID_TOOLTIP,
    ID_VARS,
    ID_ENUMS,
    ID_METHODS,
    ID_ADD_VAR,
    ID_CLEAR_VARS,
    ID_ADD_ENUM,
    ID_ADD_METHOD,
    ID_REMOVE_VAR,
    ID_REMOVE_ENUM,
    ID_REMOVE_METHOD,
    ID_FONT,
    ID_STATUS_BAR,
    ID_RESULTS,
    ID_TOOLBAR,
    ID_TOOLBOX,
    ID_TIP,
    ID_VAR_TYPE
    };

public:
  long onCmdClassName(FXObject*,FXSelector,void*);
  long onCmdResults(FXObject*,FXSelector,void*);
  long onCmdVars(FXObject*,FXSelector,void*);
  long onCmdClearVars(FXObject*,FXSelector,void*);
  long onCmdAddVar(FXObject*,FXSelector,void*);
  long onCmdRemoveVar(FXObject*,FXSelector,void*);
  long onCmdEnums(FXObject*,FXSelector,void*);
  long onCmdAddEnum(FXObject*,FXSelector,void*);
  long onCmdRemoveEnum(FXObject*,FXSelector,void*);
  long onCmdMethods(FXObject*,FXSelector,void*);
  long onCmdAddMethod(FXObject*,FXSelector,void*);
  long onCmdRemoveMethod(FXObject*,FXSelector,void*);
  long onCmdFont(FXObject*,FXSelector,void*);
  long onCmdStatusBar(FXObject*,FXSelector,void*);
  long onCmdVarType(FXObject*,FXSelector,void*);
  long onCmdToolBar(FXObject*,FXSelector,void*);
  long onCmdToolBox(FXObject*,FXSelector,void*);
  long onCmdToolTip(FXObject*,FXSelector,void*);
  long onCmdClassType(FXObject*,FXSelector,void*);

public:
  ClassDialog(FXWindow* owner);
  virtual ~ClassDialog();
  };

#endif
