#include "/usr/local/include/fox/fx.h"
#include "ComboDialog.h"
#include "icons.h"
#include "vars.h"

// Map
FXDEFMAP(ComboDialog) ComboDialogMap[]={
  FXMAPFUNC(SEL_COMMAND,ComboDialog::ID_COLS,ComboDialog::onCmdRowNumber),
FXMAPFUNC(SEL_COMMAND,ComboDialog::ID_VIS,ComboDialog::onCmdCols),
  FXMAPFUNC(SEL_COMMAND,ComboDialog::ID_ADD,ComboDialog::onCmdAdd),
  FXMAPFUNC(SEL_COMMAND,ComboDialog::ID_REMOVE,ComboDialog::onCmdRemove),
  FXMAPFUNC(SEL_COMMAND,ComboDialog::ID_CLEAR,ComboDialog::onCmdClear),
  FXMAPFUNC(SEL_COMMAND,ComboDialog::ID_RESULTS,ComboDialog::onCmdResults),
  FXMAPFUNC(SEL_COMMAND,ComboDialog::ID_NAME,ComboDialog::onCmdName),
  FXMAPFUNC(SEL_COMMAND,ComboDialog::ID_OWNER,ComboDialog::onCmdOwner),
  FXMAPFUNC(SEL_COMMAND,ComboDialog::ID_TARGET,ComboDialog::onCmdTarget),
  FXMAPFUNC(SEL_COMMAND,ComboDialog::ID_SELECTOR,ComboDialog::onCmdSelector),
  FXMAPFUNC(SEL_COMMAND,ComboDialog::ID_FONT,ComboDialog::onCmdFont),
  FXMAPFUNC(SEL_COMMAND,ComboDialog::ID_DECLARE,ComboDialog::onCmdDeclare),
  FXMAPFUNC(SEL_COMMAND,ComboDialog::ID_FONT_DECLARE,ComboDialog::onCmdFontDeclare),
  FXMAPFUNC(SEL_COMMAND,ComboDialog::ID_WIDTH,ComboDialog::onCmdWidth),
  FXMAPFUNC(SEL_COMMAND,ComboDialog::ID_HEIGHT,ComboDialog::onCmdHeight),
  FXMAPFUNC(SEL_COMMAND,ComboDialog::ID_POSX,ComboDialog::onCmdPosX),
  FXMAPFUNC(SEL_COMMAND,ComboDialog::ID_POSY,ComboDialog::onCmdPosY),
 };


// ButtonApp implementation
FXIMPLEMENT(ComboDialog,FXDialogBox,ComboDialogMap,ARRAYNUMBER(ComboDialogMap))

// Make some windows
ComboDialog::ComboDialog(FXWindow* owner):FXDialogBox(owner,"ListBox Creator",DECOR_TITLE|DECOR_BORDER,0)
{
    mainFont=new FXFont(getApp(),AppFont,10,FONTWEIGHT_NORMAL,FONTSLANT_REGULAR,FONTENCODING_GREEK);
  buttons=new FXHorizontalFrame(this,LAYOUT_SIDE_BOTTOM|FRAME_NONE|LAYOUT_FILL_X|PACK_UNIFORM_WIDTH,0,0,0,0,40,40,20,20);
	FXTabBook* MainTabs=new FXTabBook(this,NULL,0,LAYOUT_FILL_X|LAYOUT_FILL_Y|LAYOUT_RIGHT);
	tab1=new FXTabItem(MainTabs,"&Basics",NULL);
		FXMatrix* controls=new FXMatrix(MainTabs,2,FRAME_RIDGE|MATRIX_BY_COLUMNS|LAYOUT_FILL_X);
		
		// Name
		FXLabel *lblName=new FXLabel(controls,"&Name:\tObject name",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
		lblName->setFont(mainFont);
		txtName=new FXTextField(controls,15,this,ID_NAME,LAYOUT_LEFT|FRAME_SUNKEN);
		txtName->setFont(mainFont);
		txtName->setText("cmb");
	
		//Owner
		FXLabel *lblOwner=new FXLabel(controls,"&Owner:\tObject Owner",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
		lblOwner->setFont(mainFont);
		txtOwner=new FXTextField(controls,15,this,ID_OWNER,LAYOUT_LEFT|FRAME_SUNKEN);
		txtOwner->setFont(mainFont);
		
		//rows
		FXLabel* lblVis=new FXLabel(controls,"&Visible Rows:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
		lblVis->setFont(mainFont);
		spinVis=new FXSpinner(controls,6,this,ID_VIS,SPIN_NORMAL|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
		spinVis->setFont(mainFont);
		spinVis->setRange(1,20);

		//cols
		FXLabel* lblCols=new FXLabel(controls,"&Columns:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
		lblCols->setFont(mainFont);
		spinCols=new FXSpinner(controls,6,this,ID_COLS,SPIN_NORMAL|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
		spinCols->setFont(mainFont);
		spinCols->setRange(1,20);

			
		//Target
		FXLabel *lblTarget=new FXLabel(controls,"&Target:",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
		lblTarget->setFont(mainFont);
		txtTarget=new FXTextField(controls,15,this,ID_TARGET,LAYOUT_LEFT|FRAME_SUNKEN);
		txtTarget->setFont(mainFont);
		
	              //Selector
		FXLabel *lblSelector=new FXLabel(controls,"&ID:",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
		lblSelector->setFont(mainFont);
		txtSelector=new FXTextField(controls,15,this,ID_SELECTOR,LAYOUT_LEFT|FRAME_SUNKEN);
		txtSelector->setFont(mainFont);

		//Width
		FXLabel* lblWidth=new FXLabel(controls,"&Width:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
		lblWidth->setFont(mainFont);
		spinw=new FXSpinner(controls,6,this,ID_WIDTH,SPIN_NORMAL|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
		spinw->setFont(mainFont);
		spinw->setRange(1,500);

		//Height
		FXLabel *lblHeight=new FXLabel(controls,"&Height:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
		lblHeight->setFont(mainFont);
		spinh=new FXSpinner(controls,6,this,ID_HEIGHT,SPIN_NORMAL|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
		spinh->setFont(mainFont);
		spinh->setRange(1,400);

		//POS x
		FXLabel *lblPosX=new FXLabel(controls,"&X Pos:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
		lblPosX->setFont(mainFont);
		spinPosX=new FXSpinner(controls,6,this,ID_POSX,SPIN_NORMAL|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
		spinPosX->setFont(mainFont);
		spinPosX->setRange(1,1000);
	
		//POS y
		FXLabel *lblPosY=new FXLabel(controls,"& Pos:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
		lblPosY->setFont(mainFont);
		spinPosY=new FXSpinner(controls,6,this,ID_POSX,SPIN_NORMAL|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
		spinPosY->setFont(mainFont);
		spinPosY->setRange(1,1000);

		//font
		 btnFont=new FXButton(controls,"&Font",NULL,this,ID_FONT,BUTTON_TOOLBAR|ICON_ABOVE_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,52,52);
		 btnFont->setFont(mainFont);
		 myfont=new FXFont(getApp(),"helvetica",12);
		
                            chkDeclare=new FXCheckButton(controls,"Declare in the class",this,ID_DECLARE,ICON_AFTER_TEXT|LAYOUT_NORMAL|FRAME_RAISED);
		chkDeclare->setFont(mainFont);
		chkFont=new FXCheckButton(controls,"Get the main Font",this,ID_FONT_DECLARE,ICON_AFTER_TEXT|LAYOUT_NORMAL|FRAME_RAISED);
		chkFont->setFont(mainFont);

	tab2=new FXTabItem(MainTabs,"&List Control",NULL);
		FXMatrix* ListCtrl=new FXMatrix(MainTabs,2,FRAME_RIDGE|MATRIX_BY_COLUMNS|LAYOUT_FILL_X);	
             	
		 // 
		   FXLabel* lblAdd=new FXLabel(ListCtrl,"Add:\tAdd new row",NULL,ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_NONE,50,55,52,52);
		   lblAdd->setFont(mainFont);
		   txtAdd=new FXTextField(ListCtrl,20,this,ID_ADD,JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED);
		   txtAdd->setFont(mainFont);
		
		   // 
		   FXButton* btnRemove=new FXButton(ListCtrl,"Del\tDelete Selected row",NULL,this,ID_REMOVE,ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,52,52);
		   btnRemove->setFont(mainFont);

		   //
		   FXButton* btnClear=new FXButton(ListCtrl,"Clear\tClear the list",NULL,this,ID_CLEAR,ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,52,52);
		   btnClear->setFont(mainFont);

  sample=new FXComboBox(mtxSamples,5,4,NULL,0,LAYOUT_FILL_X,0,0,150,40);
  sample->setFont(mainFont);
  sample->appendItem("Replace it");
  sample->hide();

  btnOK=new FXButton(buttons,"Create\tCreate commands and\ncopy them into code window",NULL,this,ID_RESULTS,ICON_ABOVE_TEXT|JUSTIFY_NORMAL|LAYOUT_BOTTOM|LAYOUT_RIGHT|FRAME_RAISED,50,55,52,52);
  btnCancel=new FXButton(buttons,"Close\tClose the Dialog",NULL,this,FXDialogBox::ID_CANCEL,ICON_ABOVE_TEXT|JUSTIFY_NORMAL|LAYOUT_BOTTOM|LAYOUT_RIGHT|FRAME_RAISED,10,15,52,52);
}

ComboDialog::~ComboDialog(){}

long ComboDialog::onCmdRowNumber(FXObject*,FXSelector,void*)
{
	sample->setNumVisible(spinVis->getValue());
	return 1;
}

long ComboDialog::onCmdCols(FXObject*,FXSelector,void*)
{
	sample->setNumColumns(spinCols->getValue());
	return 1;
}

long ComboDialog::onCmdAdd(FXObject*,FXSelector,void*)
{
	sample->appendItem(txtAdd->getText(),NULL);
	txtAdd->setText("");
	return 1;
}

long ComboDialog::onCmdRemove(FXObject*,FXSelector,void*)
{
	sample->removeItem(sample->getCurrentItem());
	return 1;
}


long ComboDialog::onCmdClear(FXObject*,FXSelector,void*)
{
	  sample->clearItems();
	  return 1;
}

long ComboDialog::onCmdName(FXObject*,FXSelector,void*)
{
	sample->show();
	return 1;
}

long ComboDialog::onCmdOwner(FXObject*,FXSelector,void*)
{
	  return 1;
}

long ComboDialog::onCmdTarget(FXObject*,FXSelector,void*)
{
	  if (txtTarget->getText()=="") txtTarget->setText("NULL");
	  return 1;
}

long ComboDialog::onCmdSelector(FXObject*,FXSelector,void*)
{
	if (txtSelector->getText()=="") txtSelector->setText("0");
	return 1;
}

long ComboDialog::onCmdWidth(FXObject*,FXSelector,void*)
{
   sample->setWidth(spinw->getValue());
   sample->update();
   return 1;
}

long ComboDialog::onCmdHeight(FXObject*,FXSelector,void*)
{
	sample->setHeight(spinh->getValue());
	sample->update();
	return 1;
}

long ComboDialog::onCmdPosX(FXObject*,FXSelector,void*)
{
	sample->setX(spinPosX->getValue());
	return 1;
}

long ComboDialog::onCmdPosY(FXObject*,FXSelector,void*)
{
	sample->setY(spinh->getValue());
	return 1;
}


long ComboDialog::onCmdFont(FXObject*,FXSelector,void*)
{
	fontdlg=new FXFontDialog(this,"Change Font",DECOR_BORDER|DECOR_TITLE);
	FXFontDesc fontdesc;
	fontdlg->FXDialogBox::execute();
	fontdlg->getFontSelection(fontdesc);
	delete myfont;
	myfont=new FXFont(getApp(),fontdesc);
	myfont->create();
	sample->setFont(myfont);
	return 1;
}

long ComboDialog::onCmdResults(FXObject*,FXSelector,void*)
{
	FXString Resultstxt;
              FXString strFont;
              FXString strItems;
	FXString*	SumRes;
	FXString TipStr;
	FXString TotalLB;
	
	FXString ObjName;
	FXString ObjOwner;
	FXString ObjText;
	FXString ObjCols,ObjVis;
	FXString ObjTarget;
	FXString ObjSelector;
	FXString ObjTip;
	FXString ObjX;
	FXString ObjY;
	FXString ObjW;
	FXString ObjH;
              FXString ObjFont;
	FXString TextColorStr;
	FXString BackColorStr;
	FXString ShadowColorStr;
	FXString BorderColorStr;
	FXString BaseColorStr;
	FXString HiliteColorStr;
	FXString ObjOpts;

              DeclareStr="FXComboBox* ";
	newObjectStr="=new FXComboBox(";	
              ObjName=txtName->getText();
	ObjOwner=txtOwner->getText()+",";
              ObjTarget=txtTarget->getText()+",";
              ObjSelector=txtSelector->getText()+",";
	ObjCols=FXStringVal(spinCols->getValue(),10)+",";
	ObjVis=FXStringVal(spinVis->getValue(),10)+",";
	ObjOpts="LAYOUT_FILL_X,";
	ObjX=FXStringVal(spinPosX->getValue(),10)+",";
	ObjY=FXStringVal(spinPosY->getValue(),10)+",";
	ObjW=FXStringVal(spinw->getValue(),10)+",";
	ObjH=FXStringVal(spinh->getValue(),10);
	ObjFont="FXFont* "+ObjName+"Font=new FXFont(getApp(),"+ec+myfont->getName()+ec+","+
		FXStringVal(myfont->getSize()/10)+");\n"+ObjName+"->setFont("+ObjName+"Font);\n";

	if ((chkDeclare->getCheck())==TRUE) DeclareStr="";
	if ((chkFont->getCheck())==TRUE) ObjFont=ObjName+"->setFont(mainFont);\n";
	for (int i=0; i<sample->getNumItems(); i++)
	{
	strItems=strItems+txtName->getText()+
		"->appendItem("+ec+sample->getItemText(i)+ec+
		");\n";
	}
	
	TotalLB=DeclareStr+ObjName+newObjectStr+ObjOwner+ObjCols+ObjVis+ObjTarget+ObjSelector+ObjOpts+ObjX+ObjY+ObjW+ObjH+");\n"+
	strItems+"\n"+ObjFont+"\n";
             	SumRes=&TotalLB;
	editor->insertText(editor->getCursorPos(),SumRes->text(),SumRes->size()-1, FALSE);
	sample->hide();
	return 1;
}

long ComboDialog::onCmdDeclare(FXObject*,FXSelector,void*)
{
	return 1;
}

long ComboDialog::onCmdFontDeclare(FXObject*,FXSelector,void*)
{
	return 1;
}
