/********************************************************************************
*                                                                               *
*                                 List  Creator                        *
*                                                                               *
*********************************************************************************
* Copyright (C) 2001 by Sarris Anastasios.   All Rights Reserved.             *
*********************************************************************************/
#ifndef COMBODIALOG_H
#define COMBODIALOG_H

class ComboDialog : public FXDialogBox
 {
  FXDECLARE(ComboDialog)
protected:
	FXToolbar*	mdiTools;
	FXHorizontalFrame* buttons;
	FXComboBox*	sample;
	FXTabItem*	tab1;
	FXTabItem*	tab2;

	FXTextField*	txtAdd;
	FXTextField*	txtName;
	FXTextField*	txtOwner;
	FXTextField*	txtTarget;
	FXTextField*	txtSelector;
	FXFont*	mainFont;
	FXFont*	myfont;
	FXFontDialog*	fontdlg;
	FXCheckButton*	chkDeclare;
	FXCheckButton*	chkFont;
	FXSpinner*	spinCols;
	FXSpinner*	spinVis;
	FXButton*	btnFont;
	FXSpinner*	spinw;
	FXSpinner*	spinh;
	FXSpinner*	spinPosX;
	FXSpinner*	spinPosY;
	FXColor	BaseColor;
	FXColor	ShadowColor;
	FXColor	BorderColor;
	FXColor	HiliteColor;
	FXColor	BackColor;
	FXColor	TextColor;
	FXButton* btnBaseColor;
	FXButton* btnShadowColor;
	FXButton* btnBorderColor;
	FXButton* btnHiliteColor;
	FXButton* btnBackColor;
	FXButton* btnTextColor;
	FXComboBox*	comboiconpos;
	FXComboBox*	comboalign;
	FXComboBox*	combolayout;
	FXComboBox*	comboframe;
	FXButton*	btnOK;
	FXButton*	btnCancel;
	
private:
  ComboDialog(){}
public:
  enum {
    ID_RESULTS=FXDialogBox::ID_LAST,
    ID_COLS,
    ID_VIS,
    ID_NAME,
    ID_OWNER,
    ID_TARGET,
    ID_SELECTOR,
    ID_ADD,
    ID_REMOVE,
    ID_CLEAR,
    ID_FONT,
    ID_DECLARE,
    ID_FONT_DECLARE,
    ID_WIDTH,
    ID_HEIGHT,
    ID_POSX,
    ID_POSY,
    ID_TOOLTIP
};

public:
  long onCmdRowNumber(FXObject*,FXSelector,void*);
  long onCmdCols(FXObject*,FXSelector,void*);
  long onCmdAdd(FXObject*,FXSelector,void*);
  long onCmdRemove(FXObject*,FXSelector,void*);
  long onCmdClear(FXObject*,FXSelector,void*);
  long onCmdResults(FXObject*,FXSelector,void*);
  long onCmdName(FXObject*,FXSelector,void*);
  long onCmdOwner(FXObject*,FXSelector,void*);
  long onCmdTarget(FXObject*,FXSelector,void*);
  long onCmdSelector(FXObject*,FXSelector,void*);
  long onCmdFont(FXObject*,FXSelector,void*);
  long onCmdDeclare(FXObject*,FXSelector,void*);
  long onCmdFontDeclare(FXObject*,FXSelector,void*);
  long onCmdWidth(FXObject*,FXSelector,void*);
  long onCmdHeight(FXObject*,FXSelector,void*);
  long onCmdPosX(FXObject*,FXSelector,void*);
  long onCmdPosY(FXObject*,FXSelector,void*);

public:
  ComboDialog(FXWindow* owner);
  virtual ~ComboDialog();
  };

#endif
