#include "/usr/local/include/fox/fx.h"
#include "HorFrameDialog.h"
#include "vars.h"

//Map
FXDEFMAP(HorFrameDialog) HorFrameMap[]={
FXMAPFUNC(SEL_COMMAND,HorFrameDialog::ID_OWNER,HorFrameDialog::onCmdOwner),
FXMAPFUNC(SEL_COMMAND,HorFrameDialog::ID_NAME,HorFrameDialog::onCmdName),
FXMAPFUNC(SEL_COMMAND,HorFrameDialog::ID_LAYOUT,HorFrameDialog::onCmdLayout),
FXMAPFUNC(SEL_COMMAND,HorFrameDialog::ID_FRAME,HorFrameDialog::onCmdFrame),
FXMAPFUNC(SEL_COMMAND,HorFrameDialog::ID_WIDTH,HorFrameDialog::onCmdWidth),
FXMAPFUNC(SEL_COMMAND,HorFrameDialog::ID_HEIGHT,HorFrameDialog::onCmdHeight),
FXMAPFUNC(SEL_COMMAND,HorFrameDialog::ID_POSX,HorFrameDialog::onCmdPosX),
FXMAPFUNC(SEL_COMMAND,HorFrameDialog::ID_POSY,HorFrameDialog::onCmdPosY),
FXMAPFUNC(SEL_COMMAND,HorFrameDialog::ID_RESULTS,HorFrameDialog::onCmdResults),
  FXMAPFUNC(SEL_COMMAND,HorFrameDialog::ID_DECLARE,HorFrameDialog::onCmdDeclare),
  FXMAPFUNC(SEL_COMMAND,HorFrameDialog::ID_COLOR_DECLARE,HorFrameDialog::onCmdColorDeclare),
  FXMAPFUNC(SEL_COMMAND,HorFrameDialog::ID_BASE_COLOR,HorFrameDialog::onCmdBaseColor),
  FXMAPFUNC(SEL_COMMAND,HorFrameDialog::ID_BORDER_COLOR,HorFrameDialog::onCmdBorderColor),
  FXMAPFUNC(SEL_COMMAND,HorFrameDialog::ID_HILITE_COLOR,HorFrameDialog::onCmdHiliteColor),
  FXMAPFUNC(SEL_COMMAND,HorFrameDialog::ID_SHADOW_COLOR,HorFrameDialog::onCmdShadowColor),
  FXMAPFUNC(SEL_COMMAND,HorFrameDialog::ID_COLOR_DECLARE,HorFrameDialog::onCmdColorDeclare),
  FXMAPFUNC(SEL_COMMAND,HorFrameDialog::ID_BACK_COLOR,HorFrameDialog::onCmdBackColor),

};

FXIMPLEMENT(HorFrameDialog,FXDialogBox,HorFrameMap,ARRAYNUMBER(HorFrameMap))
HorFrameDialog::HorFrameDialog(FXWindow* owner):FXDialogBox(owner,"Matrix Creator",DECOR_TITLE|DECOR_BORDER,0)
{
    mainFont=new FXFont(getApp(),AppFont,10,FONTWEIGHT_NORMAL,FONTSLANT_REGULAR,FONTENCODING_GREEK);
  buttons=new FXHorizontalFrame(this,LAYOUT_SIDE_BOTTOM|FRAME_NONE|LAYOUT_FILL_X|PACK_UNIFORM_WIDTH,0,0,0,0,40,40,20,20);
	FXMatrix* BasicControls=new FXMatrix(this,1,FRAME_NONE|MATRIX_BY_COLUMNS|LAYOUT_FILL_X);
 	FXToolbarShell* dragshell2=new FXToolbarShell(this,FRAME_RAISED|FRAME_THICK);
             	mdiTools=new FXToolbar(BasicControls,dragshell2,LAYOUT_SIDE_TOP|LAYOUT_FILL_X);
         	new FXToolbarGrip(mdiTools,this,ID_TOOLBARGRIP);
	         	
              	// 
		btnBaseColor=new FXButton(mdiTools,"BS\tBase color",coloricon,this,ID_BASE_COLOR,ICON_UNDER_TEXT|BUTTON_TOOLBAR|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,35,35);
		btnBaseColor->setFont(mainFont);
		btnBaseColor->setTextColor(FXRGBA(0,0,200,255));	

		// HIlite
		btnHiliteColor=new FXButton(mdiTools,"HT\tHilite color",coloricon,this,ID_HILITE_COLOR,BUTTON_TOOLBAR|ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,35,35);
		btnHiliteColor->setFont(mainFont);
		btnHiliteColor->setTextColor(FXRGBA(0,0,255,255));

		// 
		btnBorderColor=new FXButton(mdiTools,"Bd\tBorder color",coloricon,this,ID_BORDER_COLOR,BUTTON_TOOLBAR|ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,35,35);
		btnBorderColor->setFont(mainFont);
		btnBorderColor->setTextColor(FXRGBA(0,0,255,255));

		// 
		btnShadowColor=new FXButton(mdiTools,"Sd\tShadow color",coloricon,this,ID_SHADOW_COLOR,BUTTON_TOOLBAR|ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,35,35);
		btnShadowColor->setFont(mainFont);
		btnShadowColor->setTextColor(FXRGBA(0,0,255,255));

		// 
		btnBackColor=new FXButton(mdiTools,"Bc\tBack color",coloricon,this,ID_BACK_COLOR,BUTTON_TOOLBAR|ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,35,35);
		btnBackColor->setFont(mainFont);
		btnBackColor->setTextColor(FXRGBA(0,0,255,255));
	
		//     widgets
		FXButton* btnCreateMTXW=new FXButton(mdiTools,"\tCreate commands and\ncopy them into code window",createicon,this,ID_RESULTS,BUTTON_TOOLBAR|ICON_ABOVE_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,52,52);
		btnCreateMTXW->setFont(mainFont);

	FXMatrix* controls=new FXMatrix(BasicControls,2,FRAME_RIDGE|MATRIX_BY_COLUMNS|LAYOUT_FILL_X);		

	  // 
	  FXLabel *lblName=new FXLabel(controls,"&Name:\tObject name",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
	  lblName->setFont(mainFont);
	  txtName=new FXTextField(controls,15,this,ID_NAME,LAYOUT_LEFT|FRAME_SUNKEN);
	  txtName->setFont(mainFont);
	  txtName->setText("hfrm");
	
	   //
	  FXLabel *lblOwner=new FXLabel(controls,"&Owner:\tObject Owner",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
	  lblOwner->setFont(mainFont);
	  txtOwner=new FXTextField(controls,15,this,ID_OWNER,LAYOUT_LEFT|FRAME_SUNKEN);
	  txtOwner->setFont(mainFont);

	  //  
	  FXLabel *lbllayout=new FXLabel(controls,"&Layout:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
	  lbllayout->setFont(mainFont);
	  combolayout=new FXComboBox(controls,15,5,this,ID_LAYOUT,COMBOBOX_INSERT_LAST|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
	  for(int i=0; i<20; i++){  combolayout->appendItem(strlayout[i]);         }
	  combolayout->setCurrentItem(0);

	  //
	  FXLabel *lblframe=new FXLabel(controls,"&Frame Type:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
	  lblframe->setFont(mainFont);
	  comboframe=new FXComboBox(controls,15,5,this,ID_FRAME,COMBOBOX_INSERT_LAST|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
	  for(int i=0; i<7; i++){  comboframe->appendItem(strframe[i]);         }
	  comboframe->setCurrentItem(0);

	  // 
	  FXLabel* lblWidth=new FXLabel(controls,"&Width:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
	  lblWidth->setFont(mainFont);
	  spinw=new FXSpinner(controls,6,this,ID_WIDTH,SPIN_NORMAL|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
	  spinw->setFont(mainFont);
	  spinw->setRange(1,500);

	  // 
	  FXLabel *lblHeight=new FXLabel(controls,"&Height:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
	  lblHeight->setFont(mainFont);
	  spinh=new FXSpinner(controls,6,this,ID_HEIGHT,SPIN_NORMAL|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
	  spinh->setFont(mainFont);
	  spinh->setRange(1,400);

	  // 
	  FXLabel *lblPosX=new FXLabel(controls,"&X Pos:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
	  lblPosX->setFont(mainFont);
	  spinPosX=new FXSpinner(controls,6,this,ID_POSX,SPIN_NORMAL|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
	  spinPosX->setFont(mainFont);
	  spinPosX->setRange(1,1000);
	
	  // 
	  FXLabel *lblPosY=new FXLabel(controls,"& Pos:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
	  lblPosY->setFont(mainFont);
	  spinPosY=new FXSpinner(controls,6,this,ID_POSX,SPIN_NORMAL|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
	  spinPosY->setFont(mainFont);
	  spinPosY->setRange(1,1000);
	
	  chkDeclare=new FXCheckButton(controls,"Declare in the class",this,ID_DECLARE,ICON_AFTER_TEXT|LAYOUT_NORMAL|FRAME_RAISED);
	  chkDeclare->setFont(mainFont);
	  chkColors=new FXCheckButton(controls,"Set Colors",this,ID_COLOR_DECLARE,ICON_AFTER_TEXT|LAYOUT_NORMAL|FRAME_RAISED);
	  chkColors->setFont(mainFont);		

  sample=new FXHorizontalFrame(mtxSamples,FRAME_RAISED|FRAME_RIDGE|LAYOUT_FILL_X);
  BaseColor=sample->getBaseColor();
  ShadowColor=sample->getShadowColor();
  HiliteColor=sample->getHiliteColor();
  BorderColor=sample->getBorderColor();
  BackColor=sample->getBackColor();
  spinw->setValue(sample->getWidth());
  spinh->setValue(sample->getHeight());
  sample->hide();

 btnOK=new FXButton(buttons,"Create\tCreate commands and\ncopy them into code window",NULL,this,ID_RESULTS,ICON_ABOVE_TEXT|JUSTIFY_NORMAL|LAYOUT_BOTTOM|LAYOUT_RIGHT|FRAME_RAISED,50,55,52,52);
 btnCancel=new FXButton(buttons,"Close\tClose the Dialog",NULL,this,FXDialogBox::ID_CANCEL,ICON_ABOVE_TEXT|JUSTIFY_NORMAL|LAYOUT_BOTTOM|LAYOUT_RIGHT|FRAME_RAISED,10,15,52,52);
}

HorFrameDialog::~HorFrameDialog(){}

long HorFrameDialog::onCmdName(FXObject*,FXSelector,void*)
{
	sample->show();
	return 1;
}

long HorFrameDialog::onCmdOwner(FXObject*,FXSelector,void*)
{
	return 1;
}

long HorFrameDialog::onCmdColorDeclare(FXObject*,FXSelector,void*)
{
	return 1;
}

long HorFrameDialog::onCmdDeclare(FXObject*,FXSelector,void*)
{
	return 1;
}

long HorFrameDialog::onCmdFrame(FXObject*,FXSelector,void*)
{
	FXuint style=sample->getFrameStyle();
	style=comboframe->getCurrentItem();
	switch (style)
	{
		case 0:	style|=FRAME_NONE; break;
		case 1:	style|=FRAME_NONE; break;
		case 2:	style|=FRAME_RAISED; break;
		case 3:	style|=FRAME_THICK; break;
		case 4:	style|=FRAME_GROOVE; break;
		case 5:	style|=FRAME_RIDGE; break;
		case 6:	style|=FRAME_LINE; break;
	}
	sample->setFrameStyle(style);	
	return 1;
}

long HorFrameDialog::onCmdLayout(FXObject*,FXSelector,void*)
{
              FXuint style=sample->getLayoutHints();
	style=combolayout->getCurrentItem();
	switch (style)
	{
		case 0:	style|=LAYOUT_NORMAL; break;
		case 1:	style|=LAYOUT_SIDE_TOP; break;
		case 2:	style|=LAYOUT_SIDE_BOTTOM; break;
		case 3:	style|=LAYOUT_SIDE_LEFT; break;
		case 4:	style|=LAYOUT_SIDE_RIGHT; break;
		case 5:	style|=LAYOUT_FILL_COLUMN; break;
		case 6:	style|=LAYOUT_FILL_ROW; break;
		case 7:	style|=LAYOUT_LEFT; break;
		case 8:	style|=LAYOUT_RIGHT; break;
		case 9:	style|=LAYOUT_CENTER_X; break;
		case 10:	style|=LAYOUT_FIX_X; break;
		case 11:	style|=LAYOUT_TOP; break;
		case 12:	style|=LAYOUT_BOTTOM; break;
		case 13:	style|=LAYOUT_CENTER_Y; break;
		case 14:	style|=LAYOUT_FIX_Y; break;
		case 15:	style|=LAYOUT_FIX_WIDTH; break;
		case 16:	style|=LAYOUT_FIX_HEIGHT; break;
		case 17:	style|=LAYOUT_MIN_WIDTH; break;
		case 18:	style|=LAYOUT_MIN_HEIGHT; break;
		case 19:	style|=LAYOUT_FILL_X; break;
	}
	sample->setLayoutHints(style);		
	 return 1;
}

long HorFrameDialog::onCmdWidth(FXObject*,FXSelector,void*)
{
   sample->setWidth(spinw->getValue());
   sample->update();
   return 1;
}

long HorFrameDialog::onCmdHeight(FXObject*,FXSelector,void*)
{
	sample->setHeight(spinh->getValue());
	sample->update();
	return 1;
}

long HorFrameDialog::onCmdPosX(FXObject*,FXSelector,void*)
{
	sample->setX(spinPosX->getValue());
	return 1;
}

long HorFrameDialog::onCmdPosY(FXObject*,FXSelector,void*)
{
	sample->setY(spinh->getValue());
	return 1;
}

long HorFrameDialog::onCmdBaseColor(FXObject*,FXSelector,void*)
{
	colordlg=new FXColorDialog(this," ",DECOR_BORDER|DECOR_TITLE);
	colordlg->FXDialogBox::execute();
	BaseColor=colordlg->getRGBA();
	sample->setBaseColor(BaseColor);
	return 1;
}

long HorFrameDialog::onCmdBorderColor(FXObject*,FXSelector,void*)
{
	colordlg=new FXColorDialog(this," ",DECOR_BORDER|DECOR_TITLE);
	colordlg->FXDialogBox::execute();
	BorderColor=colordlg->getRGBA();
	sample->setBorderColor(BorderColor);
	return 1;
}

long HorFrameDialog::onCmdHiliteColor(FXObject*,FXSelector,void*)
{
	colordlg=new FXColorDialog(this," ",DECOR_BORDER|DECOR_TITLE);
	colordlg->FXDialogBox::execute();
	HiliteColor=colordlg->getRGBA();
	sample->setHiliteColor(HiliteColor);
	return 1;
}

long HorFrameDialog::onCmdShadowColor(FXObject*,FXSelector,void*)
{
	colordlg=new FXColorDialog(this," ",DECOR_BORDER|DECOR_TITLE);
	colordlg->FXDialogBox::execute();
	ShadowColor=colordlg->getRGBA();
	sample->setShadowColor(ShadowColor);
	return 1;
}

long HorFrameDialog::onCmdBackColor(FXObject*,FXSelector,void*)
{	
	colordlg=new FXColorDialog(this," ",DECOR_BORDER|DECOR_TITLE);
	colordlg->FXDialogBox::execute();
	BackColor=colordlg->getRGBA();
	sample->setBackColor(BackColor);
	return 1;
}

long HorFrameDialog::onCmdResults(FXObject*,FXSelector,void*)
{
	FXString Resultstxt;
              FXString strItems;
	FXString*	SumRes;
	FXString TotalM;
	
	FXString ObjName;
	FXString ObjOwner;
	FXString ObjX;
	FXString ObjY;
	FXString ObjW;
	FXString ObjH;
              FXString BackColorStr;
	FXString ShadowColorStr;
	FXString BorderColorStr;
	FXString BaseColorStr;
	FXString HiliteColorStr;
	FXString ObjOpts;

  	DeclareStr="FXHorizontalFrame* ";
	newObjectStr="=new FXHorizontalFrame(";
	ObjName=txtName->getText();
	ObjOwner=txtOwner->getText()+",";
	ObjOpts=combolayout->getText()+"|"+comboframe->getText()+",";
	ObjX=FXStringVal(spinPosX->getValue(),10)+",";
	ObjY=FXStringVal(spinPosY->getValue(),10)+",";
	ObjW=FXStringVal(spinw->getValue(),10)+",";
	ObjH=FXStringVal(spinh->getValue(),10);

	if ((chkDeclare->getCheck())==TRUE) DeclareStr="";
	if ((chkColors->getCheck())==TRUE)
	{
	BackColorStr=ObjName+"->setBackColor(FXRGBA("+FXStringVal(FXREDVAL(BackColor))+","+
		FXStringVal(FXGREENVAL(BackColor))+","+FXStringVal(FXBLUEVAL(BackColor))+","+
		FXStringVal(FXALPHAVAL(BackColor))+"));\n";
	BaseColorStr=ObjName+"->setBaseColor(FXRGBA("+FXStringVal(FXREDVAL(BaseColor))+","+
		FXStringVal(FXGREENVAL(BaseColor))+","+FXStringVal(FXBLUEVAL(BaseColor))+","+
		FXStringVal(FXALPHAVAL(BaseColor))+"));\n";
	ShadowColorStr=ObjName+"->setShadowColor(FXRGBA("+FXStringVal(FXREDVAL(ShadowColor))+","+
		FXStringVal(FXGREENVAL(ShadowColor))+","+FXStringVal(FXBLUEVAL(ShadowColor))+","+
		FXStringVal(FXALPHAVAL(ShadowColor))+"));\n";
	BorderColorStr=ObjName+"->setBorderColor(FXRGBA("+FXStringVal(FXREDVAL(BorderColor))+","+
		FXStringVal(FXGREENVAL(BorderColor))+","+FXStringVal(FXBLUEVAL(BorderColor))+","+
		FXStringVal(FXALPHAVAL(BorderColor))+"));\n";
	HiliteColorStr=ObjName+"->setHiliteColor(FXRGBA("+FXStringVal(FXREDVAL(HiliteColor))+","+
		FXStringVal(FXGREENVAL(HiliteColor))+","+FXStringVal(FXBLUEVAL(HiliteColor))+","+
		FXStringVal(FXALPHAVAL(HiliteColor))+"));\n";
	}
	else
	{
		BackColorStr="";
		BaseColorStr="";
		ShadowColorStr="";
		BorderColorStr="";
		HiliteColorStr="";
	}
      	
	TotalM=DeclareStr+ObjName+newObjectStr+ObjOwner+ObjOpts+ObjX+ObjY+ObjW+ObjH+");\n"+
	ShadowColorStr+BorderColorStr+BaseColorStr+HiliteColorStr;
             	SumRes=&TotalM;
	editor->insertText(editor->getCursorPos(),SumRes->text(),SumRes->size()-1, FALSE);
	sample->hide();
	return 1;
}


