/********************************************************************************
*                                                                               *
*                                 Label  Creator                   *
*                                                                               *
*********************************************************************************
* Copyright (C) 2001 by Sarris Anastasios.   All Rights Reserved.             *
*********************************************************************************/

#include "/usr/local/include/fox/fx.h"
#include "LabelDialog.h"
#include "icons.h"
#include "vars.h"

// Map
FXDEFMAP(LabelDialog) LabelDialogMap[]={
  FXMAPFUNC(SEL_COMMAND,LabelDialog::ID_TEXT,LabelDialog::onCmdText),
    FXMAPFUNC(SEL_COMMAND,LabelDialog::ID_NAME,LabelDialog::onCmdName),
  FXMAPFUNC(SEL_COMMAND,LabelDialog::ID_WIDTH,LabelDialog::onCmdWidth),
  FXMAPFUNC(SEL_COMMAND,LabelDialog::ID_HEIGHT,LabelDialog::onCmdHeight),
  FXMAPFUNC(SEL_COMMAND,LabelDialog::ID_POSX,LabelDialog::onCmdPosX),
  FXMAPFUNC(SEL_COMMAND,LabelDialog::ID_POSY,LabelDialog::onCmdPosY),
  FXMAPFUNC(SEL_COMMAND,LabelDialog::ID_FONT,LabelDialog::onCmdFont),
  FXMAPFUNC(SEL_COMMAND,LabelDialog::ID_RESULTS,LabelDialog::onCmdlabelRes),
  FXMAPFUNC(SEL_COMMAND,LabelDialog::ID_TOOLTIP,LabelDialog::onCmdToolTip),
  FXMAPFUNC(SEL_COMMAND,LabelDialog::ID_ICONPOS,LabelDialog::onCmdIconPos),
  FXMAPFUNC(SEL_COMMAND,LabelDialog::ID_ALIGN,LabelDialog::onCmdAlign),
  FXMAPFUNC(SEL_COMMAND,LabelDialog::ID_LAYOUT,LabelDialog::onCmdLayout),
  FXMAPFUNC(SEL_COMMAND,LabelDialog::ID_ICON,LabelDialog::onCmdIcon),
  FXMAPFUNC(SEL_COMMAND,LabelDialog::ID_FRAME,LabelDialog::onCmdFrame),
  FXMAPFUNC(SEL_COMMAND,LabelDialog::ID_TEXT_COLOR,LabelDialog::onCmdTextColor),
  FXMAPFUNC(SEL_COMMAND,LabelDialog::ID_DECLARE,LabelDialog::onCmdDeclare),
  FXMAPFUNC(SEL_COMMAND,LabelDialog::ID_FONT_DECLARE,LabelDialog::onCmdFontDeclare),
  FXMAPFUNC(SEL_COMMAND,LabelDialog::ID_COLOR_DECLARE,LabelDialog::onCmdColorDeclare),
  FXMAPFUNC(SEL_COMMAND,LabelDialog::ID_BASE_COLOR,LabelDialog::onCmdBaseColor),
  FXMAPFUNC(SEL_COMMAND,LabelDialog::ID_BORDER_COLOR,LabelDialog::onCmdBorderColor),
  FXMAPFUNC(SEL_COMMAND,LabelDialog::ID_HILITE_COLOR,LabelDialog::onCmdHiliteColor),
  FXMAPFUNC(SEL_COMMAND,LabelDialog::ID_SHADOW_COLOR,LabelDialog::onCmdShadowColor),
  FXMAPFUNC(SEL_COMMAND,LabelDialog::ID_COLOR_DECLARE,LabelDialog::onCmdColorDeclare),
  FXMAPFUNC(SEL_COMMAND,LabelDialog::ID_BACK_COLOR,LabelDialog::onCmdBackColor),
 };


// labelApp implementation
FXIMPLEMENT(LabelDialog,FXDialogBox,LabelDialogMap,ARRAYNUMBER(LabelDialogMap))

// Make some windows
LabelDialog::LabelDialog(FXWindow* owner):FXDialogBox(owner,"Label Creator",DECOR_TITLE|DECOR_BORDER,0)
{
    mainFont=new FXFont(getApp(),AppFont,10,FONTWEIGHT_NORMAL,FONTSLANT_REGULAR,FONTENCODING_GREEK);
  buttons=new FXHorizontalFrame(this,LAYOUT_SIDE_BOTTOM|FRAME_NONE|LAYOUT_FILL_X|PACK_UNIFORM_WIDTH,0,0,0,0,40,40,20,20);
	FXMatrix* BasicControls=new FXMatrix(this,1,FRAME_NONE|MATRIX_BY_COLUMNS|LAYOUT_FILL_X);
 	FXToolbarShell* dragshell2=new FXToolbarShell(this,FRAME_RAISED|FRAME_THICK);
             	mdiTools=new FXToolbar(BasicControls,dragshell2,LAYOUT_SIDE_TOP|LAYOUT_FILL_X);
         	new FXToolbarGrip(mdiTools,this,ID_TOOLBARGRIP);
		//
		btnFont=new FXButton(mdiTools,"\tFont",fonticon,this,ID_FONT,BUTTON_TOOLBAR|ICON_ABOVE_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,52,52);
		btnFont->setFont(mainFont);
		myfont=new FXFont(getApp(),"grtex",10);
	              //
		btnTextColor=new FXButton(mdiTools,"TC\tText Color",coloricon,this,ID_TEXT_COLOR,ICON_UNDER_TEXT|BUTTON_TOOLBAR|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,52,52);
		btnTextColor->setFont(mainFont);         	
         	
              	// 
		btnBaseColor=new FXButton(mdiTools,"BS\tBase color",coloricon,this,ID_BASE_COLOR,ICON_UNDER_TEXT|BUTTON_TOOLBAR|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,35,35);
		btnBaseColor->setFont(mainFont);
		btnBaseColor->setTextColor(FXRGBA(0,0,200,255));	

		// HIlite
		btnHiliteColor=new FXButton(mdiTools,"HT\tHilite color",coloricon,this,ID_HILITE_COLOR,BUTTON_TOOLBAR|ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,35,35);
		btnHiliteColor->setFont(mainFont);
		btnHiliteColor->setTextColor(FXRGBA(0,0,255,255));

		// 
		btnBorderColor=new FXButton(mdiTools,"Bd\tBorder color",coloricon,this,ID_BORDER_COLOR,BUTTON_TOOLBAR|ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,35,35);
		btnBorderColor->setFont(mainFont);
		btnBorderColor->setTextColor(FXRGBA(0,0,255,255));

		// 
		btnShadowColor=new FXButton(mdiTools,"Sd\tShadow color",coloricon,this,ID_SHADOW_COLOR,BUTTON_TOOLBAR|ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,35,35);
		btnShadowColor->setFont(mainFont);
		btnShadowColor->setTextColor(FXRGBA(0,0,255,255));

		// 
		btnBackColor=new FXButton(mdiTools,"Bc\tBack color",coloricon,this,ID_BACK_COLOR,BUTTON_TOOLBAR|ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,35,35);
		btnBackColor->setFont(mainFont);
		btnBackColor->setTextColor(FXRGBA(0,0,255,255));
	
		//     widgets
		FXButton* btnCreateLBLW=new FXButton(mdiTools,"\tCreate commands and\ncopy them into code window",createicon,this,ID_RESULTS,BUTTON_TOOLBAR|ICON_ABOVE_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,52,52);
		btnCreateLBLW->setFont(mainFont);

              FXMatrix*  controls=new FXMatrix(BasicControls,2,FRAME_RIDGE|MATRIX_BY_COLUMNS|LAYOUT_FILL_X);
	  //  
	  FXLabel *lblName=new FXLabel(controls,"&Name:\tObject name",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
	  lblName->setFont(mainFont);
	  txtName=new FXTextField(controls,15,this,ID_NAME,LAYOUT_LEFT|FRAME_SUNKEN);
	  txtName->setFont(mainFont);
	  txtName->setText("lbl");
	
	   //
	  FXLabel *lblOwner=new FXLabel(controls,"&Owner:\tObject Owner",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
	  lblOwner->setFont(mainFont);
	  txtOwner=new FXTextField(controls,15,this,ID_OWNER,LAYOUT_LEFT|FRAME_SUNKEN);
	  txtOwner->setFont(mainFont);

	  // 
	  FXLabel *lblText=new FXLabel(controls,"&Text:\tText on Object",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
	  lblText->setFont(mainFont);
	  txtLabel=new FXTextField(controls,15,this,ID_TEXT,LAYOUT_LEFT|FRAME_SUNKEN);
	  txtLabel->setFont(mainFont);
	
	  // 
	  FXLabel *lblTooltip=new FXLabel(controls,"&Tool Tip:\tTip when the mouse is over",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
	  lblTooltip->setFont(mainFont);
	  txtTooltip=new FXTextField(controls,15,this,ID_TOOLTIP,LAYOUT_LEFT|FRAME_SUNKEN);
	  txtTooltip->setFont(mainFont);
		
	   //
	  FXLabel *lblIcon=new FXLabel(controls,"&Icon:",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
	  lblIcon->setFont(mainFont);
	  txtIcon=new FXTextField(controls,15,this,ID_ICON,LAYOUT_LEFT|FRAME_SUNKEN);
	  txtIcon->setFont(mainFont);

	  // 
	  FXLabel *lbliconpos=new FXLabel(controls,"&Icon Position:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
	  lbliconpos->setFont(mainFont);
	  comboiconpos=new FXComboBox(controls,11,5,this,ID_ICONPOS,COMBOBOX_INSERT_LAST|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
	  for(int i=0; i<5; i++){  comboiconpos->appendItem(striconpos[i]);         }
	  comboiconpos->setCurrentItem(0);

	  //
	  FXLabel *lblalign=new FXLabel(controls,"&Alignment:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
	  lblalign->setFont(mainFont);
	  comboalign=new FXComboBox(controls,15,5,this,ID_ALIGN,COMBOBOX_INSERT_LAST|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
	  for(int i=0; i<8; i++){  comboalign->appendItem(stralign[i]);         }
	  comboalign->setCurrentItem(0);
	
	  //  
	  FXLabel *lbllayout=new FXLabel(controls,"&Layout:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
	  lbllayout->setFont(mainFont);
	  combolayout=new FXComboBox(controls,15,5,this,ID_LAYOUT,COMBOBOX_INSERT_LAST|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
	  for(int i=0; i<20; i++){  combolayout->appendItem(strlayout[i]);         }
	  combolayout->setCurrentItem(0);

	  //
	  FXLabel *lblframe=new FXLabel(controls,"&Frame Type:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
	  lblframe->setFont(mainFont);
	  comboframe=new FXComboBox(controls,15,5,this,ID_FRAME,COMBOBOX_INSERT_LAST|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
	  for(int i=0; i<7; i++){  comboframe->appendItem(strframe[i]);         }
	  comboframe->setCurrentItem(0);

	  // 
	  FXLabel* lblWidth=new FXLabel(controls,"&Width:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
	  lblWidth->setFont(mainFont);
	  spinw=new FXSpinner(controls,6,this,ID_WIDTH,SPIN_NORMAL|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
	  spinw->setFont(mainFont);
	  spinw->setRange(1,500);

	  // 
	  FXLabel *lblHeight=new FXLabel(controls,"&Height:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
	  lblHeight->setFont(mainFont);
	  spinh=new FXSpinner(controls,6,this,ID_HEIGHT,SPIN_NORMAL|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
	  spinh->setFont(mainFont);
	  spinh->setRange(1,400);

	  // 
	  FXLabel *lblPosX=new FXLabel(controls,"&X Pos:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
	  lblPosX->setFont(mainFont);
	  spinPosX=new FXSpinner(controls,6,this,ID_POSX,SPIN_NORMAL|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
	  spinPosX->setFont(mainFont);
	  spinPosX->setRange(1,1000);
	
	  // 
	  FXLabel *lblPosY=new FXLabel(controls,"& Pos:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
	  lblPosY->setFont(mainFont);
	  spinPosY=new FXSpinner(controls,6,this,ID_POSX,SPIN_NORMAL|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
	  spinPosY->setFont(mainFont);
	  spinPosY->setRange(1,1000);

   	chkDeclare=new FXCheckButton(controls,"Declare in the class",this,ID_DECLARE,ICON_AFTER_TEXT|LAYOUT_NORMAL|FRAME_RAISED);
	chkDeclare->setFont(mainFont);
	chkFont=new FXCheckButton(controls,"Get the main Font",this,ID_FONT_DECLARE,ICON_AFTER_TEXT|LAYOUT_NORMAL|FRAME_RAISED);
	chkFont->setFont(mainFont);
	chkColors=new FXCheckButton(controls,"Set Colors",this,ID_COLOR_DECLARE,ICON_AFTER_TEXT|LAYOUT_NORMAL|FRAME_RAISED);
	chkColors->setFont(mainFont);		

  // The sample
  sample=new FXLabel(mtxSamples,
                      "&Change me\tGive Tip.",
                      new FXGIFIcon(getApp(),Label),
                      FRAME_THICK|LAYOUT_CENTER_X|LAYOUT_CENTER_Y|LAYOUT_FIX_WIDTH|LAYOUT_FIX_HEIGHT,
                      50,55,100,55);
  sample->setFont(mainFont);
  TextColor=sample->getTextColor();
  BaseColor=sample->getBaseColor();
  ShadowColor=sample->getShadowColor();
  HiliteColor=sample->getHiliteColor();
  BorderColor=sample->getBorderColor();
  BackColor=sample->getBackColor();
  spinw->setValue(sample->getWidth());
  spinh->setValue(sample->getHeight());
  sample->hide();

  btnOK=new FXButton(buttons,"Create\tCreate commands and\ncopy them into code window",NULL,this,ID_RESULTS,ICON_ABOVE_TEXT|JUSTIFY_NORMAL|LAYOUT_BOTTOM|LAYOUT_RIGHT|FRAME_RAISED,50,55,52,52);
  btnCancel=new FXButton(buttons,"Close\tClose the Dialog",NULL,this,FXDialogBox::ID_CANCEL,ICON_ABOVE_TEXT|JUSTIFY_NORMAL|LAYOUT_BOTTOM|LAYOUT_RIGHT|FRAME_RAISED,10,15,52,52);

}

LabelDialog::~LabelDialog(){}

long LabelDialog::onCmdIconPos(FXObject*,FXSelector,void*)
{
	FXuint IconPos=sample->getIconPosition();
	IconPos=comboiconpos->getCurrentItem();
	switch (IconPos)
	{
		case 0:	IconPos|=ICON_UNDER_TEXT; break;
		case 1:	IconPos|=ICON_AFTER_TEXT;
			IconPos&=~ICON_BEFORE_TEXT; break;
		case 2:	IconPos|=ICON_BEFORE_TEXT;
			IconPos&=~ICON_AFTER_TEXT; break;
		case 3:	IconPos|=ICON_ABOVE_TEXT;
			IconPos&=~ICON_BELOW_TEXT; break;
		case 4:	IconPos|=ICON_BELOW_TEXT;
			IconPos&=~ICON_ABOVE_TEXT; break;
	}
	sample->setIconPosition(IconPos);
	return 1;
}

long LabelDialog::onCmdFrame(FXObject*,FXSelector,void*)
{
	FXuint style=sample->getFrameStyle();
	style=comboframe->getCurrentItem();
	switch (style)
	{
		case 0:	style|=FRAME_NONE; break;
		case 1:	style|=FRAME_NONE; break;
		case 2:	style|=FRAME_RAISED; break;
		case 3:	style|=FRAME_THICK; break;
		case 4:	style|=FRAME_GROOVE; break;
		case 5:	style|=FRAME_RIDGE; break;
		case 6:	style|=FRAME_LINE; break;
	}
	sample->setFrameStyle(style);	
	return 1;
}

long LabelDialog::onCmdAlign(FXObject*,FXSelector,void*)
{
	FXuint style=sample->getJustify();
	style=comboalign->getCurrentItem();
	switch (style)
	{
		case 0:
			style&=~JUSTIFY_LEFT;
			style|=JUSTIFY_NORMAL;break;
		case 1:
			style&=~JUSTIFY_HZ_APART; break;
		case 2:
			style&=~JUSTIFY_HZ_APART;
			style|=JUSTIFY_LEFT;	break;
		case 3:
			style&=~JUSTIFY_HZ_APART;
			style|=JUSTIFY_RIGHT;  	break;
		case 4:
			style|=JUSTIFY_HZ_APART; break;
		case 5:
			style&=~JUSTIFY_VT_APART; break;
		case 6:
			style&=~JUSTIFY_VT_APART;
			style|=JUSTIFY_TOP;	break;
		case 7:
			style&=~JUSTIFY_VT_APART;
			style|=JUSTIFY_BOTTOM;break;
	}
	sample->setJustify(style);		
	return 1;
}

long LabelDialog::onCmdLayout(FXObject*,FXSelector,void*)
{
              FXuint style=sample->getLayoutHints();
	style=combolayout->getCurrentItem();
	switch (style)
	{
		case 0:	style|=LAYOUT_NORMAL; break;
		case 1:	style|=LAYOUT_SIDE_TOP; break;
		case 2:	style|=LAYOUT_SIDE_BOTTOM; break;
		case 3:	style|=LAYOUT_SIDE_LEFT; break;
		case 4:	style|=LAYOUT_SIDE_RIGHT; break;
		case 5:	style|=LAYOUT_FILL_COLUMN; break;
		case 6:	style|=LAYOUT_FILL_ROW; break;
		case 7:	style|=LAYOUT_LEFT; break;
		case 8:	style|=LAYOUT_RIGHT; break;
		case 9:	style|=LAYOUT_CENTER_X; break;
		case 10:	style|=LAYOUT_FIX_X; break;
		case 11:	style|=LAYOUT_TOP; break;
		case 12:	style|=LAYOUT_BOTTOM; break;
		case 13:	style|=LAYOUT_CENTER_Y; break;
		case 14:	style|=LAYOUT_FIX_Y; break;
		case 15:	style|=LAYOUT_FIX_WIDTH; break;
		case 16:	style|=LAYOUT_FIX_HEIGHT; break;
		case 17:	style|=LAYOUT_MIN_WIDTH; break;
		case 18:	style|=LAYOUT_MIN_HEIGHT; break;
		case 19:	style|=LAYOUT_FILL_X; break;
	}
	sample->setLayoutHints(style);	
	 return 1;
}

long LabelDialog::onCmdName(FXObject*,FXSelector,void*)
{
	sample->show();
	return 1;
}

long LabelDialog::onCmdText(FXObject*,FXSelector,void*)
{
	sample->setText(txtLabel->getText());
	return 1;
}

long LabelDialog::onCmdToolTip(FXObject*,FXSelector,void*)
{
	sample->setTipText(txtTooltip->getText());
	return 1;
}


long LabelDialog::onCmdIcon(FXObject*,FXSelector,void*)
{
	if ((txtIcon->getText())=="") txtIcon->setText("NULL");
	return 1;
}

long LabelDialog::onCmdWidth(FXObject*,FXSelector,void*)
{
   sample->setWidth(spinw->getValue());
   return 1;
}

long LabelDialog::onCmdHeight(FXObject*,FXSelector,void*)
{
	sample->setHeight(spinh->getValue());
	return 1;
}

long LabelDialog::onCmdPosX(FXObject*,FXSelector,void*)
{
	sample->setX(spinPosX->getValue());
	return 1;
}

long LabelDialog::onCmdPosY(FXObject*,FXSelector,void*)
{
	sample->setY(spinh->getValue());
	return 1;
}

long LabelDialog::onCmdTextColor(FXObject*,FXSelector,void*)
{
	colordlg=new FXColorDialog(this," ",DECOR_BORDER|DECOR_TITLE);
	colordlg->FXDialogBox::execute();
	TextColor=colordlg->getRGBA();
	sample->setTextColor(TextColor);
	return 1;
}

long LabelDialog::onCmdBaseColor(FXObject*,FXSelector,void*)
{
	colordlg=new FXColorDialog(this," ",DECOR_BORDER|DECOR_TITLE);
	colordlg->FXDialogBox::execute();
	BaseColor=colordlg->getRGBA();
	sample->setBaseColor(BaseColor);
	return 1;
}

long LabelDialog::onCmdBorderColor(FXObject*,FXSelector,void*)
{
	colordlg=new FXColorDialog(this," ",DECOR_BORDER|DECOR_TITLE);
	colordlg->FXDialogBox::execute();
	BorderColor=colordlg->getRGBA();
	sample->setBorderColor(BorderColor);
	return 1;
}

long LabelDialog::onCmdHiliteColor(FXObject*,FXSelector,void*)
{
	colordlg=new FXColorDialog(this," ",DECOR_BORDER|DECOR_TITLE);
	colordlg->FXDialogBox::execute();
	HiliteColor=colordlg->getRGBA();
	sample->setHiliteColor(HiliteColor);
	return 1;
}

long LabelDialog::onCmdShadowColor(FXObject*,FXSelector,void*)
{
	colordlg=new FXColorDialog(this," ",DECOR_BORDER|DECOR_TITLE);
	colordlg->FXDialogBox::execute();
	ShadowColor=colordlg->getRGBA();
	sample->setShadowColor(ShadowColor);
	return 1;
}

long LabelDialog::onCmdBackColor(FXObject*,FXSelector,void*)
{	
	colordlg=new FXColorDialog(this," ",DECOR_BORDER|DECOR_TITLE);
	colordlg->FXDialogBox::execute();
	BackColor=colordlg->getRGBA();
	sample->setBackColor(BackColor);
	return 1;
}


long LabelDialog::onCmdlabelRes(FXObject*,FXSelector,void*)
{
	              FXString Resultstxt;
              FXString strFont;
              FXString strItems;
	FXString* SumRes;
	FXString TipStr;
	FXString TotalL;
	
	FXString ObjName;
	FXString ObjOwner;
	FXString ObjText;
	FXString ObjCols;
	FXString ObjTarget;
	FXString ObjTip;
	FXString ObjIcon;
	FXString ObjX;
	FXString ObjY;
	FXString ObjW;
	FXString ObjH;
              FXString ObjFont;
              FXString BackColorStr;
	FXString ShadowColorStr;
	FXString BorderColorStr;
	FXString BaseColorStr;
	FXString HiliteColorStr;
	FXString TextColorStr;
	FXString ObjOpts;

  	DeclareStr="FXLabel*";
	newObjectStr="=new FXLabel(";
	ObjName=txtName->getText();
	ObjOwner=txtOwner->getText()+",";
	ObjText=ec+txtLabel->getText()+"\\t";
	ObjTip=txtTooltip->getText()+ec+",";
	ObjIcon=txtIcon->getText()+",";
	ObjOpts=comboalign->getText()+"|"+combolayout->getText()+"|"+comboframe->getText()+",";
	ObjX=FXStringVal(spinPosX->getValue(),10)+",";
	ObjY=FXStringVal(spinPosY->getValue(),10)+",";
	ObjW=FXStringVal(spinw->getValue(),10)+",";
	ObjH=FXStringVal(spinh->getValue(),10);
	ObjFont="FXFont* "+ObjName+"Font=new FXFont(getApp(),"+ec+myfont->getName()+ec+","+
		FXStringVal(myfont->getSize()/10)+");\n"+ObjName+"->setFont("+ObjName+"Font);\n";

	if ((chkDeclare->getCheck())==TRUE) DeclareStr="";
	if ((chkFont->getCheck())==TRUE) ObjFont=ObjName+"->setFont(mainFont);\n";
	
	if ((chkColors->getCheck())==TRUE)
	{
	BackColorStr=ObjName+"->setBackColor(FXRGBA("+FXStringVal(FXREDVAL(BackColor))+","+
		FXStringVal(FXGREENVAL(BackColor))+","+FXStringVal(FXBLUEVAL(BackColor))+","+
		FXStringVal(FXALPHAVAL(BackColor))+"));\n";
	BaseColorStr=ObjName+"->setBaseColor(FXRGBA("+FXStringVal(FXREDVAL(BaseColor))+","+
		FXStringVal(FXGREENVAL(BaseColor))+","+FXStringVal(FXBLUEVAL(BaseColor))+","+
		FXStringVal(FXALPHAVAL(BaseColor))+"));\n";
	ShadowColorStr=ObjName+"->setShadowColor(FXRGBA("+FXStringVal(FXREDVAL(ShadowColor))+","+
		FXStringVal(FXGREENVAL(ShadowColor))+","+FXStringVal(FXBLUEVAL(ShadowColor))+","+
		FXStringVal(FXALPHAVAL(ShadowColor))+"));\n";
	BorderColorStr=ObjName+"->setBorderColor(FXRGBA("+FXStringVal(FXREDVAL(BorderColor))+","+
		FXStringVal(FXGREENVAL(BorderColor))+","+FXStringVal(FXBLUEVAL(BorderColor))+","+
		FXStringVal(FXALPHAVAL(BorderColor))+"));\n";
	HiliteColorStr=ObjName+"->setHiliteColor(FXRGBA("+FXStringVal(FXREDVAL(HiliteColor))+","+
		FXStringVal(FXGREENVAL(HiliteColor))+","+FXStringVal(FXBLUEVAL(HiliteColor))+","+
		FXStringVal(FXALPHAVAL(HiliteColor))+"));\n";
	TextColorStr=ObjName+"->setTextColor(FXRGBA("+FXStringVal(FXREDVAL(TextColor))+","+
		FXStringVal(FXGREENVAL(TextColor))+","+FXStringVal(FXBLUEVAL(TextColor))+","+
		FXStringVal(FXALPHAVAL(TextColor))+"));\n";
	}
	else
	{
		BackColorStr="";
		BaseColorStr="";
		ShadowColorStr="";
		BorderColorStr="";
		HiliteColorStr="";
		TextColorStr="";
	}
	
	TotalL=DeclareStr+ObjName+newObjectStr+ObjOwner+ObjText+ObjTip+ObjIcon+ObjOpts+ObjX+ObjY+ObjW+ObjH+");\n"+
 		ObjFont+BackColorStr+ShadowColorStr+BorderColorStr+BaseColorStr+HiliteColorStr+TextColorStr;

	SumRes=&TotalL;
	editor->insertText(editor->getCursorPos(),SumRes->text(),SumRes->size()-1, FALSE);	
	sample->hide();
	return 1;
}

long LabelDialog::onCmdFont(FXObject*,FXSelector,void*)
{
	fontdlg=new FXFontDialog(this,"Change Font",DECOR_BORDER|DECOR_TITLE);
	FXFontDesc fontdesc;
	fontdlg->FXDialogBox::execute();
	fontdlg->getFontSelection(fontdesc);
	delete myfont;
	myfont=new FXFont(getApp(),fontdesc);
	myfont->create();
	sample->setFont(myfont);
	return 1;
}

long LabelDialog::onCmdDeclare(FXObject*,FXSelector,void*)
{
	return 1;
}

long LabelDialog::onCmdFontDeclare(FXObject*,FXSelector,void*)
{
	return 1;
}

long LabelDialog::onCmdColorDeclare(FXObject*,FXSelector,void*)
{
	return 1;
}
