/********************************************************************************
*                                                                               *
*                                 Label  Creator                   *
*                                                                               *
*********************************************************************************
* Copyright (C) 2001 by Sarris Anastasios.   All Rights Reserved.             *
*********************************************************************************/
#ifndef LABELDIALOG_H
#define LABELDIALOG_H

class LabelDialog : public FXDialogBox
 {
  FXDECLARE(LabelDialog)
protected:
  FXLabel*	sample;        // Object being tested
  FXStatusbar*	statusbar;     // Status line
  FXHorizontalFrame*	buttons;

  FXString	labelalign;
  FXColor	TextColor;
  FXColorDialog* colordlg;
  FXFontDialog*	fontdlg;
  FXFont*	myfont;
  FXFont*	mainFont;
  FXText*	txtResults;
  FXToolbar*	mdiTools;;
  FXButton*	btnFont;
  FXColor	BaseColor;
  FXColor	ShadowColor;
  FXColor	BorderColor;
  FXColor	HiliteColor;
  FXColor	BackColor;
 FXSpinner*	spinw;
 FXSpinner*	spinh;
 FXSpinner*	spinPosX;
 FXSpinner*	spinPosY;

  FXTextField*	txtLabel;
  FXTextField*	txtTooltip;
  FXTextField*	txtOwner;
  FXTextField*	txtName;
  FXTextField*	txtIcon;

  FXCheckButton*	chkDeclare;
  FXCheckButton*	chkFont;
  FXCheckButton*	chkColors;
 FXButton* btnBaseColor;
 FXButton* btnShadowColor;
 FXButton* btnBorderColor;
 FXButton* btnHiliteColor;
 FXButton* btnBackColor;
 FXButton* btnTextColor;
 FXComboBox*	comboiconpos;
 FXComboBox*	comboalign;
 FXComboBox*	combolayout;
 FXComboBox*	comboframe;
 FXComboBox*	combostyle;
 FXButton*	btnOK;
 FXButton*	btnCancel;

private:
  LabelDialog(){}
public:
  enum {
    ID_TEXT=FXDialogBox::ID_LAST,
    ID_FONT,
    ID_WIDTH,
    ID_HEIGHT,
    ID_POSX,
    ID_POSY,
    ID_OWNER,
    ID_NAME,
    ID_TOOLTIP,
    ID_TOOLBARGRIP,
    ID_ICONPOS,
    ID_ALIGN,
    ID_LAYOUT,
    ID_FRAME,
    ID_ICON,
    ID_TEXT_COLOR,
    ID_BASE_COLOR,
    ID_HILITE_COLOR,
    ID_SHADOW_COLOR,
    ID_BORDER_COLOR,
    ID_BACK_COLOR,
    ID_DECLARE,
    ID_FONT_DECLARE,
    ID_COLOR_DECLARE,
    ID_RESULTS
    };

public:
  long onCmdName(FXObject*,FXSelector,void*);
  long onCmdText(FXObject*,FXSelector,void*);
  long onCmdWidth(FXObject*,FXSelector,void*);
  long onCmdHeight(FXObject*,FXSelector,void*);
  long onCmdPosX(FXObject*,FXSelector,void*);
  long onCmdPosY(FXObject*,FXSelector,void*);
  long onCmdFont(FXObject*,FXSelector,void*);
  long onCmdIconPos(FXObject*,FXSelector,void*);
  long onCmdAlign(FXObject*,FXSelector,void*);
  long onCmdlabelRes(FXObject*,FXSelector,void*);
  long onCmdToolTip(FXObject*,FXSelector,void*);
  long onCmdLayout(FXObject*,FXSelector,void*);
  long onCmdFrame(FXObject*,FXSelector,void*);
  long onCmdIcon(FXObject*,FXSelector,void*);
  long onCmdTextColor(FXObject*,FXSelector,void*);
  long onCmdDeclare(FXObject*,FXSelector,void*);
  long onCmdFontDeclare(FXObject*,FXSelector,void*);
  long onCmdBaseColor(FXObject*,FXSelector,void*);
  long onCmdBorderColor(FXObject*,FXSelector,void*);
  long onCmdHiliteColor(FXObject*,FXSelector,void*);
  long onCmdShadowColor(FXObject*,FXSelector,void*);
  long onCmdBackColor(FXObject*,FXSelector,void*);
  long onCmdColorDeclare(FXObject*,FXSelector,void*);

public:
  LabelDialog(FXWindow* owner);
  virtual ~LabelDialog();
  };

#endif
