/********************************************************************************
*                                                                               *
*                                 List  Creator                        *
*                                                                               *
*********************************************************************************
* Copyright (C) 2001 by Sarris Anastasios.   All Rights Reserved.             *
*********************************************************************************/
#include "/usr/local/include/fox/fx.h"
#include "ListDialog.h"
#include "icons.h"
#include "vars.h"

// Map
FXDEFMAP(ListDialog) ListDialogMap[]={
  FXMAPFUNC(SEL_COMMAND,ListDialog::ID_COLS,ListDialog::onCmdRowNumber),
  FXMAPFUNC(SEL_COMMAND,ListDialog::ID_ADD,ListDialog::onCmdAdd),
  FXMAPFUNC(SEL_COMMAND,ListDialog::ID_OPTION_NAME,ListDialog::onCmdOptionName),
  FXMAPFUNC(SEL_COMMAND,ListDialog::ID_OPTION_ICON,ListDialog::onCmdOptionIcon),
  FXMAPFUNC(SEL_COMMAND,ListDialog::ID_REMOVE,ListDialog::onCmdRemove),
  FXMAPFUNC(SEL_COMMAND,ListDialog::ID_CLEAR,ListDialog::onCmdClear),
  FXMAPFUNC(SEL_COMMAND,ListDialog::ID_RESULTS,ListDialog::onCmdResults),
  FXMAPFUNC(SEL_COMMAND,ListDialog::ID_NAME,ListDialog::onCmdName),
  FXMAPFUNC(SEL_COMMAND,ListDialog::ID_OWNER,ListDialog::onCmdOwner),
  FXMAPFUNC(SEL_COMMAND,ListDialog::ID_TARGET,ListDialog::onCmdTarget),
  FXMAPFUNC(SEL_COMMAND,ListDialog::ID_SELECTOR,ListDialog::onCmdSelector),
  FXMAPFUNC(SEL_COMMAND,ListDialog::ID_FONT,ListDialog::onCmdFont),
  FXMAPFUNC(SEL_COMMAND,ListDialog::ID_DECLARE,ListDialog::onCmdDeclare),
  FXMAPFUNC(SEL_COMMAND,ListDialog::ID_FONT_DECLARE,ListDialog::onCmdFontDeclare),
  FXMAPFUNC(SEL_COMMAND,ListDialog::ID_WIDTH,ListDialog::onCmdWidth),
  FXMAPFUNC(SEL_COMMAND,ListDialog::ID_HEIGHT,ListDialog::onCmdHeight),
  FXMAPFUNC(SEL_COMMAND,ListDialog::ID_POSX,ListDialog::onCmdPosX),
  FXMAPFUNC(SEL_COMMAND,ListDialog::ID_POSY,ListDialog::onCmdPosY),
 };


// ButtonApp implementation
FXIMPLEMENT(ListDialog,FXDialogBox,ListDialogMap,ARRAYNUMBER(ListDialogMap))

// Make some windows
ListDialog::ListDialog(FXWindow* owner):FXDialogBox(owner,"List Creator",DECOR_TITLE|DECOR_BORDER,0)
{
    mainFont=new FXFont(getApp(),AppFont,10,FONTWEIGHT_NORMAL,FONTSLANT_REGULAR,FONTENCODING_GREEK);
  buttons=new FXHorizontalFrame(this,LAYOUT_SIDE_BOTTOM|FRAME_NONE|LAYOUT_FILL_X|PACK_UNIFORM_WIDTH,0,0,0,0,40,40,20,20);
	FXTabBook* MainTabs=new FXTabBook(this,NULL,0,LAYOUT_FILL_X|LAYOUT_FILL_Y|LAYOUT_RIGHT);
	tab1=new FXTabItem(MainTabs,"&Basics",NULL);
		FXMatrix* controls=new FXMatrix(MainTabs,2,FRAME_RIDGE|MATRIX_BY_COLUMNS|LAYOUT_FILL_X);
		
		// Name
		FXLabel *lblName=new FXLabel(controls,"&Name:\tObject name",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
		lblName->setFont(mainFont);
		txtName=new FXTextField(controls,15,this,ID_NAME,LAYOUT_LEFT|FRAME_SUNKEN);
		txtName->setFont(mainFont);
		txtName->setText("lst");
	
		//Owner
		FXLabel *lblOwner=new FXLabel(controls,"&Owner:\tObject Owner",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
		lblOwner->setFont(mainFont);
		txtOwner=new FXTextField(controls,15,this,ID_OWNER,LAYOUT_LEFT|FRAME_SUNKEN);
		txtOwner->setFont(mainFont);
		
		//rows
		FXLabel* lblCols=new FXLabel(controls,"&Visible Rows:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
		lblCols->setFont(mainFont);
		spinCols=new FXSpinner(controls,6,this,ID_COLS,SPIN_NORMAL|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
		spinCols->setFont(mainFont);
		spinCols->setRange(1,20);
	
		//Target
		FXLabel *lblTarget=new FXLabel(controls,"&Target:",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
		lblTarget->setFont(mainFont);
		txtTarget=new FXTextField(controls,15,this,ID_TARGET,LAYOUT_LEFT|FRAME_SUNKEN);
		txtTarget->setFont(mainFont);
	
		//Selector
		FXLabel *lblSelector=new FXLabel(controls,"&ID:",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
		lblSelector->setFont(mainFont);
		txtSelector=new FXTextField(controls,15,this,ID_SELECTOR,LAYOUT_LEFT|FRAME_SUNKEN);
		txtSelector->setFont(mainFont);

		//Width
		FXLabel* lblWidth=new FXLabel(controls,"&Width:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
		lblWidth->setFont(mainFont);
		spinw=new FXSpinner(controls,6,this,ID_WIDTH,SPIN_NORMAL|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
		spinw->setFont(mainFont);
		spinw->setRange(1,500);

		//Height
		FXLabel *lblHeight=new FXLabel(controls,"&Height:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
		lblHeight->setFont(mainFont);
		spinh=new FXSpinner(controls,6,this,ID_HEIGHT,SPIN_NORMAL|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
		spinh->setFont(mainFont);
		spinh->setRange(1,400);

		// POS x
		FXLabel *lblPosX=new FXLabel(controls,"&X Pos:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
		lblPosX->setFont(mainFont);
		spinPosX=new FXSpinner(controls,6,this,ID_POSX,SPIN_NORMAL|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
		spinPosX->setFont(mainFont);
		spinPosX->setRange(1,1000);
	
		// POS y
		FXLabel *lblPosY=new FXLabel(controls,"& Pos:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
		lblPosY->setFont(mainFont);
		spinPosY=new FXSpinner(controls,6,this,ID_POSX,SPIN_NORMAL|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
		spinPosY->setFont(mainFont);
		spinPosY->setRange(1,1000);

		//font
		 btnFont=new FXButton(controls,"&Font",NULL,this,ID_FONT,BUTTON_TOOLBAR|ICON_ABOVE_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,52,52);
		 btnFont->setFont(mainFont);
		 myfont=new FXFont(getApp(),"grtex",12);
		
                            chkDeclare=new FXCheckButton(controls,"Declare in the class",this,ID_DECLARE,ICON_AFTER_TEXT|LAYOUT_NORMAL|FRAME_RAISED);
		chkDeclare->setFont(mainFont);
		chkFont=new FXCheckButton(controls,"Get the main Font",this,ID_FONT_DECLARE,ICON_AFTER_TEXT|LAYOUT_NORMAL|FRAME_RAISED);
		chkFont->setFont(mainFont);

	tab2=new FXTabItem(MainTabs,"&List Control",NULL);
		FXMatrix* ListCtrl=new FXMatrix(MainTabs,2,FRAME_RIDGE|MATRIX_BY_COLUMNS|LAYOUT_FILL_X);	
             	
		 //Option Name
		 FXLabel* lblOptionName=new FXLabel(ListCtrl,"Option Name:",NULL,ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_NONE,50,55,52,52);
		 lblOptionName->setFont(mainFont);
		 txtOptionName=new FXTextField(ListCtrl,20,this,ID_OPTION_NAME,JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED);
		 txtOptionName->setFont(mainFont);
		
		 //Option Icon
		 FXLabel* lblOptionIcon=new FXLabel(ListCtrl,"Option Icon:",NULL,ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_NONE,50,55,52,52);
		 lblOptionIcon->setFont(mainFont);
		 txtOptionIcon=new FXTextField(ListCtrl,20,this,ID_OPTION_ICON,JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED);
		 txtOptionIcon->setFont(mainFont);
		
		  //Add Option
		   FXButton* btnAdd=new FXButton(ListCtrl,"Addl\tAdd Option",NULL,this,ID_ADD,ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,52,52);
		   btnAdd->setFont(mainFont);
		
		   //Remove Option
		   FXButton* btnRemove=new FXButton(ListCtrl,"Del\tDelete Selected row",NULL,this,ID_REMOVE,ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,52,52);
		   btnRemove->setFont(mainFont);

		   //Clear
		   FXButton* btnClear=new FXButton(ListCtrl,"Clear\tClear the list",NULL,this,ID_CLEAR,ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,52,52);
		   btnClear->setFont(mainFont);

  sample=new FXList(mtxSamples,5,NULL,0,FRAME_SUNKEN|FRAME_THICK|LISTBOX_NORMAL|LAYOUT_FILL_X|LAYOUT_TOP,0,0,150,40);
  sample->setFont(mainFont);
  sample->appendItem("Replace it");
  sample->hide();

  btnOK=new FXButton(buttons,"Create\tCreate commands and\ncopy them into code window",NULL,this,ID_RESULTS,ICON_ABOVE_TEXT|JUSTIFY_NORMAL|LAYOUT_BOTTOM|LAYOUT_RIGHT|FRAME_RAISED,50,55,52,52);
  btnCancel=new FXButton(buttons,"Close\tClose Dialog",NULL,this,FXDialogBox::ID_CANCEL,ICON_ABOVE_TEXT|JUSTIFY_NORMAL|LAYOUT_BOTTOM|LAYOUT_RIGHT|FRAME_RAISED,10,15,52,52);
}

ListDialog::~ListDialog(){}

long ListDialog::onCmdRowNumber(FXObject*,FXSelector,void*)
{
	sample->setNumVisible(spinCols->getValue());
	return 1;
}

long ListDialog::onCmdAdd(FXObject*,FXSelector,void*)
{
	sample->appendItem(txtOptionName->getText(),NULL);
	txtOptionName->setText("");
	txtOptionIcon->setText("");
	return 1;
}

long ListDialog::onCmdOptionName(FXObject*,FXSelector,void*)
{
	sample->show();
	return 1;
}

long ListDialog::onCmdOptionIcon(FXObject*,FXSelector,void*)
{
	return 1;
}

long ListDialog::onCmdRemove(FXObject*,FXSelector,void*)
{
	sample->removeItem(sample->getCurrentItem());
	return 1;
}


long ListDialog::onCmdClear(FXObject*,FXSelector,void*)
{
	  sample->clearItems();
	  return 1;
}

long ListDialog::onCmdName(FXObject*,FXSelector,void*)
{
	  return 1;
}

long ListDialog::onCmdOwner(FXObject*,FXSelector,void*)
{
	  return 1;
}

long ListDialog::onCmdTarget(FXObject*,FXSelector,void*)
{
	if (txtTarget->getText()=="") txtTarget->setText("NULL");
	return 1;
}

long ListDialog::onCmdSelector(FXObject*,FXSelector,void*)
{
	if (txtSelector->getText()=="") txtSelector->setText("0");
	return 1;
}

long ListDialog::onCmdWidth(FXObject*,FXSelector,void*)
{
   sample->setWidth(spinw->getValue());
   return 1;
}

long ListDialog::onCmdHeight(FXObject*,FXSelector,void*)
{
	sample->setHeight(spinh->getValue());
	return 1;
}

long ListDialog::onCmdPosX(FXObject*,FXSelector,void*)
{
	sample->setX(spinPosX->getValue());
	return 1;
}

long ListDialog::onCmdPosY(FXObject*,FXSelector,void*)
{
	sample->setY(spinh->getValue());
	return 1;
}


long ListDialog::onCmdFont(FXObject*,FXSelector,void*)
{
	fontdlg=new FXFontDialog(this,"Change Font",DECOR_BORDER|DECOR_TITLE);
	FXFontDesc fontdesc;
	fontdlg->FXDialogBox::execute();
	fontdlg->getFontSelection(fontdesc);
	delete myfont;
	myfont=new FXFont(getApp(),fontdesc);
	myfont->create();
	sample->setFont(myfont);
	return 1;
}

long ListDialog::onCmdResults(FXObject*,FXSelector,void*)
{
	FXString Resultstxt;
              FXString strFont;
              FXString strItems;
	FXString*	SumRes;
	FXString TipStr;
	FXString TotalLB;
	
	FXString ObjName;
	FXString ObjOwner;
	FXString ObjText;
	FXString ObjCols;
	FXString ObjTarget;
	FXString ObjSelector;
	FXString ObjTip;
	FXString ObjX;
	FXString ObjY;
	FXString ObjW;
	FXString ObjH;
              FXString ObjFont;
	FXString TextColorStr;
	FXString BackColorStr;
	FXString ShadowColorStr;
	FXString BorderColorStr;
	FXString BaseColorStr;
	FXString HiliteColorStr;
	FXString ObjOpts;

  	DeclareStr="FXList* ";
	newObjectStr="=new FXList(";	
	ObjName=txtName->getText();
	ObjOwner=txtOwner->getText()+",";
              ObjTarget=txtTarget->getText()+",";
              ObjSelector=txtSelector->getText()+",";
              ObjCols=FXStringVal(spinCols->getValue(),10)+",";
	ObjOpts="LISTBOX_NORMAL|LAYOUT_FILL_X,";
	ObjX=FXStringVal(spinPosX->getValue(),10)+",";
	ObjY=FXStringVal(spinPosY->getValue(),10)+",";
	ObjW=FXStringVal(spinw->getValue(),10)+",";
	ObjH=FXStringVal(spinh->getValue(),10);
	ObjFont="FXFont* "+ObjName+"Font=new FXFont(getApp(),"+ec+myfont->getName()+ec+","+
		FXStringVal(myfont->getSize()/10)+");\n"+ObjName+"->setFont("+ObjName+"Font);\n";

	if ((chkDeclare->getCheck())==TRUE) DeclareStr="";
	if ((chkFont->getCheck())==TRUE) ObjFont=ObjName+"->setFont(mainFont);\n";
	for (int i=0; i<sample->getNumItems(); i++)
	{
	strItems=strItems+txtName->getText()+
		"->appendItem("+ec+sample->getItemText(i)+ec+
		");\n";
	}
	
	TotalLB=DeclareStr+ObjName+newObjectStr+ObjOwner+ObjCols+ObjTarget+ObjSelector+ObjOpts+ObjX+ObjY+ObjW+ObjH+");\n"+
	strItems+"\n"+ObjFont+"\n";
             	SumRes=&TotalLB;
	editor->insertText(editor->getCursorPos(),SumRes->text(),SumRes->size()-1, FALSE);
	sample->hide();
	return 1;
}

long ListDialog::onCmdDeclare(FXObject*,FXSelector,void*)
{
	return 1;
}

long ListDialog::onCmdFontDeclare(FXObject*,FXSelector,void*)
{
	return 1;
}
