/********************************************************************************
*                                                                               *
*                                 Create Button                        *
*                                                                               *
*********************************************************************************
* Copyright (C) 2001 by Anastasios Sarris.   All Rights Reserved.             *
*********************************************************************************/
#include "/usr/local/include/fox/fx.h"
#include "OptionDialog.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "icons.h"
#include "vars.h"

// Map
FXDEFMAP(OptionDialog) OptionDialogMap[]={
  FXMAPFUNC(SEL_COMMAND,OptionDialog::ID_TEXT,OptionDialog::onCmdText),
  FXMAPFUNC(SEL_COMMAND,OptionDialog::ID_NAME,OptionDialog::onCmdName),
  FXMAPFUNC(SEL_COMMAND,OptionDialog::ID_WIDTH,OptionDialog::onCmdWidth),
  FXMAPFUNC(SEL_COMMAND,OptionDialog::ID_HEIGHT,OptionDialog::onCmdHeight),
  FXMAPFUNC(SEL_COMMAND,OptionDialog::ID_POSX,OptionDialog::onCmdPosX),
  FXMAPFUNC(SEL_COMMAND,OptionDialog::ID_POSY,OptionDialog::onCmdPosY),
  FXMAPFUNC(SEL_COMMAND,OptionDialog::ID_FONT,OptionDialog::onCmdFont),
  FXMAPFUNC(SEL_COMMAND,OptionDialog::ID_RESULTS,OptionDialog::onCmdResults),
  FXMAPFUNC(SEL_COMMAND,OptionDialog::ID_TOOLTIP,OptionDialog::onCmdToolTip),
  FXMAPFUNC(SEL_COMMAND,OptionDialog::ID_ICONPOS,OptionDialog::onCmdIconPos),
  FXMAPFUNC(SEL_COMMAND,OptionDialog::ID_ALIGN,OptionDialog::onCmdAlign),
  FXMAPFUNC(SEL_COMMAND,OptionDialog::ID_LAYOUT,OptionDialog::onCmdLayout),
  FXMAPFUNC(SEL_COMMAND,OptionDialog::ID_TARGET,OptionDialog::onCmdTarget),
  FXMAPFUNC(SEL_COMMAND,OptionDialog::ID_SELECTOR,OptionDialog::onCmdSelector),
  FXMAPFUNC(SEL_COMMAND,OptionDialog::ID_ICON,OptionDialog::onCmdIcon),
  FXMAPFUNC(SEL_COMMAND,OptionDialog::ID_FRAME,OptionDialog::onCmdFrame),
  FXMAPFUNC(SEL_COMMAND,OptionDialog::ID_TEXT_COLOR,OptionDialog::onCmdTextColor),
  FXMAPFUNC(SEL_COMMAND,OptionDialog::ID_DECLARE,OptionDialog::onCmdDeclare),
  FXMAPFUNC(SEL_COMMAND,OptionDialog::ID_FONT_DECLARE,OptionDialog::onCmdFontDeclare),
  FXMAPFUNC(SEL_COMMAND,OptionDialog::ID_COLOR_DECLARE,OptionDialog::onCmdColorDeclare),
  FXMAPFUNC(SEL_COMMAND,OptionDialog::ID_BASE_COLOR,OptionDialog::onCmdBaseColor),
  FXMAPFUNC(SEL_COMMAND,OptionDialog::ID_BORDER_COLOR,OptionDialog::onCmdBorderColor),
  FXMAPFUNC(SEL_COMMAND,OptionDialog::ID_HILITE_COLOR,OptionDialog::onCmdHiliteColor),
  FXMAPFUNC(SEL_COMMAND,OptionDialog::ID_SHADOW_COLOR,OptionDialog::onCmdShadowColor),
  FXMAPFUNC(SEL_COMMAND,OptionDialog::ID_BACK_COLOR,OptionDialog::onCmdBackColor),
 };

// ButtonApp implementation
FXIMPLEMENT(OptionDialog,FXDialogBox,OptionDialogMap,ARRAYNUMBER(OptionDialogMap))

// Make some windows
OptionDialog::OptionDialog(FXWindow* owner):FXDialogBox(owner,"Button Creator",DECOR_TITLE|DECOR_BORDER,0)
{
    mainFont=new FXFont(getApp(),AppFont,10,FONTWEIGHT_NORMAL,FONTSLANT_REGULAR,FONTENCODING_GREEK);
  buttons=new FXHorizontalFrame(this,LAYOUT_SIDE_BOTTOM|FRAME_NONE|LAYOUT_FILL_X|PACK_UNIFORM_WIDTH,0,0,0,0,40,40,20,20);
	FXMatrix* BasicControls=new FXMatrix(this,1,FRAME_NONE|MATRIX_BY_COLUMNS|LAYOUT_FILL_X);
 	FXToolbarShell* dragshell2=new FXToolbarShell(this,FRAME_RAISED|FRAME_THICK);
             	mdiTools=new FXToolbar(BasicControls,dragshell2,LAYOUT_SIDE_TOP|LAYOUT_FILL_X);
         	new FXToolbarGrip(mdiTools,this,ID_TOOLBARGRIP);
		//Font
		btnFont=new FXButton(mdiTools,"\tFont",fonticon,this,ID_FONT,BUTTON_TOOLBAR|ICON_ABOVE_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,52,52);
		btnFont->setFont(mainFont);
		buttonFont=new FXFont(getApp(),"grtex",10);
	              //Text Color
		btnTextColor=new FXButton(mdiTools,"TC\tText Color",coloricon,this,ID_TEXT_COLOR,ICON_UNDER_TEXT|BUTTON_TOOLBAR|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,52,52);
		btnTextColor->setFont(mainFont);         	
         	
              	//Basic Color
		btnBaseColor=new FXButton(mdiTools,"\tBase color",coloricon,this,ID_BASE_COLOR,ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,35,35);
		btnBaseColor->setFont(mainFont);
		btnBaseColor->setBaseColor(FXRGBA(255,100,0,255));
		
		//HIlite
		btnHiliteColor=new FXButton(mdiTools,"\tHilite color",coloricon,this,ID_HILITE_COLOR,ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,35,35);
		btnHiliteColor->setFont(mainFont);
		btnHiliteColor->setHiliteColor(FXRGBA(255,0,0,255));

		//Border Color
		btnBorderColor=new FXButton(mdiTools,"\tBorder color",coloricon,this,ID_BORDER_COLOR,ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,35,35);
		btnBorderColor->setFont(mainFont);
		btnBorderColor->setBorderColor(FXRGBA(0,255,0,255));

		// Shadow
		btnShadowColor=new FXButton(mdiTools,"\tShadow color",coloricon,this,ID_SHADOW_COLOR,ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,35,35);
		btnShadowColor->setFont(mainFont);
		btnShadowColor->setShadowColor(FXRGBA(255,0,0,255));

		// Back Color
		btnBackColor=new FXButton(mdiTools,"\tBack color",coloricon,this,ID_BACK_COLOR,ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,35,35);
		btnBackColor->setFont(mainFont);
		btnBackColor->setBackColor(FXRGBA(255,0,0,255));

	FXMatrix* controls=new FXMatrix(BasicControls,2,FRAME_RIDGE|MATRIX_BY_COLUMNS|LAYOUT_FILL_X);		
             	
		// Name
		FXLabel *lblName=new FXLabel(controls,"&Name:\tObject name",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
		lblName->setFont(mainFont);
		txtName=new FXTextField(controls,15,this,ID_NAME,LAYOUT_LEFT|FRAME_SUNKEN);
		txtName->setFont(mainFont);
		txtName->setText("Opt");
	
		// Owner
		FXLabel *lblOwner=new FXLabel(controls,"&Owner:\tObject Owner",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
		lblOwner->setFont(mainFont);
		txtOwner=new FXTextField(controls,15,this,ID_OWNER,LAYOUT_LEFT|FRAME_SUNKEN);
		txtOwner->setFont(mainFont);

		// Text
		FXLabel *lblText=new FXLabel(controls,"&Text:\tText on Object",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
		lblText->setFont(mainFont);
		txtLabel=new FXTextField(controls,15,this,ID_TEXT,LAYOUT_LEFT|FRAME_SUNKEN);
		txtLabel->setFont(mainFont);
            	  	
		// Tip
		FXLabel *lblTooltip=new FXLabel(controls,"&Tool Tip:\tTip when the mouse is over",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
		lblTooltip->setFont(mainFont);
		txtTooltip=new FXTextField(controls,15,this,ID_TOOLTIP,LAYOUT_LEFT|FRAME_SUNKEN);
		txtTooltip->setFont(mainFont);
	
		// Target
		FXLabel *lblTarget=new FXLabel(controls,"&Target,ID:\tTarget,ID",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
		lblTarget->setFont(mainFont);
		txtTarget=new FXTextField(controls,15,this,ID_TARGET,LAYOUT_LEFT|FRAME_SUNKEN);
		txtTarget->setFont(mainFont);
	
		//Selector
		FXLabel *lblSelector=new FXLabel(controls,"&ID:",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
		lblSelector->setFont(mainFont);
		txtSelector=new FXTextField(controls,15,this,ID_SELECTOR,LAYOUT_LEFT|FRAME_SUNKEN);
		txtSelector->setFont(mainFont);
		
		// Icon
		FXLabel *lblIcon=new FXLabel(controls,"&Icon:",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
		lblIcon->setFont(mainFont);
		txtIcon=new FXTextField(controls,15,this,ID_ICON,LAYOUT_LEFT|FRAME_SUNKEN);
		txtIcon->setFont(mainFont);

		// Icon Pos
		FXLabel *lbliconpos=new FXLabel(controls,"&Icon Position:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
		lbliconpos->setFont(mainFont);
		comboiconpos=new FXComboBox(controls,11,5,this,ID_ICONPOS,COMBOBOX_INSERT_LAST|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
		for(int i=0; i<5; i++){  comboiconpos->appendItem(striconpos[i]);         }
		comboiconpos->setCurrentItem(0);

		//Alignment
		FXLabel *lblalign=new FXLabel(controls,"&Alignment:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
		lblalign->setFont(mainFont);
		comboalign=new FXComboBox(controls,15,5,this,ID_ALIGN,COMBOBOX_INSERT_LAST|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
		for(int i=0; i<8; i++){  comboalign->appendItem(stralign[i]);         }
		comboalign->setCurrentItem(0);
	
		//Layout
		FXLabel *lbllayout=new FXLabel(controls,"&Layout:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
		lbllayout->setFont(mainFont);
		combolayout=new FXComboBox(controls,15,5,this,ID_LAYOUT,COMBOBOX_INSERT_LAST|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
		for(int i=0; i<20; i++){  combolayout->appendItem(strlayout[i]);         }
		combolayout->setCurrentItem(0);

		//Frame
		FXLabel *lblframe=new FXLabel(controls,"&Frame Type:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
		lblframe->setFont(mainFont);
		comboframe=new FXComboBox(controls,15,5,this,ID_FRAME,COMBOBOX_INSERT_LAST|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
		for(int i=0; i<7; i++){  comboframe->appendItem(strframe[i]);         }
		comboframe->setCurrentItem(0);

		//Width
		FXLabel* lblWidth=new FXLabel(controls,"&Width:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
		lblWidth->setFont(mainFont);
		spinw=new FXSpinner(controls,6,this,ID_WIDTH,SPIN_NORMAL|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
		spinw->setFont(mainFont);
		spinw->setRange(1,500);
				
		//Height
		FXLabel *lblHeight=new FXLabel(controls,"&Height:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
		lblHeight->setFont(mainFont);
		spinh=new FXSpinner(controls,6,this,ID_HEIGHT,SPIN_NORMAL|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
		spinh->setFont(mainFont);
		spinh->setRange(1,400);
		
		// POS x
		FXLabel *lblPosX=new FXLabel(controls,"&X Pos:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
		lblPosX->setFont(mainFont);
		spinPosX=new FXSpinner(controls,6,this,ID_POSX,SPIN_NORMAL|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
		spinPosX->setFont(mainFont);
		spinPosX->setRange(1,1000);
	
		// POS y
		FXLabel *lblPosY=new FXLabel(controls,"& Pos:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
		lblPosY->setFont(mainFont);
		spinPosY=new FXSpinner(controls,6,this,ID_POSX,SPIN_NORMAL|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
		spinPosY->setFont(mainFont);
		spinPosY->setRange(1,1000);

                            chkDeclare=new FXCheckButton(controls,"Declare in the class",this,ID_DECLARE,ICON_AFTER_TEXT|LAYOUT_NORMAL|FRAME_RAISED);
		chkDeclare->setFont(mainFont);
		chkFont=new FXCheckButton(controls,"Get the main Font",this,ID_FONT_DECLARE,ICON_AFTER_TEXT|LAYOUT_NORMAL|FRAME_RAISED);
		chkFont->setFont(mainFont);
		chkColors=new FXCheckButton(controls,"Set Colors",this,ID_COLOR_DECLARE,ICON_AFTER_TEXT|LAYOUT_NORMAL|FRAME_RAISED);
		chkColors->setFont(mainFont);	

		  // The sample
		sample=new FXOption(mtxSamples,
		"&Change the text\tTip.",
		new FXGIFIcon(getApp(),DrawnButton),
		NULL,0,
		JUSTIFY_NORMAL|ICON_BEFORE_TEXT|MENUBUTTON_DOWN,
		50,55,100,50);
		sample->setFont(mainFont);
		TextColor=sample->getTextColor();
		BaseColor=sample->getBaseColor();
		ShadowColor=sample->getShadowColor();
		HiliteColor=sample->getHiliteColor();
		BorderColor=sample->getBorderColor();
		BackColor=sample->getBackColor();
		spinw->setValue(sample->getWidth());
		spinh->setValue(sample->getHeight());
		sample->hide();

  btnOK=new FXButton(buttons,"Create\tCreate commands and\ncopy them into code window",NULL,this,ID_RESULTS,ICON_ABOVE_TEXT|JUSTIFY_NORMAL|LAYOUT_BOTTOM|LAYOUT_RIGHT|FRAME_RAISED,50,55,52,52);
  btnCancel=new FXButton(buttons,"Close\tClose Dialog",NULL,this,FXDialogBox::ID_CANCEL,ICON_ABOVE_TEXT|JUSTIFY_NORMAL|LAYOUT_BOTTOM|LAYOUT_RIGHT|FRAME_RAISED,10,15,52,52);

}

OptionDialog::~OptionDialog(){}

long OptionDialog::onCmdIconPos(FXObject*,FXSelector,void*)
{
	FXuint IconPos=sample->getIconPosition();
	IconPos=comboiconpos->getCurrentItem();
	switch (IconPos)
	{
		case 0:	IconPos|=ICON_UNDER_TEXT; break;
		case 1:	IconPos|=ICON_AFTER_TEXT;
			IconPos&=~ICON_BEFORE_TEXT; break;
		case 2:	IconPos|=ICON_BEFORE_TEXT;
			IconPos&=~ICON_AFTER_TEXT; break;
		case 3:	IconPos|=ICON_ABOVE_TEXT;
			IconPos&=~ICON_BELOW_TEXT; break;
		case 4:	IconPos|=ICON_BELOW_TEXT;
			IconPos&=~ICON_ABOVE_TEXT; break;
	}
	sample->setIconPosition(IconPos);
	return 1;
}

long OptionDialog::onCmdFrame(FXObject*,FXSelector,void*)
{
	FXuint style=sample->getFrameStyle();
	style=comboframe->getCurrentItem();
	switch (style)
	{
		case 0:	style|=FRAME_NONE; break;
		case 1:	style|=FRAME_NONE; break;
		case 2:	style|=FRAME_RAISED; break;
		case 3:	style|=FRAME_THICK; break;
		case 4:	style|=FRAME_GROOVE; break;
		case 5:	style|=FRAME_RIDGE; break;
		case 6:	style|=FRAME_LINE; break;
	}
	sample->setFrameStyle(style);	
	return 1;
}

long OptionDialog::onCmdAlign(FXObject*,FXSelector,void*)
{
	FXuint style=sample->getJustify();
	style=comboalign->getCurrentItem();
	switch (style)
	{
		case 0:
			style&=~JUSTIFY_LEFT;
			style|=JUSTIFY_NORMAL;break;
		case 1:
			style&=~JUSTIFY_HZ_APART; break;
		case 2:
			style&=~JUSTIFY_HZ_APART;
			style|=JUSTIFY_LEFT;	break;
		case 3:
			style&=~JUSTIFY_HZ_APART;
			style|=JUSTIFY_RIGHT;  	break;
		case 4:
			style|=JUSTIFY_HZ_APART; break;
		case 5:
			style&=~JUSTIFY_VT_APART; break;
		case 6:
			style&=~JUSTIFY_VT_APART;
			style|=JUSTIFY_TOP;	break;
		case 7:
			style&=~JUSTIFY_VT_APART;
			style|=JUSTIFY_BOTTOM;break;
	}
	sample->setJustify(style);	
	return 1;
}

long OptionDialog::onCmdLayout(FXObject*,FXSelector,void*)
{
              FXuint style=sample->getLayoutHints();
	style=combolayout->getCurrentItem();
	switch (style)
	{
		case 0:	style|=LAYOUT_NORMAL; break;
		case 1:	style|=LAYOUT_SIDE_TOP; break;
		case 2:	style|=LAYOUT_SIDE_BOTTOM; break;
		case 3:	style|=LAYOUT_SIDE_LEFT; break;
		case 4:	style|=LAYOUT_SIDE_RIGHT; break;
		case 5:	style|=LAYOUT_FILL_COLUMN; break;
		case 6:	style|=LAYOUT_FILL_ROW; break;
		case 7:	style|=LAYOUT_LEFT; break;
		case 8:	style|=LAYOUT_RIGHT; break;
		case 9:	style|=LAYOUT_CENTER_X; break;
		case 10:	style|=LAYOUT_FIX_X; break;
		case 11:	style|=LAYOUT_TOP; break;
		case 12:	style|=LAYOUT_BOTTOM; break;
		case 13:	style|=LAYOUT_CENTER_Y; break;
		case 14:	style|=LAYOUT_FIX_Y; break;
		case 15:	style|=LAYOUT_FIX_WIDTH; break;
		case 16:	style|=LAYOUT_FIX_HEIGHT; break;
		case 17:	style|=LAYOUT_MIN_WIDTH; break;
		case 18:	style|=LAYOUT_MIN_HEIGHT; break;
		case 19:	style|=LAYOUT_FILL_X; break;
	}
	sample->setLayoutHints(style);	
	 return 1;
}

long OptionDialog::onCmdText(FXObject*,FXSelector,void*)
{
	sample->setText(txtLabel->getText());
	return 1;
}

long OptionDialog::onCmdName(FXObject*,FXSelector,void*)
{
	sample->show();
	return 1;
}

long OptionDialog::onCmdToolTip(FXObject*,FXSelector,void*)
{
	sample->setTipText(txtTooltip->getText());
	return 1;
}

long OptionDialog::onCmdTarget(FXObject*,FXSelector,void*)
{
	if (txtTarget->getText()=="") txtTarget->setText("NULL");
	return 1;
}

long OptionDialog::onCmdSelector(FXObject*,FXSelector,void*)
{
	if (txtSelector->getText()=="") txtSelector->setText("0");
	return 1;
}

long OptionDialog::onCmdIcon(FXObject*,FXSelector,void*)
{
	if ((txtIcon->getText())=="") txtIcon->setText("NULL");
	return 1;
}

long OptionDialog::onCmdWidth(FXObject*,FXSelector,void*)
{
   sample->setWidth(spinw->getValue());
   return 1;
}

long OptionDialog::onCmdHeight(FXObject*,FXSelector,void*)
{
	sample->setHeight(spinh->getValue());
	return 1;
}

long OptionDialog::onCmdPosX(FXObject*,FXSelector,void*)
{
	sample->setX(spinPosX->getValue());
	return 1;
}

long OptionDialog::onCmdPosY(FXObject*,FXSelector,void*)
{
	sample->setY(spinh->getValue());
	return 1;
}

long OptionDialog::onCmdDeclare(FXObject*,FXSelector,void*)
{
	return 1;
}

long OptionDialog::onCmdFontDeclare(FXObject*,FXSelector,void*)
{
	return 1;
}

long OptionDialog::onCmdColorDeclare(FXObject*,FXSelector,void*)
{
	return 1;
}

long OptionDialog::onCmdTextColor(FXObject*,FXSelector,void*)
{
	colordlg=new FXColorDialog(this," ",DECOR_BORDER|DECOR_TITLE);
	colordlg->FXDialogBox::execute();
	TextColor=colordlg->getRGBA();
	sample->setTextColor(TextColor);
	return 1;
}

long OptionDialog::onCmdBaseColor(FXObject*,FXSelector,void*)
{
	colordlg=new FXColorDialog(this," ",DECOR_BORDER|DECOR_TITLE);
	colordlg->FXDialogBox::execute();
	BaseColor=colordlg->getRGBA();
	sample->setBaseColor(BaseColor);
	return 1;
}

long OptionDialog::onCmdBorderColor(FXObject*,FXSelector,void*)
{
	colordlg=new FXColorDialog(this," ",DECOR_BORDER|DECOR_TITLE);
	colordlg->FXDialogBox::execute();
	BorderColor=colordlg->getRGBA();
	sample->setBorderColor(BorderColor);
	return 1;
}

long OptionDialog::onCmdHiliteColor(FXObject*,FXSelector,void*)
{
	colordlg=new FXColorDialog(this," ",DECOR_BORDER|DECOR_TITLE);
	colordlg->FXDialogBox::execute();
	HiliteColor=colordlg->getRGBA();
	sample->setHiliteColor(HiliteColor);
	return 1;
}

long OptionDialog::onCmdShadowColor(FXObject*,FXSelector,void*)
{
	colordlg=new FXColorDialog(this," ",DECOR_BORDER|DECOR_TITLE);
	colordlg->FXDialogBox::execute();
	ShadowColor=colordlg->getRGBA();
	sample->setShadowColor(ShadowColor);
	return 1;
}

long OptionDialog::onCmdBackColor(FXObject*,FXSelector,void*)
{	
	colordlg=new FXColorDialog(this," ",DECOR_BORDER|DECOR_TITLE);
	colordlg->FXDialogBox::execute();
	BackColor=colordlg->getRGBA();
	sample->setBackColor(BackColor);
	return 1;
}

long OptionDialog::onCmdFont(FXObject*,FXSelector,void*)
{
	fontdlg=new FXFontDialog (this,"Change Font",DECOR_BORDER|DECOR_TITLE);
	FXFontDesc fontdesc;
	fontdlg->FXDialogBox::execute();
	fontdlg->getFontSelection(fontdesc);
	delete buttonFont;
	buttonFont=new FXFont(getApp(),fontdesc);
	buttonFont->create();
	sample->setFont(buttonFont);
	return 1;
}

long OptionDialog::onCmdResults(FXObject*,FXSelector,void*)
{
              FXString Resultstxt;
              FXString strFont;
              FXString strItems;
	FXString* SumRes;
	FXString TipStr;
	FXString TotalB;
	
	FXString ObjName;
	FXString ObjOwner;
	FXString ObjText;
	FXString ObjCols;
	FXString ObjTarget, ObjSelector;
	FXString ObjTip;
	FXString ObjIcon;
	FXString ObjX;
	FXString ObjY;
	FXString ObjW;
	FXString ObjH;
              FXString ObjFont;
              FXString BackColorStr;
	FXString ShadowColorStr;
	FXString BorderColorStr;
	FXString BaseColorStr;
	FXString HiliteColorStr;
	FXString TextColorStr;
	FXString ObjOpts;

	DeclareStr="FXOption* ";
	newObjectStr="=new FXOption(";	
	ObjName=txtName->getText();
	ObjOwner=txtOwner->getText()+",";
	ObjText=ec+txtLabel->getText()+"\\t";
	ObjTip=txtTooltip->getText()+ec+",";
	ObjIcon=txtIcon->getText()+",";
	ObjOpts=comboiconpos->getText()+"|"+ObjOpts;
	ObjTarget=txtTarget->getText()+",";
	ObjSelector=txtSelector->getText()+",";
	ObjOpts=comboalign->getText()+"|"+combolayout->getText()+"|"+comboframe->getText()+",";
	ObjX=FXStringVal(spinPosX->getValue(),10)+",";
	ObjY=FXStringVal(spinPosY->getValue(),10)+",";
	ObjW=FXStringVal(spinw->getValue(),10)+",";
	ObjH=FXStringVal(spinh->getValue(),10);
	ObjFont="FXFont* "+ObjName+"Font=new FXFont(getApp(),"+ec+buttonFont->getName()+ec+","+
		FXStringVal(buttonFont->getSize()/10)+");\n"+ObjName+"->setFont("+ObjName+"Font);\n";

	if ((chkDeclare->getCheck())==TRUE) DeclareStr="";
	if ((chkFont->getCheck())==TRUE) ObjFont=ObjName+"->setFont(mainFont);\n";
	
	if ((chkColors->getCheck())==TRUE)
	{
	BackColorStr=ObjName+"->setBackColor(FXRGBA("+FXStringVal(FXREDVAL(BackColor))+","+
		FXStringVal(FXGREENVAL(BackColor))+","+FXStringVal(FXBLUEVAL(BackColor))+","+
		FXStringVal(FXALPHAVAL(BackColor))+"));\n";
	BaseColorStr=ObjName+"->setBaseColor(FXRGBA("+FXStringVal(FXREDVAL(BaseColor))+","+
		FXStringVal(FXGREENVAL(BaseColor))+","+FXStringVal(FXBLUEVAL(BaseColor))+","+
		FXStringVal(FXALPHAVAL(BaseColor))+"));\n";
	ShadowColorStr=ObjName+"->setShadowColor(FXRGBA("+FXStringVal(FXREDVAL(ShadowColor))+","+
		FXStringVal(FXGREENVAL(ShadowColor))+","+FXStringVal(FXBLUEVAL(ShadowColor))+","+
		FXStringVal(FXALPHAVAL(ShadowColor))+"));\n";
	BorderColorStr=ObjName+"->setBorderColor(FXRGBA("+FXStringVal(FXREDVAL(BorderColor))+","+
		FXStringVal(FXGREENVAL(BorderColor))+","+FXStringVal(FXBLUEVAL(BorderColor))+","+
		FXStringVal(FXALPHAVAL(BorderColor))+"));\n";
	HiliteColorStr=ObjName+"->setHiliteColor(FXRGBA("+FXStringVal(FXREDVAL(HiliteColor))+","+
		FXStringVal(FXGREENVAL(HiliteColor))+","+FXStringVal(FXBLUEVAL(HiliteColor))+","+
		FXStringVal(FXALPHAVAL(HiliteColor))+"));\n";
	TextColorStr=ObjName+"->setTextColor(FXRGBA("+FXStringVal(FXREDVAL(TextColor))+","+
		FXStringVal(FXGREENVAL(TextColor))+","+FXStringVal(FXBLUEVAL(TextColor))+","+
		FXStringVal(FXALPHAVAL(TextColor))+"));\n";
	}
	else
	{
		BackColorStr="";
		BaseColorStr="";
		ShadowColorStr="";
		BorderColorStr="";
		HiliteColorStr="";
		TextColorStr="";
	}
	
	TotalB=DeclareStr+ObjName+newObjectStr+ObjOwner+ObjText+ObjTip+ObjIcon+ObjTarget+ObjSelector+ObjOpts+ObjX+ObjY+ObjW+ObjH+");\n"+
		ObjFont+BackColorStr+ShadowColorStr+BorderColorStr+BaseColorStr+HiliteColorStr+TextColorStr;

	SumRes=&TotalB;
	editor->insertText(editor->getCursorPos(),SumRes->text(),SumRes->size()-1, FALSE);	
	sample->hide();
	return 1;
}
