/********************************************************************************
*                                                                               *
*                                 Create Popup                        *
*                                                                               *
*********************************************************************************
* Copyright (C) 2001 by Anastasios Sarris.   All Rights Reserved.             *
*********************************************************************************/
#include "/usr/local/include/fox/fx.h"
#include "PopupDialog.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "icons.h"
#include "vars.h"

// Map
FXDEFMAP(PopupDialog) PopupDialogMap[]={
  FXMAPFUNC(SEL_COMMAND,PopupDialog::ID_NAME,PopupDialog::onCmdName),
  FXMAPFUNC(SEL_COMMAND,PopupDialog::ID_WIDTH,PopupDialog::onCmdWidth),
  FXMAPFUNC(SEL_COMMAND,PopupDialog::ID_HEIGHT,PopupDialog::onCmdHeight),
  FXMAPFUNC(SEL_COMMAND,PopupDialog::ID_POSX,PopupDialog::onCmdPosX),
  FXMAPFUNC(SEL_COMMAND,PopupDialog::ID_POSY,PopupDialog::onCmdPosY),
  FXMAPFUNC(SEL_COMMAND,PopupDialog::ID_RESULTS,PopupDialog::onCmdResults),
  FXMAPFUNC(SEL_COMMAND,PopupDialog::ID_FRAME,PopupDialog::onCmdFrame),
  FXMAPFUNC(SEL_COMMAND,PopupDialog::ID_DECLARE,PopupDialog::onCmdDeclare),
  FXMAPFUNC(SEL_COMMAND,PopupDialog::ID_COLOR_DECLARE,PopupDialog::onCmdColorDeclare),
  FXMAPFUNC(SEL_COMMAND,PopupDialog::ID_BASE_COLOR,PopupDialog::onCmdBaseColor),
  FXMAPFUNC(SEL_COMMAND,PopupDialog::ID_BORDER_COLOR,PopupDialog::onCmdBorderColor),
  FXMAPFUNC(SEL_COMMAND,PopupDialog::ID_HILITE_COLOR,PopupDialog::onCmdHiliteColor),
  FXMAPFUNC(SEL_COMMAND,PopupDialog::ID_SHADOW_COLOR,PopupDialog::onCmdShadowColor),
  FXMAPFUNC(SEL_COMMAND,PopupDialog::ID_BACK_COLOR,PopupDialog::onCmdBackColor),
  FXMAPFUNC(SEL_COMMAND,PopupDialog::ID_DIRECTION,PopupDialog::onCmdDirection),
 };

// ButtonApp implementation
FXIMPLEMENT(PopupDialog,FXDialogBox,PopupDialogMap,ARRAYNUMBER(PopupDialogMap))

// Make some windows
PopupDialog::PopupDialog(FXWindow* owner):FXDialogBox(owner,"Button Creator",DECOR_TITLE|DECOR_BORDER,0)
{
    mainFont=new FXFont(getApp(),AppFont,10,FONTWEIGHT_NORMAL,FONTSLANT_REGULAR,FONTENCODING_GREEK);
  StrStyle="";
  buttons=new FXHorizontalFrame(this,LAYOUT_SIDE_BOTTOM|FRAME_NONE|LAYOUT_FILL_X|PACK_UNIFORM_WIDTH,0,0,0,0,40,40,20,20);
	FXMatrix* BasicControls=new FXMatrix(this,1,FRAME_NONE|MATRIX_BY_COLUMNS|LAYOUT_FILL_X);
 	FXToolbarShell* dragshell2=new FXToolbarShell(this,FRAME_RAISED|FRAME_THICK);
	mdiTools=new FXToolbar(BasicControls,dragshell2,LAYOUT_SIDE_TOP|LAYOUT_FILL_X);
	new FXToolbarGrip(mdiTools,this,ID_TOOLBARGRIP);
		// 
		btnBaseColor=new FXButton(mdiTools,"\tBase color",coloricon,this,ID_BASE_COLOR,ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,35,35);
		btnBaseColor->setFont(mainFont);
		btnBaseColor->setBaseColor(FXRGBA(255,100,0,255));
		
		// HIlite
		btnHiliteColor=new FXButton(mdiTools,"\tHilite color",coloricon,this,ID_HILITE_COLOR,ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,35,35);
		btnHiliteColor->setFont(mainFont);
		btnHiliteColor->setHiliteColor(FXRGBA(255,0,0,255));

		// 
		btnBorderColor=new FXButton(mdiTools,"\tBorder color",coloricon,this,ID_BORDER_COLOR,ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,35,35);
		btnBorderColor->setFont(mainFont);
		btnBorderColor->setBorderColor(FXRGBA(0,255,0,255));

		// 
		btnShadowColor=new FXButton(mdiTools,"\tShadow color",coloricon,this,ID_SHADOW_COLOR,ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,35,35);
		btnShadowColor->setFont(mainFont);
		btnShadowColor->setShadowColor(FXRGBA(255,0,0,255));

		// 
		btnBackColor=new FXButton(mdiTools,"\tBack color",coloricon,this,ID_BACK_COLOR,ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,35,35);
		btnBackColor->setFont(mainFont);
		btnBackColor->setBackColor(FXRGBA(255,0,0,255));

	FXMatrix* controls=new FXMatrix(BasicControls,2,FRAME_RIDGE|MATRIX_BY_COLUMNS|LAYOUT_FILL_X);		
             	
		//  
		FXLabel *lblName=new FXLabel(controls,"&Name:\tObject name",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
		lblName->setFont(mainFont);
		txtName=new FXTextField(controls,15,this,ID_NAME,LAYOUT_LEFT|FRAME_SUNKEN);
		txtName->setFont(mainFont);
		txtName->setText("pop");
	
		//
		FXLabel *lblOwner=new FXLabel(controls,"&Owner:\tObject Owner",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
		lblOwner->setFont(mainFont);
		txtOwner=new FXTextField(controls,15,this,ID_OWNER,LAYOUT_LEFT|FRAME_SUNKEN);
		txtOwner->setFont(mainFont);

		//Direction
		FXLabel *lblDirection=new FXLabel(controls,"&Direction:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
		lblDirection->setFont(mainFont);
		combodirection=new FXComboBox(controls,15,2,this,ID_DIRECTION,COMBOBOX_INSERT_LAST|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
		for(int i=0; i<2; i++){  combodirection->appendItem(strPopupDir[i]);         }
		combodirection->setCurrentItem(0);
		
		//
		FXLabel *lblframe=new FXLabel(controls,"&Frame Type:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
		lblframe->setFont(mainFont);
		comboframe=new FXComboBox(controls,15,7,this,ID_FRAME,FRAME_SUNKEN|FRAME_THICK|LAYOUT_FILL_X);
		for(int i=0; i<7; i++){  comboframe->appendItem(strframe[i]);         }
		comboframe->setCurrentItem(0);

		// 
		FXLabel* lblWidth=new FXLabel(controls,"&Width:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
		lblWidth->setFont(mainFont);
		spinw=new FXSpinner(controls,6,this,ID_WIDTH,SPIN_NORMAL|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
		spinw->setFont(mainFont);
		spinw->setRange(1,500);
				
		// 
		FXLabel *lblHeight=new FXLabel(controls,"&Height:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
		lblHeight->setFont(mainFont);
		spinh=new FXSpinner(controls,6,this,ID_HEIGHT,SPIN_NORMAL|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
		spinh->setFont(mainFont);
		spinh->setRange(1,400);
		
		// 
		FXLabel *lblPosX=new FXLabel(controls,"&X Pos:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
		lblPosX->setFont(mainFont);
		spinPosX=new FXSpinner(controls,6,this,ID_POSX,SPIN_NORMAL|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
		spinPosX->setFont(mainFont);
		spinPosX->setRange(1,1000);
	
		// 
		FXLabel *lblPosY=new FXLabel(controls,"& Pos:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
		lblPosY->setFont(mainFont);
		spinPosY=new FXSpinner(controls,6,this,ID_POSX,SPIN_NORMAL|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
		spinPosY->setFont(mainFont);
		spinPosY->setRange(1,1000);

		chkDeclare=new FXCheckButton(controls,"Declare in the class",this,ID_DECLARE,ICON_AFTER_TEXT|LAYOUT_NORMAL|FRAME_RAISED);
		chkDeclare->setFont(mainFont);
		chkColors=new FXCheckButton(controls,"Set Colors",this,ID_COLOR_DECLARE,ICON_AFTER_TEXT|LAYOUT_NORMAL|FRAME_RAISED);
		chkColors->setFont(mainFont);	

		// The sample
		sample=new FXPopup(mtxSamples,POPUP_VERTICAL|FRAME_RAISED|FRAME_THICK);
		new FXOption(sample,"1",NULL,NULL,0);
		new FXOption(sample,"2",NULL,NULL,0);
		mbtntest=new FXMenuButton(mtxSamples,"Test",NULL,sample,MENUBUTTON_ATTACH_BOTH|JUSTIFY_NORMAL);
		BaseColor=sample->getBaseColor();
		ShadowColor=sample->getShadowColor();
		HiliteColor=sample->getHiliteColor();
		BorderColor=sample->getBorderColor();
		BackColor=sample->getBackColor();
		spinw->setValue(sample->getWidth());
		spinh->setValue(sample->getHeight());
		mbtntest->hide();
		sample->hide();

 btnOK=new FXButton(buttons,"Create\tCreate commands and\ncopy them into code window",NULL,this,ID_RESULTS,ICON_ABOVE_TEXT|JUSTIFY_NORMAL|LAYOUT_BOTTOM|LAYOUT_RIGHT|FRAME_RAISED,50,55,52,52);
 btnCancel=new FXButton(buttons,"Close\tClose Dialog",NULL,this,FXDialogBox::ID_CANCEL,ICON_ABOVE_TEXT|JUSTIFY_NORMAL|LAYOUT_BOTTOM|LAYOUT_RIGHT|FRAME_RAISED,10,15,52,52);

}

PopupDialog::~PopupDialog(){}

long PopupDialog::onCmdDirection(FXObject*,FXSelector,void*)
{
	FXuint direction=sample->getOrientation();
	direction=combodirection->getCurrentItem();
	switch (direction)
	{
		case 0:	direction|=POPUP_VERTICAL; break;
		case 1:	direction|=POPUP_HORIZONTAL; break;
	}
	sample->setOrientation(direction);
	sample->update();
	return 1;
}

long PopupDialog::onCmdFrame(FXObject*,FXSelector,void*)
{
	FXuint style=sample->getFrameStyle();
	style=comboframe->getCurrentItem();
	switch (style)
	{
		case 0:	style|=FRAME_NONE;
			StrStyle="FRAME_NONE"; break;
		case 1:	style|=FRAME_SUNKEN;
			StrStyle="|FRAME_SUNKEN"; break;
		case 2:	style|=FRAME_RAISED;
			StrStyle="|FRAME_RAISED"; break;
		case 3:	style|=FRAME_THICK;
			StrStyle="|FRAME_THICK"; break;
		case 4:	style|=FRAME_GROOVE;
			StrStyle="|FRAME_GROOVE"; break;
		case 5:	style|=FRAME_RIDGE;
			StrStyle="|FRAME_RIDGE"; break;
		case 6:	style|=FRAME_LINE;
			StrStyle="|FRAME_LINE"; break;
	}
	sample->setFrameStyle(style);
	return 1;
}

long PopupDialog::onCmdName(FXObject*,FXSelector,void*)
{
	mbtntest->show();
	sample->show();
	return 1;
}

long PopupDialog::onCmdWidth(FXObject*,FXSelector,void*)
{
   sample->setWidth(spinw->getValue());
   sample->update();
   return 1;
}

long PopupDialog::onCmdHeight(FXObject*,FXSelector,void*)
{
	sample->setHeight(spinh->getValue());
	sample->update();
	return 1;
}

long PopupDialog::onCmdPosX(FXObject*,FXSelector,void*)
{
	sample->setX(spinPosX->getValue());
	return 1;
}

long PopupDialog::onCmdPosY(FXObject*,FXSelector,void*)
{
	sample->setY(spinh->getValue());
	return 1;
}

long PopupDialog::onCmdDeclare(FXObject*,FXSelector,void*)
{
	return 1;
}

long PopupDialog::onCmdColorDeclare(FXObject*,FXSelector,void*)
{
	return 1;
}

long PopupDialog::onCmdBaseColor(FXObject*,FXSelector,void*)
{
	colordlg=new FXColorDialog(this," ",DECOR_BORDER|DECOR_TITLE);
	colordlg->FXDialogBox::execute();
	BaseColor=colordlg->getRGBA();
	sample->setBaseColor(BaseColor);
	return 1;
}

long PopupDialog::onCmdBorderColor(FXObject*,FXSelector,void*)
{
	colordlg=new FXColorDialog(this," ",DECOR_BORDER|DECOR_TITLE);
	colordlg->FXDialogBox::execute();
	BorderColor=colordlg->getRGBA();
	sample->setBorderColor(BorderColor);
	return 1;
}

long PopupDialog::onCmdHiliteColor(FXObject*,FXSelector,void*)
{
	colordlg=new FXColorDialog(this," ",DECOR_BORDER|DECOR_TITLE);
	colordlg->FXDialogBox::execute();
	HiliteColor=colordlg->getRGBA();
	sample->setHiliteColor(HiliteColor);
	return 1;
}

long PopupDialog::onCmdShadowColor(FXObject*,FXSelector,void*)
{
	colordlg=new FXColorDialog(this," ",DECOR_BORDER|DECOR_TITLE);
	colordlg->FXDialogBox::execute();
	ShadowColor=colordlg->getRGBA();
	sample->setShadowColor(ShadowColor);
	return 1;
}

long PopupDialog::onCmdBackColor(FXObject*,FXSelector,void*)
{	
	colordlg=new FXColorDialog(this," ",DECOR_BORDER|DECOR_TITLE);
	colordlg->FXDialogBox::execute();
	BackColor=colordlg->getRGBA();
	sample->setBackColor(BackColor);
	return 1;
}

long PopupDialog::onCmdResults(FXObject*,FXSelector,void*)
{
              FXString Resultstxt;
              FXString strItems;
	FXString* SumRes;
	FXString TipStr;
	FXString TotalB;
	
	FXString ObjName;
	FXString ObjOwner;
	FXString ObjX;
	FXString ObjY;
	FXString ObjW;
	FXString ObjH;
              FXString BackColorStr;
	FXString ShadowColorStr;
	FXString BorderColorStr;
	FXString BaseColorStr;
	FXString HiliteColorStr;
	FXString ObjOpts;

	DeclareStr="FXPopup* ";
	newObjectStr="=new FXPopup(";	
	ObjName=txtName->getText();
	ObjOwner=txtOwner->getText()+",";
	ObjOpts=combodirection->getText()+StrStyle+",";
	ObjX=FXStringVal(spinPosX->getValue(),10)+",";
	ObjY=FXStringVal(spinPosY->getValue(),10)+",";
	ObjW=FXStringVal(spinw->getValue(),10)+",";
	ObjH=FXStringVal(spinh->getValue(),10);

	if ((chkDeclare->getCheck())==TRUE) DeclareStr="";
	if ((chkColors->getCheck())==TRUE)
	{
	BackColorStr=ObjName+"->setBackColor(FXRGBA("+FXStringVal(FXREDVAL(BackColor))+","+
		FXStringVal(FXGREENVAL(BackColor))+","+FXStringVal(FXBLUEVAL(BackColor))+","+
		FXStringVal(FXALPHAVAL(BackColor))+"));\n";
	BaseColorStr=ObjName+"->setBaseColor(FXRGBA("+FXStringVal(FXREDVAL(BaseColor))+","+
		FXStringVal(FXGREENVAL(BaseColor))+","+FXStringVal(FXBLUEVAL(BaseColor))+","+
		FXStringVal(FXALPHAVAL(BaseColor))+"));\n";
	ShadowColorStr=ObjName+"->setShadowColor(FXRGBA("+FXStringVal(FXREDVAL(ShadowColor))+","+
		FXStringVal(FXGREENVAL(ShadowColor))+","+FXStringVal(FXBLUEVAL(ShadowColor))+","+
		FXStringVal(FXALPHAVAL(ShadowColor))+"));\n";
	BorderColorStr=ObjName+"->setBorderColor(FXRGBA("+FXStringVal(FXREDVAL(BorderColor))+","+
		FXStringVal(FXGREENVAL(BorderColor))+","+FXStringVal(FXBLUEVAL(BorderColor))+","+
		FXStringVal(FXALPHAVAL(BorderColor))+"));\n";
	HiliteColorStr=ObjName+"->setHiliteColor(FXRGBA("+FXStringVal(FXREDVAL(HiliteColor))+","+
		FXStringVal(FXGREENVAL(HiliteColor))+","+FXStringVal(FXBLUEVAL(HiliteColor))+","+
		FXStringVal(FXALPHAVAL(HiliteColor))+"));\n";
	}
	else
	{
		BackColorStr="";
		BaseColorStr="";
		ShadowColorStr="";
		BorderColorStr="";
		HiliteColorStr="";
	}
	
	TotalB=DeclareStr+ObjName+newObjectStr+ObjOwner+ObjOpts+ObjX+ObjY+ObjW+ObjH+");\n"+
		BackColorStr+ShadowColorStr+BorderColorStr+BaseColorStr+HiliteColorStr;

	SumRes=&TotalB;
	editor->insertText(editor->getCursorPos(),SumRes->text(),SumRes->size()-1, FALSE);	
	mbtntest->hide();
	sample->hide();
	return 1;
}
