/********************************************************************************
*                                                                               *
*                                 Create Popup                        *
*                                                                               *
*********************************************************************************
* Copyright (C) 2001 by Anastasios Sarris.   All Rights Reserved.             *
*********************************************************************************/
#ifndef POPUPDIALOG_H
#define POPUPDIALOG_H

// Mini application object
class PopupDialog : public FXDialogBox
 {
  FXDECLARE(PopupDialog)
protected:
  FXPopup*	sample;        // Object being tested
  FXMenuButton*	mbtntest;
  FXToolbar*	mdiTools;
  FXHorizontalFrame*	buttons;
  FXColor	BaseColor;
  FXColor	ShadowColor;
  FXColor	BorderColor;
  FXColor	HiliteColor;
  FXColor	BackColor;
  FXString	buttonalign;
  FXFont*	myfont;
  FXFont*	mainFont;
  FXFontDialog*	fontdlg;
  FXFont*	toolFont;
  FXTextField*	txtLabel;
  FXColorDialog* colordlg;
  FXTextField*	txtOwner;
  FXTextField*	txtName;
  FXComboBox*	combodirection;
 FXButton* btnBaseColor;
 FXButton* btnShadowColor;
 FXButton* btnBorderColor;
 FXButton* btnHiliteColor;
 FXButton* btnBackColor;
 FXComboBox*	comboiconpos;
 FXComboBox*	comboalign;
 FXComboBox*	combolayout;
 FXComboBox*	comboframe;
  FXSpinner*	spinw;
  FXSpinner*	spinh;
  FXSpinner*	spinPosX;
  FXSpinner*	spinPosY;
  FXCheckButton*	chkDeclare;
  FXCheckButton*	chkToolStyle;
  FXCheckButton*	chkFont;
  FXCheckButton*	chkColors;
  FXString	StrStyle;
  FXButton*	btnOK;
  FXButton*	btnCancel;

private:
  PopupDialog(){}
public:
  enum {
    ID_TEXT=FXDialogBox::ID_LAST,
    ID_TOOLBARGRIP,
    ID_DIRECTION,
    ID_WIDTH,
    ID_HEIGHT,
    ID_POSX,
    ID_POSY,
    ID_OWNER,
    ID_NAME,
    ID_FRAME,
    ID_DECLARE,
    ID_RESULTS,
    ID_COLOR_DECLARE,
    ID_FONT_DECLARE,
    ID_BASE_COLOR,
    ID_HILITE_COLOR,
    ID_SHADOW_COLOR,
    ID_BORDER_COLOR,
    ID_BACK_COLOR
};

public:
  long onCmdName(FXObject*,FXSelector,void*);
  long onCmdWidth(FXObject*,FXSelector,void*);
  long onCmdHeight(FXObject*,FXSelector,void*);
  long onCmdPosX(FXObject*,FXSelector,void*);
  long onCmdPosY(FXObject*,FXSelector,void*);
  long onCmdResults(FXObject*,FXSelector,void*);
  long onCmdFrame(FXObject*,FXSelector,void*);
  long onCmdDeclare(FXObject*,FXSelector,void*);
  long onCmdColorDeclare(FXObject*,FXSelector,void*);
  long onCmdBaseColor(FXObject*,FXSelector,void*);
  long onCmdBorderColor(FXObject*,FXSelector,void*);
  long onCmdHiliteColor(FXObject*,FXSelector,void*);
  long onCmdShadowColor(FXObject*,FXSelector,void*);
  long onCmdBackColor(FXObject*,FXSelector,void*);
  long onCmdDirection(FXObject*,FXSelector,void*);

public:
  PopupDialog(FXWindow* owner);
  virtual ~PopupDialog();
  };
#endif
