/********************************************************************************
*                                                                               *
*                                 Create Scrollbar                        *
*                                                                               *
*********************************************************************************
* Copyright (C) 2001 by Anastasios Sarris.   All Rights Reserved.             *
*********************************************************************************/
#ifndef SCROLLBARDIALOG_H
#define SCROLLBARDIALOG_H

// Mini application object
class ScrollBarDialog : public FXDialogBox
 {
  FXDECLARE(ScrollBarDialog)
protected:
  FXScrollbar*	sample;        // Object being tested
  FXToolbar*	mdiTools;
  FXHorizontalFrame*	buttons;
  FXColor	SlotColor;
  FXString	buttonalign;
  FXFont*	buttonFont;
  FXFont*	mainFont;
  FXFont*	toolFont;
  FXColorDialog*	colordlg;
  FXTextField*	txtLabel;
  FXTextField*	txtTooltip;
  FXTextField*	txtOwner;
  FXTextField*	txtName;
  FXTextField*	txtTarget;
  FXTextField*	txtSelector;
  FXTextField*	txtIcon;
  FXTextField*	txtHelp;
  FXSpinner*	spinw;
  FXSpinner*	spinh;
  FXSpinner*	spinPosX;
  FXSpinner*	spinPosY;
  FXCheckButton*	chkDeclare;
  FXCheckButton*	chkToolStyle;
  FXCheckButton*	chkColors;
  FXColor	BaseColor;	FXColor	ShadowColor;
  FXColor	BorderColor;	FXColor	HiliteColor;
  FXColor	BackColor;	FXColor	TextColor;
  FXButton* btnBaseColor;	FXButton* btnShadowColor;
  FXButton* btnBorderColor;	FXButton* btnHiliteColor;
  FXButton* btnBackColor;	FXButton* btnTextColor;
  FXComboBox*	comboiconpos;	FXComboBox*	comboalign;
  FXComboBox*	combolayout;	FXComboBox*	comboframe;
  FXComboBox*	combostyle;	
  FXButton*	btnOK;		  FXButton*	btnCancel;

private:
  ScrollBarDialog(){}
public:
  enum {
    ID_OWNER=FXDialogBox::ID_LAST,
    ID_TOOLBARGRIP,
    ID_DIRECTION,
    ID_WIDTH,
    ID_HEIGHT,
    ID_POSX,
    ID_POSY,
    ID_NAME,
    ID_TOOLTIP,
    ID_TARGET,
    ID_SELECTOR,
    ID_DECLARE,
    ID_RESULTS,
    ID_COLOR_DECLARE,
    ID_HILITE_COLOR,
    ID_SHADOW_COLOR,
    ID_BORDER_COLOR,
    ID_BACK_COLOR
};

public:
  long onCmdName(FXObject*,FXSelector,void*);
  long onCmdWidth(FXObject*,FXSelector,void*);
  long onCmdHeight(FXObject*,FXSelector,void*);
  long onCmdPosX(FXObject*,FXSelector,void*);
  long onCmdPosY(FXObject*,FXSelector,void*);
  long onCmdFont(FXObject*,FXSelector,void*);
  long onCmdResults(FXObject*,FXSelector,void*);
  long onCmdTarget(FXObject*,FXSelector,void*);
  long onCmdSelector(FXObject*,FXSelector,void*);
  long onCmdDeclare(FXObject*,FXSelector,void*);
  long onCmdColorDeclare(FXObject*,FXSelector,void*);
  long onCmdBorderColor(FXObject*,FXSelector,void*);
  long onCmdHiliteColor(FXObject*,FXSelector,void*);
  long onCmdShadowColor(FXObject*,FXSelector,void*);
  long onCmdBackColor(FXObject*,FXSelector,void*);
  long onCmdDirection(FXObject*,FXSelector,void*);

public:
  ScrollBarDialog(FXWindow* owner);
  virtual ~ScrollBarDialog();
  };

#endif
