/********************************************************************************
*                                                                               *
*                                 List  Creator                        *
*                                                                               *
*********************************************************************************
* Copyright (C) 2001 by Sarris Anastasios.   All Rights Reserved.             *
*********************************************************************************/
#include "/usr/local/include/fox/fx.h"
#include "SearchDialog.h"
#include "icons.h"
#include "vars.h"

// Map
FXDEFMAP(SearchDialog) SearchDialogMap[]={
  FXMAPFUNC(SEL_COMMAND,SearchDialog::ID_NAME,SearchDialog::onCmdName),
  FXMAPFUNC(SEL_COMMAND,SearchDialog::ID_ICON,SearchDialog::onCmdIcon),
  FXMAPFUNC(SEL_COMMAND,SearchDialog::ID_RESULTS,SearchDialog::onCmdResults),
  FXMAPFUNC(SEL_COMMAND,SearchDialog::ID_OWNER,SearchDialog::onCmdOwner),
  FXMAPFUNC(SEL_COMMAND,SearchDialog::ID_CAPTION,SearchDialog::onCmdCaption),
  FXMAPFUNC(SEL_COMMAND,SearchDialog::ID_DECLARE,SearchDialog::onCmdDeclare),
  FXMAPFUNC(SEL_COMMAND,SearchDialog::ID_WIDTH,SearchDialog::onCmdWidth),
  FXMAPFUNC(SEL_COMMAND,SearchDialog::ID_HEIGHT,SearchDialog::onCmdHeight),
  FXMAPFUNC(SEL_COMMAND,SearchDialog::ID_POSX,SearchDialog::onCmdPosX),
  FXMAPFUNC(SEL_COMMAND,SearchDialog::ID_POSY,SearchDialog::onCmdPosY),
  FXMAPFUNC(SEL_COMMAND,SearchDialog::ID_CREATE,SearchDialog::onCmdCreate),
 };


// ButtonApp implementation
FXIMPLEMENT(SearchDialog,FXDialogBox,SearchDialogMap,ARRAYNUMBER(SearchDialogMap))

// Make some windows
SearchDialog::SearchDialog(FXWindow* owner):FXDialogBox(owner,"List Creator",DECOR_TITLE|DECOR_BORDER,0)
{
    mainFont=new FXFont(getApp(),AppFont,10,FONTWEIGHT_NORMAL,FONTSLANT_REGULAR,FONTENCODING_GREEK);
  buttons=new FXHorizontalFrame(this,LAYOUT_SIDE_BOTTOM|FRAME_NONE|LAYOUT_FILL_X|PACK_UNIFORM_WIDTH,0,0,0,0,40,40,20,20);
		FXMatrix* controls=new FXMatrix(this,2,FRAME_RIDGE|MATRIX_BY_COLUMNS|LAYOUT_FILL_X);
		
		//  
		FXLabel *lblName=new FXLabel(controls,"&Name:\tObject name",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
		lblName->setFont(mainFont);
		txtName=new FXTextField(controls,15,this,ID_NAME,LAYOUT_LEFT|FRAME_SUNKEN);
		txtName->setFont(mainFont);
		txtName->setText("srch");
	
		//
		FXLabel *lblOwner=new FXLabel(controls,"&Owner:\tObject Owner",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
		lblOwner->setFont(mainFont);
		txtOwner=new FXTextField(controls,15,this,ID_OWNER,LAYOUT_LEFT|FRAME_SUNKEN);
		txtOwner->setFont(mainFont);
		
		//Caption
		FXLabel *lblCaption=new FXLabel(controls,"&Caption:",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
		lblCaption->setFont(mainFont);
		txtCaption=new FXTextField(controls,15,this,ID_CAPTION,LAYOUT_LEFT|FRAME_SUNKEN);
		txtCaption->setFont(mainFont);

		 //Option Icon
		 FXLabel* lblIcon=new FXLabel(controls,"Icon:",NULL,ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_NONE,50,55,52,52);
		 lblIcon->setFont(mainFont);
		 txtIcon=new FXTextField(controls,20,this,ID_ICON,JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED);
		 txtIcon->setFont(mainFont);
		 			
		//
		FXLabel* lblWidth=new FXLabel(controls,"&Width:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
		lblWidth->setFont(mainFont);
		spinw=new FXSpinner(controls,6,this,ID_WIDTH,SPIN_NORMAL|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
		spinw->setFont(mainFont);
		spinw->setRange(1,2000);
		spinw->setValue(400);

		//
		FXLabel *lblHeight=new FXLabel(controls,"&Height:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
		lblHeight->setFont(mainFont);
		spinh=new FXSpinner(controls,6,this,ID_HEIGHT,SPIN_NORMAL|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
		spinh->setFont(mainFont);
		spinh->setRange(1,2000);
		spinh->setValue(150);

		// 
		FXLabel *lblPosX=new FXLabel(controls,"&X Pos:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
		lblPosX->setFont(mainFont);
		spinPosX=new FXSpinner(controls,6,this,ID_POSX,SPIN_NORMAL|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
		spinPosX->setFont(mainFont);
		spinPosX->setRange(1,1000);
	
		// 
		FXLabel *lblPosY=new FXLabel(controls,"& Pos:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
		lblPosY->setFont(mainFont);
		spinPosY=new FXSpinner(controls,6,this,ID_POSX,SPIN_NORMAL|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
		spinPosY->setFont(mainFont);
		spinPosY->setRange(1,1000);

                            chkDeclare=new FXCheckButton(controls,"Declare in the class",this,ID_DECLARE,ICON_AFTER_TEXT|LAYOUT_NORMAL|FRAME_RAISED);
		chkDeclare->setFont(mainFont);
	
  sample=new FXSearchDialog(this,"Test",NULL,0,0,150,40);
  sample->setWidth(spinw->getValue());
  sample->setHeight(spinh->getValue());
  btnCreate=new FXButton(buttons,"Show\tShow the dialog",NULL,this,ID_CREATE,JUSTIFY_NORMAL|FRAME_RAISED);
  btnOK=new FXButton(buttons,"Create\tCreate commands and\ncopy them into code window",NULL,this,ID_RESULTS,ICON_ABOVE_TEXT|JUSTIFY_NORMAL|LAYOUT_BOTTOM|LAYOUT_RIGHT|FRAME_RAISED,50,55,52,52);
  btnCancel=new FXButton(buttons,"Close\tClose Dialog",NULL,this,FXDialogBox::ID_CANCEL,ICON_ABOVE_TEXT|JUSTIFY_NORMAL|LAYOUT_BOTTOM|LAYOUT_RIGHT|FRAME_RAISED,10,15,52,52);
}

SearchDialog::~SearchDialog(){}

long SearchDialog::onCmdIcon(FXObject*,FXSelector,void*)
{
	return 1;
}

long SearchDialog::onCmdName(FXObject*,FXSelector,void*)
{
	  return 1;
}

long SearchDialog::onCmdCreate(FXObject*,FXSelector,void*)
{
	sample->show();
	//FXDialogBox::execute();      modal
	spinw->setValue(sample->getWidth());
	spinh->setValue(sample->getHeight());
	spinw->update();
	spinh->update();
	return 1;
}

long SearchDialog::onCmdOwner(FXObject*,FXSelector,void*)
{
	  return 1;
}

long SearchDialog::onCmdCaption(FXObject*,FXSelector,void*)
{
	return 1;
}

long SearchDialog::onCmdWidth(FXObject*,FXSelector,void*)
{
   sample->setWidth(spinw->getValue());
   sample->update();
   return 1;
}

long SearchDialog::onCmdHeight(FXObject*,FXSelector,void*)
{
	sample->setHeight(spinh->getValue());
	sample->update();
	return 1;
}

long SearchDialog::onCmdPosX(FXObject*,FXSelector,void*)
{
	sample->setX(spinPosX->getValue());
	return 1;
}

long SearchDialog::onCmdPosY(FXObject*,FXSelector,void*)
{
	sample->setY(spinh->getValue());
	return 1;
}

long SearchDialog::onCmdResults(FXObject*,FXSelector,void*)
{
	FXString Resultstxt;
	FXString*	SumRes;
	FXString TotalLB;
	FXString ObjName;
	FXString ObjOwner;
	FXString ObjText;
	FXString ObjIcon;
	FXString ObjCaption;
	FXString ObjTip;
	FXString ObjX;
	FXString ObjY;
	FXString ObjW;
	FXString ObjH;
  	
  	DeclareStr="FXSearchDialog* ";
	newObjectStr="=new FXSearchDialog(";	
	ObjName=txtName->getText();
	ObjOwner=txtOwner->getText()+",";
              ObjCaption=ec+txtCaption->getText()+ec+",";
              ObjIcon=txtIcon->getText()+",";
              if (ObjIcon==",") ObjIcon="NULL,";
	ObjX=FXStringVal(spinPosX->getValue(),10)+",";
	ObjY=FXStringVal(spinPosY->getValue(),10)+",";
	ObjW=FXStringVal(spinw->getValue(),10)+",";
	ObjH=FXStringVal(spinh->getValue(),10);
	if ((chkDeclare->getCheck())==TRUE) DeclareStr="";

	TotalLB=DeclareStr+ObjName+newObjectStr+ObjOwner+ObjCaption+ObjIcon+ObjX+ObjY+ObjW+ObjH+");\n";

             	SumRes=&TotalLB;
	editor->insertText(editor->getCursorPos(),SumRes->text(),SumRes->size()-1, FALSE);
	return 1;
}

long SearchDialog::onCmdDeclare(FXObject*,FXSelector,void*)
{
	return 1;
}
