/********************************************************************************
*                                                                               *
*                                 Create Dial                        *
*                                                                               *
*********************************************************************************
* Copyright (C) 2001 by Anastasios Sarris.   All Rights Reserved.             *
*********************************************************************************/
#include "/usr/local/include/fox/fx.h"
#include "SliderDialog.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "icons.h"
#include "vars.h"

// Map
FXDEFMAP(SliderDialog) SliderDialogMap[]={
  FXMAPFUNC(SEL_COMMAND,SliderDialog::ID_NAME,SliderDialog::onCmdName),
  FXMAPFUNC(SEL_COMMAND,SliderDialog::ID_WIDTH,SliderDialog::onCmdWidth),
  FXMAPFUNC(SEL_COMMAND,SliderDialog::ID_HEIGHT,SliderDialog::onCmdHeight),
  FXMAPFUNC(SEL_COMMAND,SliderDialog::ID_POSX,SliderDialog::onCmdPosX),
  FXMAPFUNC(SEL_COMMAND,SliderDialog::ID_POSY,SliderDialog::onCmdPosY),
  FXMAPFUNC(SEL_COMMAND,SliderDialog::ID_RESULTS,SliderDialog::onCmdResults),
  FXMAPFUNC(SEL_COMMAND,SliderDialog::ID_TOOLTIP,SliderDialog::onCmdToolTip),
  FXMAPFUNC(SEL_COMMAND,SliderDialog::ID_LAYOUT,SliderDialog::onCmdLayout),
  FXMAPFUNC(SEL_COMMAND,SliderDialog::ID_TARGET,SliderDialog::onCmdTarget),
  FXMAPFUNC(SEL_COMMAND,SliderDialog::ID_SELECTOR,SliderDialog::onCmdSelector),
  FXMAPFUNC(SEL_COMMAND,SliderDialog::ID_FRAME,SliderDialog::onCmdFrame),
  FXMAPFUNC(SEL_COMMAND,SliderDialog::ID_DECLARE,SliderDialog::onCmdDeclare),
  FXMAPFUNC(SEL_COMMAND,SliderDialog::ID_COLOR_DECLARE,SliderDialog::onCmdColorDeclare),
  FXMAPFUNC(SEL_COMMAND,SliderDialog::ID_BASE_COLOR,SliderDialog::onCmdBaseColor),
  FXMAPFUNC(SEL_COMMAND,SliderDialog::ID_BORDER_COLOR,SliderDialog::onCmdBorderColor),
  FXMAPFUNC(SEL_COMMAND,SliderDialog::ID_HILITE_COLOR,SliderDialog::onCmdHiliteColor),
  FXMAPFUNC(SEL_COMMAND,SliderDialog::ID_SHADOW_COLOR,SliderDialog::onCmdShadowColor),
  FXMAPFUNC(SEL_COMMAND,SliderDialog::ID_BACK_COLOR,SliderDialog::onCmdBackColor),
  FXMAPFUNC(SEL_COMMAND,SliderDialog::ID_SLOT_COLOR,SliderDialog::onCmdSlotColor),
  FXMAPFUNC(SEL_COMMAND,SliderDialog::ID_SLOT_SIZE,SliderDialog::onCmdSlotSize),
  FXMAPFUNC(SEL_COMMAND,SliderDialog::ID_HEAD_SIZE,SliderDialog::onCmdHeadSize),
  FXMAPFUNC(SEL_COMMAND,SliderDialog::ID_INC,SliderDialog::onCmdInc),
  FXMAPFUNC(SEL_COMMAND,SliderDialog::ID_HELP,SliderDialog::onCmdHelp),
  FXMAPFUNC(SEL_COMMAND,SliderDialog::ID_DIRECTION,SliderDialog::onCmdDirection),
 };

// ButtonApp implementation
FXIMPLEMENT(SliderDialog,FXDialogBox,SliderDialogMap,ARRAYNUMBER(SliderDialogMap))

// Make some windows
SliderDialog::SliderDialog(FXWindow* owner):FXDialogBox(owner,"Button Creator",DECOR_TITLE|DECOR_BORDER,0)
{
    mainFont=new FXFont(getApp(),AppFont,10,FONTWEIGHT_NORMAL,FONTSLANT_REGULAR,FONTENCODING_GREEK);
  buttons=new FXHorizontalFrame(this,LAYOUT_SIDE_BOTTOM|FRAME_NONE|LAYOUT_FILL_X|PACK_UNIFORM_WIDTH,0,0,0,0,40,40,20,20);
	FXMatrix* BasicControls=new FXMatrix(this,1,FRAME_NONE|MATRIX_BY_COLUMNS|LAYOUT_FILL_X);
 	FXToolbarShell* dragshell2=new FXToolbarShell(this,FRAME_RAISED|FRAME_THICK);
             	mdiTools=new FXToolbar(BasicControls,dragshell2,LAYOUT_SIDE_TOP|LAYOUT_FILL_X);
         	new FXToolbarGrip(mdiTools,this,ID_TOOLBARGRIP);
         	
		//Slot color
		btnSlotColor=new FXButton(mdiTools,"\tSlot color",coloricon,this,ID_SLOT_COLOR,ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,35,35);
		btnSlotColor->setFont(mainFont);
		btnSlotColor->setBaseColor(FXRGBA(255,100,0,255));

              	// 
		btnBaseColor=new FXButton(mdiTools,"\tBase color",coloricon,this,ID_BASE_COLOR,ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,35,35);
		btnBaseColor->setFont(mainFont);
		btnBaseColor->setBaseColor(FXRGBA(255,100,0,255));
		
		// HIlite
		btnHiliteColor=new FXButton(mdiTools,"\tHilite color",coloricon,this,ID_HILITE_COLOR,ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,35,35);
		btnHiliteColor->setFont(mainFont);
		btnHiliteColor->setHiliteColor(FXRGBA(255,0,0,255));

		// 
		btnBorderColor=new FXButton(mdiTools,"\tBorder color",coloricon,this,ID_BORDER_COLOR,ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,35,35);
		btnBorderColor->setFont(mainFont);
		btnBorderColor->setBorderColor(FXRGBA(0,255,0,255));

		// 
		btnShadowColor=new FXButton(mdiTools,"\tShadow color",coloricon,this,ID_SHADOW_COLOR,ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,35,35);
		btnShadowColor->setFont(mainFont);
		btnShadowColor->setShadowColor(FXRGBA(255,0,0,255));

		// 
		btnBackColor=new FXButton(mdiTools,"\tBack color",coloricon,this,ID_BACK_COLOR,ICON_UNDER_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,35,35);
		btnBackColor->setFont(mainFont);
		btnBackColor->setBackColor(FXRGBA(255,0,0,255));

	FXMatrix* controls=new FXMatrix(BasicControls,2,FRAME_RIDGE|MATRIX_BY_COLUMNS|LAYOUT_FILL_X);		
             	
		//  
		FXLabel *lblName=new FXLabel(controls,"&Name:\tObject name",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
		lblName->setFont(mainFont);
		txtName=new FXTextField(controls,15,this,ID_NAME,LAYOUT_LEFT|FRAME_SUNKEN);
		txtName->setFont(mainFont);
		txtName->setText("dial");
	
		//
		FXLabel *lblOwner=new FXLabel(controls,"&Owner:\tObject Owner",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
		lblOwner->setFont(mainFont);
		txtOwner=new FXTextField(controls,15,this,ID_OWNER,LAYOUT_LEFT|FRAME_SUNKEN);
		txtOwner->setFont(mainFont);

		// 
		FXLabel *lblTooltip=new FXLabel(controls,"&Tool Tip:\tTip when the mouse is over",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
		lblTooltip->setFont(mainFont);
		txtTooltip=new FXTextField(controls,15,this,ID_TOOLTIP,LAYOUT_LEFT|FRAME_SUNKEN);
		txtTooltip->setFont(mainFont);

		//Help
		FXLabel *lblHelp=new FXLabel(controls,"&Help:",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
		lblHelp->setFont(mainFont);
		txtHelp=new FXTextField(controls,15,this,ID_HELP,LAYOUT_LEFT|FRAME_SUNKEN);
		txtHelp->setFont(mainFont);
			
		//
		FXLabel *lblTarget=new FXLabel(controls,"&Target,ID:\tTarget,ID",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
		lblTarget->setFont(mainFont);
		txtTarget=new FXTextField(controls,15,this,ID_TARGET,LAYOUT_LEFT|FRAME_SUNKEN);
		txtTarget->setFont(mainFont);
	
		//Selector
		FXLabel *lblSelector=new FXLabel(controls,"&ID:",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
		lblSelector->setFont(mainFont);
		txtSelector=new FXTextField(controls,15,this,ID_SELECTOR,LAYOUT_LEFT|FRAME_SUNKEN);
		txtSelector->setFont(mainFont);

		//Direction
		FXLabel *lblDir=new FXLabel(controls,"&Direction:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
		lblDir->setFont(mainFont);
		combostyle=new FXComboBox(controls,15,6,this,ID_DIRECTION,COMBOBOX_INSERT_LAST|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
		for(int i=0; i<6; i++){  combostyle->appendItem(strSliderStyle[i]);         }
		combostyle->setCurrentItem(0);
		
		//  
		FXLabel *lbllayout=new FXLabel(controls,"&Layout:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
		lbllayout->setFont(mainFont);
		combolayout=new FXComboBox(controls,15,5,this,ID_LAYOUT,COMBOBOX_INSERT_LAST|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
		for(int i=0; i<20; i++){  combolayout->appendItem(strlayout[i]);         }
		combolayout->setCurrentItem(0);

		//
		FXLabel *lblframe=new FXLabel(controls,"&Frame Type:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
		lblframe->setFont(mainFont);
		comboframe=new FXComboBox(controls,15,5,this,ID_FRAME,COMBOBOX_INSERT_LAST|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
		for(int i=0; i<7; i++){  comboframe->appendItem(strframe[i]);         }
		comboframe->setCurrentItem(0);

		//Slot Size
		FXLabel* lblSize=new FXLabel(controls,"&Slot Size:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
		lblSize->setFont(mainFont);
		spinSlotSize=new FXSpinner(controls,6,this,ID_SLOT_SIZE,SPIN_NORMAL|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
		spinSlotSize->setFont(mainFont);
		spinSlotSize->setRange(1,3600);
		
		//Head Size
		FXLabel* lblHSize=new FXLabel(controls,"&Head Size:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
		lblHSize->setFont(mainFont);
		spinHeadSize=new FXSpinner(controls,6,this,ID_HEAD_SIZE,SPIN_NORMAL|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
		spinHeadSize->setFont(mainFont);
		spinHeadSize->setRange(1,3600);
		
		//Inc
		FXLabel* lblRev=new FXLabel(controls,"&Increment:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
		lblRev->setFont(mainFont);
		spinRevInc=new FXSpinner(controls,6,this,ID_INC,SPIN_NORMAL|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
		spinRevInc->setFont(mainFont);
		spinRevInc->setRange(1,3600);

		// 
		FXLabel* lblWidth=new FXLabel(controls,"&Width:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
		lblWidth->setFont(mainFont);
		spinw=new FXSpinner(controls,6,this,ID_WIDTH,SPIN_NORMAL|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
		spinw->setFont(mainFont);
		spinw->setRange(1,500);
				
		// 
		FXLabel *lblHeight=new FXLabel(controls,"&Height:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
		lblHeight->setFont(mainFont);
		spinh=new FXSpinner(controls,6,this,ID_HEIGHT,SPIN_NORMAL|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
		spinh->setFont(mainFont);
		spinh->setRange(1,400);
		
		// 
		FXLabel *lblPosX=new FXLabel(controls,"&X Pos:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
		lblPosX->setFont(mainFont);
		spinPosX=new FXSpinner(controls,6,this,ID_POSX,SPIN_NORMAL|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
		spinPosX->setFont(mainFont);
		spinPosX->setRange(1,1000);
	
		// 
		FXLabel *lblPosY=new FXLabel(controls,"& Pos:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
		lblPosY->setFont(mainFont);
		spinPosY=new FXSpinner(controls,6,this,ID_POSX,SPIN_NORMAL|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
		spinPosY->setFont(mainFont);
		spinPosY->setRange(1,1000);

                            chkDeclare=new FXCheckButton(controls,"Declare in the class",this,ID_DECLARE,ICON_AFTER_TEXT|LAYOUT_NORMAL|FRAME_RAISED);
		chkDeclare->setFont(mainFont);
		chkColors=new FXCheckButton(controls,"Set Colors",this,ID_COLOR_DECLARE,ICON_AFTER_TEXT|LAYOUT_NORMAL|FRAME_RAISED);
		chkColors->setFont(mainFont);	

		  // The sample
		sample=new FXSlider(mtxSamples,
		NULL,0,
		DIAL_HORIZONTAL|FRAME_RAISED|FRAME_THICK|LAYOUT_CENTER_X|LAYOUT_CENTER_Y|LAYOUT_FIX_WIDTH|LAYOUT_FIX_HEIGHT,
		50,55,100,50);
		BaseColor=sample->getBaseColor();
		ShadowColor=sample->getShadowColor();
		HiliteColor=sample->getHiliteColor();
		BorderColor=sample->getBorderColor();
		BackColor=sample->getBackColor();
		SlotColor=sample->getSlotColor();
		spinw->setValue(sample->getWidth());
		spinh->setValue(sample->getHeight());
		spinPosX->setValue(sample->getX());
		spinPosY->setValue(sample->getY());
		spinHeadSize->setValue(sample->getHeadSize());
		spinRevInc->setValue(sample->getIncrement());
		spinSlotSize->setValue(sample->getSlotSize());
		sample->hide();

  btnOK=new FXButton(buttons,"Create\tCreate commands and\ncopy them into code window",NULL,this,ID_RESULTS,ICON_ABOVE_TEXT|JUSTIFY_NORMAL|LAYOUT_BOTTOM|LAYOUT_RIGHT|FRAME_RAISED,50,55,52,52);
  btnCancel=new FXButton(buttons,"Close\tClose Dialog",NULL,this,FXDialogBox::ID_CANCEL,ICON_ABOVE_TEXT|JUSTIFY_NORMAL|LAYOUT_BOTTOM|LAYOUT_RIGHT|FRAME_RAISED,10,15,52,52);

}

SliderDialog::~SliderDialog(){}

long SliderDialog::onCmdFrame(FXObject*,FXSelector,void*)
{
	FXuint style=sample->getFrameStyle();
	style=comboframe->getCurrentItem();
	switch (style)
	{
		case 0:	style|=FRAME_NONE; break;
		case 1:	style|=FRAME_NONE; break;
		case 2:	style|=FRAME_RAISED; break;
		case 3:	style|=FRAME_THICK; break;
		case 4:	style|=FRAME_GROOVE; break;
		case 5:	style|=FRAME_RIDGE; break;
		case 6:	style|=FRAME_LINE; break;
	}
	sample->setFrameStyle(style);	
	return 1;
}

long SliderDialog::onCmdDirection(FXObject*,FXSelector,void*)
{
	FXuint style=sample->getSliderStyle();
	style=combostyle->getCurrentItem();
	switch (style)
	{
		case 0:	style|=SLIDER_HORIZONTAL; break;
		case 1:	style|=SLIDER_VERTICAL;
		case 2:	style|=SLIDER_HORIZONTAL|SLIDER_ARROW_UP; break;
		case 3:	style|=SLIDER_HORIZONTAL|SLIDER_ARROW_DOWN; break;
		case 4:	style|=SLIDER_VERTICAL|SLIDER_ARROW_LEFT; break;
		case 5:	style|=SLIDER_VERTICAL|SLIDER_ARROW_RIGHT; break;
	}
	sample->setSliderStyle(style);
	sample->update();
	return 1;
}

long SliderDialog::onCmdLayout(FXObject*,FXSelector,void*)
{
              FXuint style=sample->getLayoutHints();
	style=combolayout->getCurrentItem();
	switch (style)
	{
		case 0:	style|=LAYOUT_NORMAL; break;
		case 1:	style|=LAYOUT_SIDE_TOP; break;
		case 2:	style|=LAYOUT_SIDE_BOTTOM; break;
		case 3:	style|=LAYOUT_SIDE_LEFT; break;
		case 4:	style|=LAYOUT_SIDE_RIGHT; break;
		case 5:	style|=LAYOUT_FILL_COLUMN; break;
		case 6:	style|=LAYOUT_FILL_ROW; break;
		case 7:	style|=LAYOUT_LEFT; break;
		case 8:	style|=LAYOUT_RIGHT; break;
		case 9:	style|=LAYOUT_CENTER_X; break;
		case 10:	style|=LAYOUT_FIX_X; break;
		case 11:	style|=LAYOUT_TOP; break;
		case 12:	style|=LAYOUT_BOTTOM; break;
		case 13:	style|=LAYOUT_CENTER_Y; break;
		case 14:	style|=LAYOUT_FIX_Y; break;
		case 15:	style|=LAYOUT_FIX_WIDTH; break;
		case 16:	style|=LAYOUT_FIX_HEIGHT; break;
		case 17:	style|=LAYOUT_MIN_WIDTH; break;
		case 18:	style|=LAYOUT_MIN_HEIGHT; break;
		case 19:	style|=LAYOUT_FILL_X; break;
	}
	sample->setLayoutHints(style);	
	 return 1;
}

long SliderDialog::onCmdToolTip(FXObject*,FXSelector,void*)
{
	sample->setTipText(txtTooltip->getText());
	return 1;
}

long SliderDialog::onCmdHelp(FXObject*,FXSelector,void*)
{
	sample->setHelpText(txtHelp->getText());
	return 1;
}

long SliderDialog::onCmdName(FXObject*,FXSelector,void*)
{
	sample->show();
	return 1;
}

long SliderDialog::onCmdTarget(FXObject*,FXSelector,void*)
{
	if (txtTarget->getText()=="") txtTarget->setText("NULL");
	return 1;
}

long SliderDialog::onCmdSelector(FXObject*,FXSelector,void*)
{
	if (txtSelector->getText()=="") txtSelector->setText("0");
	return 1;
}

long SliderDialog::onCmdWidth(FXObject*,FXSelector,void*)
{
   sample->setWidth(spinw->getValue());
   sample->update();
   return 1;
}

long SliderDialog::onCmdSlotSize(FXObject*,FXSelector,void*)
{
   sample->setSlotSize(spinSlotSize->getValue());
   return 1;
}

long SliderDialog::onCmdInc(FXObject*,FXSelector,void*)
{
   sample->setIncrement(spinRevInc->getValue());
   return 1;
}

long SliderDialog::onCmdHeadSize(FXObject*,FXSelector,void*)
{
   sample->setHeadSize(spinHeadSize->getValue());
   return 1;
}

long SliderDialog::onCmdHeight(FXObject*,FXSelector,void*)
{
	sample->setHeight(spinh->getValue());
	return 1;
}

long SliderDialog::onCmdPosX(FXObject*,FXSelector,void*)
{
	sample->setX(spinPosX->getValue());
	return 1;
}

long SliderDialog::onCmdPosY(FXObject*,FXSelector,void*)
{
	sample->setY(spinh->getValue());
	return 1;
}

long SliderDialog::onCmdDeclare(FXObject*,FXSelector,void*)
{
	return 1;
}

long SliderDialog::onCmdColorDeclare(FXObject*,FXSelector,void*)
{
	return 1;
}

long SliderDialog::onCmdBaseColor(FXObject*,FXSelector,void*)
{
	colordlg=new FXColorDialog(this,"Select Color",DECOR_BORDER|DECOR_TITLE);
	colordlg->FXDialogBox::execute();
	BaseColor=colordlg->getRGBA();
	sample->setBaseColor(BaseColor);
	return 1;
}

long SliderDialog::onCmdSlotColor(FXObject*,FXSelector,void*)
{
	colordlg=new FXColorDialog(this,"Slot Color",DECOR_BORDER|DECOR_TITLE);
	colordlg->FXDialogBox::execute();
	SlotColor=colordlg->getRGBA();
	sample->setSlotColor(SlotColor);
	sample->update();
	return 1;
}

long SliderDialog::onCmdBorderColor(FXObject*,FXSelector,void*)
{
	colordlg=new FXColorDialog(this,"Select Color",DECOR_BORDER|DECOR_TITLE);
	colordlg->FXDialogBox::execute();
	BorderColor=colordlg->getRGBA();
	sample->setBorderColor(BorderColor);
	return 1;
}

long SliderDialog::onCmdHiliteColor(FXObject*,FXSelector,void*)
{
	colordlg=new FXColorDialog(this,"Select Color",DECOR_BORDER|DECOR_TITLE);
	colordlg->FXDialogBox::execute();
	HiliteColor=colordlg->getRGBA();
	sample->setHiliteColor(HiliteColor);
	return 1;
}

long SliderDialog::onCmdShadowColor(FXObject*,FXSelector,void*)
{
	colordlg=new FXColorDialog(this,"Select Color",DECOR_BORDER|DECOR_TITLE);
	colordlg->FXDialogBox::execute();
	ShadowColor=colordlg->getRGBA();
	sample->setShadowColor(ShadowColor);
	return 1;
}

long SliderDialog::onCmdBackColor(FXObject*,FXSelector,void*)
{	
	colordlg=new FXColorDialog(this,"Select Color",DECOR_BORDER|DECOR_TITLE);
	colordlg->FXDialogBox::execute();
	BackColor=colordlg->getRGBA();
	sample->setBackColor(BackColor);
	return 1;
}

long SliderDialog::onCmdResults(FXObject*,FXSelector,void*)
{
              FXString Resultstxt;
              FXString strItems;
	FXString* SumRes;
	FXString TipStr;
	FXString TotalD;
	
	FXString ObjName;
	FXString ObjOwner;
	FXString ObjText;
	FXString ObjCols;
	FXString ObjTarget, ObjSelector;
	FXString ObjTip;
	FXString ObjIcon;
	FXString ObjX;
	FXString ObjY;
	FXString ObjW;
	FXString ObjH;
	FXString ObjSlotSize;
	FXString SlotSizeStr;
	FXString ObjHeadSize;
	FXString HeadSizeStr;
	FXString ObjRevInc;
	FXString RevIncStr;
	FXString ObjHelp;
	FXString HelpStr;
              FXString BackColorStr;
	FXString ShadowColorStr;
	FXString BorderColorStr;
	FXString BaseColorStr;
	FXString HiliteColorStr;
	FXString SlotColorStr;
	FXString ObjOpts;

	DeclareStr="FXDial* ";
	newObjectStr="=new FXDial(";	
	ObjName=txtName->getText();
	ObjOwner=txtOwner->getText()+",";
	ObjTip=txtTooltip->getText();
	TipStr=ObjName+"->setTipText("+ObjTip+");\n";
	ObjTarget=txtTarget->getText()+",";
	ObjSelector=txtSelector->getText()+",";
	ObjOpts=combostyle->getText()+"|"+combolayout->getText()+"|"+comboframe->getText()+",";
	ObjSlotSize=FXStringVal(spinSlotSize->getValue(),10);
	ObjHeadSize=FXStringVal(spinHeadSize->getValue(),10);
	ObjRevInc=FXStringVal(spinRevInc->getValue(),10);
	ObjHelp=txtHelp->getText();
	ObjX=FXStringVal(spinPosX->getValue(),10)+",";
	ObjY=FXStringVal(spinPosY->getValue(),10)+",";
	ObjW=FXStringVal(spinw->getValue(),10)+",";
	ObjH=FXStringVal(spinh->getValue(),10);
	SlotSizeStr=ObjName+"->setSlotSize("+ObjSlotSize+");\n";
	HeadSizeStr=ObjName+"->setHeadSize("+ObjHeadSize+");\n";
	RevIncStr=ObjName+"->setIncrement("+ObjRevInc+");\n";
	HelpStr=ObjName+"->setHelpText("+ObjHelp+");\n";
	if ((chkDeclare->getCheck())==TRUE) DeclareStr="";
	if ((chkColors->getCheck())==TRUE)
	{
	SlotColorStr=ObjName+"->setSlotColor(FXRGBA("+FXStringVal(FXREDVAL(SlotColor))+","+
		FXStringVal(FXGREENVAL(SlotColor))+","+FXStringVal(FXBLUEVAL(SlotColor))+","+
		FXStringVal(FXALPHAVAL(SlotColor))+"));\n";
	BackColorStr=ObjName+"->setBackColor(FXRGBA("+FXStringVal(FXREDVAL(BackColor))+","+
		FXStringVal(FXGREENVAL(BackColor))+","+FXStringVal(FXBLUEVAL(BackColor))+","+
		FXStringVal(FXALPHAVAL(BackColor))+"));\n";
	BaseColorStr=ObjName+"->setBaseColor(FXRGBA("+FXStringVal(FXREDVAL(BaseColor))+","+
		FXStringVal(FXGREENVAL(BaseColor))+","+FXStringVal(FXBLUEVAL(BaseColor))+","+
		FXStringVal(FXALPHAVAL(BaseColor))+"));\n";
	ShadowColorStr=ObjName+"->setShadowColor(FXRGBA("+FXStringVal(FXREDVAL(ShadowColor))+","+
		FXStringVal(FXGREENVAL(ShadowColor))+","+FXStringVal(FXBLUEVAL(ShadowColor))+","+
		FXStringVal(FXALPHAVAL(ShadowColor))+"));\n";
	BorderColorStr=ObjName+"->setBorderColor(FXRGBA("+FXStringVal(FXREDVAL(BorderColor))+","+
		FXStringVal(FXGREENVAL(BorderColor))+","+FXStringVal(FXBLUEVAL(BorderColor))+","+
		FXStringVal(FXALPHAVAL(BorderColor))+"));\n";
	HiliteColorStr=ObjName+"->setHiliteColor(FXRGBA("+FXStringVal(FXREDVAL(HiliteColor))+","+
		FXStringVal(FXGREENVAL(HiliteColor))+","+FXStringVal(FXBLUEVAL(HiliteColor))+","+
		FXStringVal(FXALPHAVAL(HiliteColor))+"));\n";
	}
	else
	{
		BackColorStr="";
		BaseColorStr="";
		ShadowColorStr="";
		BorderColorStr="";
		HiliteColorStr="";
		SlotColorStr="";
	}
	
	TotalD=DeclareStr+ObjName+newObjectStr+ObjOwner+ObjTarget+ObjSelector+ObjOpts+ObjX+ObjY+ObjW+ObjH+");\n"+
		SlotColorStr+BackColorStr+ShadowColorStr+BorderColorStr+BaseColorStr+HiliteColorStr+
		TipStr+HelpStr+SlotSizeStr+HeadSizeStr+RevIncStr;

	SumRes=&TotalD;
	editor->insertText(editor->getCursorPos(),SumRes->text(),SumRes->size()-1, FALSE);	
	sample->hide();
	return 1;
}
