/********************************************************************************
*                                                                               *
*                                 Create Slider                        *
*                                                                               *
*********************************************************************************
* Copyright (C) 2001 by Anastasios Sarris.   All Rights Reserved.             *
*********************************************************************************/
#ifndef SLIDERDIALOG_H
#define SLIDERDIALOG_H

// Mini application object
class SliderDialog : public FXDialogBox
 {
  FXDECLARE(SliderDialog)
protected:
  FXSlider*	sample;        // Object being tested
  FXToolbar*	mdiTools;
  FXHorizontalFrame*	buttons;
  FXColor	SlotColor;
  FXString	buttonalign;
  FXFont*	buttonFont;
  FXFont*	mainFont;
  FXFont*	toolFont;
  FXTextField*	txtLabel;
  FXColorDialog* colordlg;
  FXSpinner*	spinw;	FXSpinner*	spinh;
 FXSpinner*	spinPosX;	FXSpinner*	spinPosY;
  FXButton*	btnSlotColor;
  FXTextField*	txtTooltip;
  FXTextField*	txtOwner;
  FXTextField*	txtName;
  FXTextField*	txtTarget;
  FXTextField*	txtSelector;
  FXTextField*	txtIcon;
  FXTextField*	txtHelp;
  FXSpinner*	spinSlotSize;	FXSpinner*	spinHeadSize;
  FXSpinner*	spinRevInc;
  FXCheckButton*	chkDeclare;	FXCheckButton*	chkToolStyle;
  FXCheckButton*	chkFont;	FXCheckButton*	chkColors;
  FXColor	BaseColor;	FXColor	ShadowColor;
  FXColor	BorderColor;	FXColor	HiliteColor;
 FXColor	BackColor;	FXColor	TextColor;
 FXButton* btnBaseColor;		FXButton* btnShadowColor;
 FXButton* btnBorderColor;	FXButton* btnHiliteColor;
 FXButton* btnBackColor;
 FXButton* btnTextColor;
 FXComboBox*	comboiconpos;	FXComboBox*	comboalign;
 FXComboBox*	combolayout;	FXComboBox*	comboframe;
 FXComboBox*	combostyle;	
 FXButton*	btnOK;		FXButton*	btnCancel;

private:
  SliderDialog(){}
public:
  enum {
    ID_TEXT=FXDialogBox::ID_LAST,
    ID_TOOLBARGRIP,
    ID_SLOT_SIZE,
    ID_HEAD_SIZE,
    ID_SLOT_COLOR,
    ID_HELP,
    ID_INC,
    ID_DIRECTION,
    ID_WIDTH,
    ID_HEIGHT,
    ID_POSX,
    ID_POSY,
    ID_OWNER,
    ID_NAME,
    ID_TOOLTIP,
    ID_LAYOUT,
    ID_FRAME,
    ID_TARGET,
    ID_SELECTOR,
    ID_DECLARE,
    ID_RESULTS,
    ID_COLOR_DECLARE,
    ID_BASE_COLOR,
    ID_HILITE_COLOR,
    ID_SHADOW_COLOR,
    ID_BORDER_COLOR,
    ID_BACK_COLOR
};

public:
  long onCmdName(FXObject*,FXSelector,void*);
  long onCmdWidth(FXObject*,FXSelector,void*);
  long onCmdHeight(FXObject*,FXSelector,void*);
  long onCmdPosX(FXObject*,FXSelector,void*);
  long onCmdPosY(FXObject*,FXSelector,void*);
  long onCmdFont(FXObject*,FXSelector,void*);
  long onCmdResults(FXObject*,FXSelector,void*);
  long onCmdToolTip(FXObject*,FXSelector,void*);
  long onCmdLayout(FXObject*,FXSelector,void*);
  long onCmdFrame(FXObject*,FXSelector,void*);
  long onCmdTarget(FXObject*,FXSelector,void*);
  long onCmdSelector(FXObject*,FXSelector,void*);
  long onCmdDeclare(FXObject*,FXSelector,void*);
  long onCmdColorDeclare(FXObject*,FXSelector,void*);
  long onCmdBaseColor(FXObject*,FXSelector,void*);
  long onCmdBorderColor(FXObject*,FXSelector,void*);
  long onCmdHiliteColor(FXObject*,FXSelector,void*);
  long onCmdShadowColor(FXObject*,FXSelector,void*);
  long onCmdBackColor(FXObject*,FXSelector,void*);
  long onCmdSlotColor(FXObject*,FXSelector,void*);
  long onCmdSlotSize(FXObject*,FXSelector,void*);
  long onCmdHeadSize(FXObject*,FXSelector,void*);
  long onCmdInc(FXObject*,FXSelector,void*);
  long onCmdHelp(FXObject*,FXSelector,void*);
  long onCmdDirection(FXObject*,FXSelector,void*);

public:
  SliderDialog(FXWindow* owner);
  virtual ~SliderDialog();
  };

#endif
