/********************************************************************************
*                                                                               *
*                                 Spinner  Creator                    *
*                                                                               *
*********************************************************************************
* Copyright (C) 2001 by Sarris Anastasios.   All Rights Reserved.             *
*********************************************************************************/
#ifndef SPINNERDIALOG_H
#define SPINNERDIALOG_H

// Mini application object
class SpinnerDialog : public FXDialogBox
 {
  FXDECLARE(SpinnerDialog)
protected:
  FXSpinner*	sample;
  FXStatusbar*	statusbar;
  FXToolbar*	mdiTools;
  FXHorizontalFrame*	buttons;
  FXColorDialog* colordlg;
  FXFontDialog*	fontdlg;
  FXButton*	btnFont;
  FXTextField*	txtTooltip;
  FXString	buttonalign;
  FXFont*	myfont;
  FXFont*	mainFont;
  FXText*	txtResults;
  FXTextField*	txtOwner;
  FXTextField*	txtName;
  FXTextField*	txtTarget;
  FXTextField*	txtSelector;
  FXSpinner*	spinw;
  FXSpinner*	spinh;
  FXSpinner*	spinPosX;
  FXSpinner*	spinPosY;
  FXSpinner*	spinCols;
  FXCheckButton*	chkDeclare;
  FXCheckButton*	chkFont;
  FXCheckButton*	chkColors;
  FXColor	BaseColor;	FXColor	ShadowColor;
 FXColor	BorderColor;	FXColor	HiliteColor;
 FXColor	BackColor;	FXColor	TextColor;
 FXButton* btnBaseColor;		FXButton* btnShadowColor;
 FXButton* btnBorderColor;	FXButton* btnHiliteColor;
 FXButton* btnBackColor;		FXButton* btnTextColor;
 FXComboBox*	comboiconpos;	FXComboBox*	comboalign;
 FXComboBox*	combolayout;	FXComboBox*	comboframe;
 FXComboBox*	combostyle;
 FXButton*	btnOK;		FXButton*	btnCancel;

private:
  SpinnerDialog(){}
public:
  enum {
    ID_RESULTS=FXDialogBox::ID_LAST,
    ID_TOOLBAR_STYLE,
    ID_TOOLBARGRIP,
    ID_COLOR_DECLARE,
    ID_FONT,
    ID_WIDTH,
    ID_HEIGHT,
    ID_POSX,
    ID_POSY,
    ID_OWNER,
    ID_NAME,
    ID_LAYOUT,
    ID_FRAME,
    ID_TARGET,
    ID_SELECTOR,
    ID_TOOLTIP,
    ID_COPY,
    ID_COLS,
    ID_DECLARE,
    ID_FONT_DECLARE,
    ID_BASE_COLOR,
    ID_HILITE_COLOR,
    ID_SHADOW_COLOR,
    ID_BORDER_COLOR
    };
public:
  long onCmdName(FXObject*,FXSelector,void*);
  long onCmdWidth(FXObject*,FXSelector,void*);
  long onCmdHeight(FXObject*,FXSelector,void*);
  long onCmdPosX(FXObject*,FXSelector,void*);
  long onCmdPosY(FXObject*,FXSelector,void*);
  long onCmdFont(FXObject*,FXSelector,void*);
  long onCmdResults(FXObject*,FXSelector,void*);
  long onCmdLayout(FXObject*,FXSelector,void*);
  long onCmdFrame(FXObject*,FXSelector,void*);
  long onCmdTarget(FXObject*,FXSelector,void*);
  long onCmdSelector(FXObject*,FXSelector,void*);
  long onCmdCols(FXObject*,FXSelector,void*);
  long onCmdDeclare(FXObject*,FXSelector,void*);
  long onCmdFontDeclare(FXObject*,FXSelector,void*);
  long onCmdColorDeclare(FXObject*,FXSelector,void*);
  long onCmdBaseColor(FXObject*,FXSelector,void*);
  long onCmdBorderColor(FXObject*,FXSelector,void*);
  long onCmdHiliteColor(FXObject*,FXSelector,void*);
  long onCmdShadowColor(FXObject*,FXSelector,void*);

public:
  SpinnerDialog(FXWindow* owner);
  virtual ~SpinnerDialog();
};

#endif
