/********************************************************************************
*                                                                               *
*                                 Create Table		           *
*                                                                               *
*********************************************************************************
* Copyright (C) 2001 by Anastasios Sarris.   All Rights Reserved.             *
*********************************************************************************/
#ifndef TABLEDIALOG_H
#define TABLEDIALOG_H

class TableDialog: public FXDialogBox
{
	FXDECLARE(TableDialog)
	protected:
		FXTable*	sample;
		FXHorizontalFrame*	buttons;
		FXFont* mainFont;
		FXTextField* txtName;
		FXTextField* txtOwner;
		FXSpinner* spinRows;
		FXSpinner* spinCols;
		FXComboBox* comboGrids;
		FXCheckButton*	chkDeclare;
		FXSpinner* spinWidth;
		FXSpinner* spinHeight;
		FXSpinner* spinPosX;
		FXSpinner* spinPosY;
		FXSpinner* spinLeadRows;
		FXSpinner* spinLeadCols;
		FXSpinner* spinTrailRows;
		FXSpinner* spinTrailCols;
		FXTextField* txtTarget;
		FXTextField* txtID;
		FXMatrix*	controls;
		FXint	RowsNo;
		FXint	ColsNo;
		FXButton*	btnOK;
		FXButton*	btnCancel;

	protected:
		TableDialog(){}
	public:
	enum {
		ID_RESULTS=FXDialogBox::ID_LAST,
		ID_OWNER,
		ID_ROWS,
		ID_COLS,
		ID_GRIDS,
		ID_WIDTH,
		ID_HEIGHT,
		ID_POSX,
		ID_POSY,
		ID_DECLARE,
		ID_LEADROWS,
		ID_LEADCOLS,
		ID_TRAILROWS,
		ID_TRAILCOLS,
		ID_TARGET,
		ID_SELECTOR,
		ID_NAME,
};
	public:
		long onCmdName(FXObject*,FXSelector,void*);
		long onCmdDeclare(FXObject*,FXSelector,void*);
		long onCmdOwner(FXObject*,FXSelector,void*);
		long onCmdRows(FXObject*,FXSelector,void*);
		long onCmdCols(FXObject*,FXSelector,void*);
		long onCmdGrids(FXObject*,FXSelector,void*);
		long onCmdWidth(FXObject*,FXSelector,void*);
		long onCmdHeight(FXObject*,FXSelector,void*);
		long onCmdPosX(FXObject*,FXSelector,void*);
		long onCmdPosY(FXObject*,FXSelector,void*);
		long onCmdLeadRows(FXObject*,FXSelector,void*);
		long onCmdLeadCols(FXObject*,FXSelector,void*);
		long onCmdTrailRows(FXObject*,FXSelector,void*);
		long onCmdTrailCols(FXObject*,FXSelector,void*);
		long onCmdTarget(FXObject*,FXSelector,void*);
		long onCmdSelector(FXObject*,FXSelector,void*);
		long onCmdResults(FXObject*,FXSelector,void*);
		
	public:
	TableDialog(FXWindow* owner);
	virtual ~TableDialog();
};

#endif
