/********************************************************************************
*                                                                               *
*                                 textmulti Test                                   *
*                                                                               *
*********************************************************************************
* Copyright (C) 2001 by Anastasios Sarris.   All Rights Reserved.             *
*********************************************************************************/

#include "/usr/local/include/fox/fx.h"
#include "TextDialog.h"
#include "vars.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

// Map
FXDEFMAP(TextDialog) TextDialogMap[]={
  FXMAPFUNC(SEL_COMMAND,TextDialog::ID_NAME,TextDialog::onCmdName),
  FXMAPFUNC(SEL_COMMAND,TextDialog::ID_FONT,TextDialog::onCmdFont),
  FXMAPFUNC(SEL_COMMAND,TextDialog::ID_RESULTS,TextDialog::onCmdResults),
  FXMAPFUNC(SEL_COMMAND,TextDialog::ID_TARGET,TextDialog::onCmdTarget),
  FXMAPFUNC(SEL_COMMAND,TextDialog::ID_SELECTOR,TextDialog::onCmdSelector),
  FXMAPFUNC(SEL_COMMAND,TextDialog::ID_LAYOUT,TextDialog::onCmdLayout),
  FXMAPFUNC(SEL_COMMAND,TextDialog::ID_DECLARE,TextDialog::onCmdDeclare),
  FXMAPFUNC(SEL_COMMAND,TextDialog::ID_FONT_DECLARE,TextDialog::onCmdFontDeclare),
  FXMAPFUNC(SEL_COMMAND,TextDialog::ID_COLOR_DECLARE,TextDialog::onCmdColorDeclare),
  FXMAPFUNC(SEL_COMMAND,TextDialog::ID_TEXT_COLOR,TextDialog::onCmdTextColor),
  FXMAPFUNC(SEL_COMMAND,TextDialog::ID_WIDTH,TextDialog::onCmdWidth),
  FXMAPFUNC(SEL_COMMAND,TextDialog::ID_HEIGHT,TextDialog::onCmdHeight),
  FXMAPFUNC(SEL_COMMAND,TextDialog::ID_POSX,TextDialog::onCmdPosX),
  FXMAPFUNC(SEL_COMMAND,TextDialog::ID_POSY,TextDialog::onCmdPosY),
 };


// ButtonApp implementation
FXIMPLEMENT(TextDialog,FXDialogBox,TextDialogMap,ARRAYNUMBER(TextDialogMap))

// Make some windows
TextDialog::TextDialog(FXWindow* owner):FXDialogBox(owner,"Text Creator ",DECOR_TITLE|DECOR_BORDER,0)
{
    mainFont=new FXFont(getApp(),AppFont,10,FONTWEIGHT_NORMAL,FONTSLANT_REGULAR,FONTENCODING_GREEK);
  buttons=new FXHorizontalFrame(this,LAYOUT_SIDE_BOTTOM|FRAME_NONE|LAYOUT_FILL_X|PACK_UNIFORM_WIDTH,0,0,0,0,40,40,20,20);
	FXMatrix* BasicControls=new FXMatrix(this,1,FRAME_NONE|MATRIX_BY_COLUMNS|LAYOUT_FILL_X);
 	FXToolbarShell* dragshell2=new FXToolbarShell(this,FRAME_RAISED|FRAME_THICK);
             	mdiTools=new FXToolbar(BasicControls,dragshell2,LAYOUT_SIDE_TOP|LAYOUT_FILL_X);
         	new FXToolbarGrip(mdiTools,this,ID_TOOLBARGRIP);
		//
		btnFont=new FXButton(mdiTools,"\tFont",fonticon,this,ID_FONT,BUTTON_TOOLBAR|ICON_ABOVE_TEXT|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,52,52);
		btnFont->setFont(mainFont);
		myfont=new FXFont(getApp(),"grtex",10);
	
	              //
		btnTextColor=new FXButton(mdiTools,"TC\tText Color",coloricon,this,ID_TEXT_COLOR,ICON_UNDER_TEXT|BUTTON_TOOLBAR|JUSTIFY_NORMAL|LAYOUT_NORMAL|FRAME_RAISED,50,55,52,52);
		btnTextColor->setFont(mainFont);         	
         	
              FXMatrix*  controls=new FXMatrix(BasicControls,2,FRAME_RIDGE|MATRIX_BY_COLUMNS|LAYOUT_FILL_X);
	  //  
	  FXLabel *lblName=new FXLabel(controls,"&Name:\tObject name",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
	  lblName->setFont(mainFont);
	  txtName=new FXTextField(controls,15,this,ID_NAME,LAYOUT_LEFT|FRAME_SUNKEN);
	  txtName->setFont(mainFont);
	  txtName->setText("mtxt");
	
	   //
	  FXLabel *lblOwner=new FXLabel(controls,"&Owner:\tObject Owner",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
	  lblOwner->setFont(mainFont);
	  txtOwner=new FXTextField(controls,15,this,ID_OWNER,LAYOUT_LEFT|FRAME_SUNKEN);
	  txtOwner->setFont(mainFont);

	  //
	  FXLabel *lblTarget=new FXLabel(controls,"&Target:\tTarget",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
	  lblTarget->setFont(mainFont);
	  txtTarget=new FXTextField(controls,15,this,ID_TARGET,LAYOUT_LEFT|FRAME_SUNKEN);
	  txtTarget->setFont(mainFont);
	
	    //Selector
	  FXLabel *lblSelector=new FXLabel(controls,"&ID:",NULL,LAYOUT_FILL_ROW|JUSTIFY_LEFT);
	  lblSelector->setFont(mainFont);
	  txtSelector=new FXTextField(controls,15,this,ID_SELECTOR,LAYOUT_LEFT|FRAME_SUNKEN);
	  txtSelector->setFont(mainFont);

	  //  
	  FXLabel *lbllayout=new FXLabel(controls,"&Layout:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
	  lbllayout->setFont(mainFont);
	  combolayout=new FXComboBox(controls,15,5,this,ID_LAYOUT,COMBOBOX_INSERT_LAST|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
	  for(int i=0; i<20; i++){  combolayout->appendItem(strlayout[i]);         }
	  combolayout->setCurrentItem(0);

	  // 
	  FXLabel* lblWidth=new FXLabel(controls,"&Width:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
	  lblWidth->setFont(mainFont);
	  spinw=new FXSpinner(controls,6,this,ID_WIDTH,SPIN_NORMAL|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
	  spinw->setFont(mainFont);
	  spinw->setRange(1,500);

	  // 
	  FXLabel *lblHeight=new FXLabel(controls,"&Height:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
	  lblHeight->setFont(mainFont);
	  spinh=new FXSpinner(controls,6,this,ID_HEIGHT,SPIN_NORMAL|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
	  spinh->setFont(mainFont);
	  spinh->setRange(1,400);

	  // 
	  FXLabel *lblPosX=new FXLabel(controls,"&X Pos:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
	  lblPosX->setFont(mainFont);
	  spinPosX=new FXSpinner(controls,6,this,ID_POSX,SPIN_NORMAL|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
	  spinPosX->setFont(mainFont);
	  spinPosX->setRange(1,1000);
	
	  // 
	  FXLabel *lblPosY=new FXLabel(controls,"& Pos:",NULL,LAYOUT_LEFT|JUSTIFY_LEFT);
	  lblPosY->setFont(mainFont);
	  spinPosY=new FXSpinner(controls,6,this,ID_POSX,SPIN_NORMAL|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
	  spinPosY->setFont(mainFont);
	  spinPosY->setRange(1,1000);
	
	  chkDeclare=new FXCheckButton(controls,"Declare in the class",this,ID_DECLARE,ICON_AFTER_TEXT|LAYOUT_NORMAL|FRAME_RAISED);
	  chkDeclare->setFont(mainFont);
	  chkFont=new FXCheckButton(controls,"Get the main Font",this,ID_FONT_DECLARE,ICON_AFTER_TEXT|LAYOUT_NORMAL|FRAME_RAISED);
	  chkFont->setFont(mainFont);
	  chkColors=new FXCheckButton(controls,"Set Colors",this,ID_COLOR_DECLARE,ICON_AFTER_TEXT|LAYOUT_NORMAL|FRAME_RAISED);
	  chkColors->setFont(mainFont);	

  // The sample
  sample=new FXText(mtxSamples,NULL,0,LAYOUT_TOP|LAYOUT_FILL_X|LAYOUT_FILL_Y);
  sample->setFont(mainFont);
  sample->hide();

  btnOK=new FXButton(buttons,"Create\tCreate commands and\ncopy them into code window",NULL,this,ID_RESULTS,ICON_ABOVE_TEXT|JUSTIFY_NORMAL|LAYOUT_BOTTOM|LAYOUT_RIGHT|FRAME_RAISED,50,55,52,52);
  btnCancel=new FXButton(buttons,"Close\tCancel Dialog",NULL,this,FXDialogBox::ID_CANCEL,ICON_ABOVE_TEXT|JUSTIFY_NORMAL|LAYOUT_BOTTOM|LAYOUT_RIGHT|FRAME_RAISED,10,15,52,52);

}

TextDialog::~TextDialog(){}

long TextDialog::onCmdName(FXObject*,FXSelector,void*)
{
	sample->show();
	sample->update();
	return 1;
}

long TextDialog::onCmdWidth(FXObject*,FXSelector,void*)
{
   sample->setWidth(spinw->getValue());
   sample->update();
   return 1;
}

long TextDialog::onCmdHeight(FXObject*,FXSelector,void*)
{
	sample->setHeight(spinh->getValue());
	sample->update();
	return 1;
}

long TextDialog::onCmdPosX(FXObject*,FXSelector,void*)
{
	sample->setX(spinPosX->getValue());
	return 1;
}

long TextDialog::onCmdPosY(FXObject*,FXSelector,void*)
{
	sample->setY(spinh->getValue());
	return 1;
}

long TextDialog::onCmdTarget(FXObject*,FXSelector,void*)
{
	if (txtTarget->getText()=="") txtTarget->setText("NULL");
	return 1;
}

long TextDialog::onCmdSelector(FXObject*,FXSelector,void*)
{
	if (txtSelector->getText()=="") txtSelector->setText("0");
	return 1;
}

long TextDialog::onCmdDeclare(FXObject*,FXSelector,void*)
{
	return 1;
}

long TextDialog::onCmdLayout(FXObject*,FXSelector,void*)
{
              FXuint style=sample->getLayoutHints();
	style=combolayout->getCurrentItem();
	switch (style)
	{
		case 0:	style|=LAYOUT_NORMAL; break;
		case 1:	style|=LAYOUT_SIDE_TOP; break;
		case 2:	style|=LAYOUT_SIDE_BOTTOM; break;
		case 3:	style|=LAYOUT_SIDE_LEFT; break;
		case 4:	style|=LAYOUT_SIDE_RIGHT; break;
		case 5:	style|=LAYOUT_FILL_COLUMN; break;
		case 6:	style|=LAYOUT_FILL_ROW; break;
		case 7:	style|=LAYOUT_LEFT; break;
		case 8:	style|=LAYOUT_RIGHT; break;
		case 9:	style|=LAYOUT_CENTER_X; break;
		case 10:	style|=LAYOUT_FIX_X; break;
		case 11:	style|=LAYOUT_TOP; break;
		case 12:	style|=LAYOUT_BOTTOM; break;
		case 13:	style|=LAYOUT_CENTER_Y; break;
		case 14:	style|=LAYOUT_FIX_Y; break;
		case 15:	style|=LAYOUT_FIX_WIDTH; break;
		case 16:	style|=LAYOUT_FIX_HEIGHT; break;
		case 17:	style|=LAYOUT_MIN_WIDTH; break;
		case 18:	style|=LAYOUT_MIN_HEIGHT; break;
		case 19:	style|=LAYOUT_FILL_X; break;
	}
	sample->setLayoutHints(style);	
	return 1;
}


long TextDialog::onCmdTextColor(FXObject*,FXSelector,void*)
{
	colordlg=new FXColorDialog(this," ",DECOR_BORDER|DECOR_TITLE);
	colordlg->FXDialogBox::execute();
	TextColor=colordlg->getRGBA();
	sample->setTextColor(TextColor);
	return 1;
}

long TextDialog::onCmdFontDeclare(FXObject*,FXSelector,void*)
{
	return 1;
}

long TextDialog::onCmdColorDeclare(FXObject*,FXSelector,void*)
{
	return 1;
}


long TextDialog::onCmdResults(FXObject*,FXSelector,void*)
{
	FXString Resultstxt;
              FXString strFont;
              FXString strItems;
	FXString*	SumRes;
	FXString TotalTM;
	
	FXString ObjName;
	FXString ObjOwner;
	FXString ObjText;
	FXString ObjTarget, ObjSelector;
	FXString ObjIcon;
	FXString ObjX;
	FXString ObjY;
	FXString ObjW;
	FXString ObjH;
              FXString ObjFont;
	FXString TextColorStr;
	FXString ObjOpts;

	DeclareStr="FXText* ";
	newObjectStr="=new FXText(";
	ObjName=txtName->getText();
	ObjOwner=txtOwner->getText()+",";
	ObjOpts=combolayout->getText()+",";
	ObjX=FXStringVal(spinPosX->getValue(),10)+",";
	ObjY=FXStringVal(spinPosY->getValue(),10)+",";
	ObjW=FXStringVal(spinw->getValue(),10)+",";
	ObjH=FXStringVal(spinh->getValue(),10);
	ObjFont="FXFont* "+ObjName+"Font=new FXFont(getApp(),"+ec+myfont->getName()+ec+","+
		FXStringVal(myfont->getSize()/10)+");\n"+ObjName+"->setFont("+ObjName+"Font);\n";

	if ((chkDeclare->getCheck())==TRUE) DeclareStr="";
	if ((chkFont->getCheck())==TRUE) ObjFont=ObjName+"->setFont(mainFont);\n";
	
	if ((chkColors->getCheck())==TRUE)
	{
	TextColorStr=ObjName+"->setTextColor(FXRGBA("+FXStringVal(FXREDVAL(TextColor))+","+
		FXStringVal(FXGREENVAL(TextColor))+","+FXStringVal(FXBLUEVAL(TextColor))+","+
		FXStringVal(FXALPHAVAL(TextColor))+"));\n";
	}
	else
	{
		TextColorStr="";
	}
	ObjTarget=txtTarget->getText()+",";
	ObjSelector=txtSelector->getText()+",";
	TotalTM=DeclareStr+ObjName+newObjectStr+ObjOwner+ObjTarget+ObjSelector+ObjOpts+ObjX+ObjY+ObjW+ObjH+");\n"+
	ObjFont+TextColorStr;

 	SumRes=&TotalTM;
	editor->insertText(editor->getCursorPos(),SumRes->text(),SumRes->size()-1, FALSE);
	sample->hide();
	return 1;
}

long TextDialog::onCmdFont(FXObject*,FXSelector,void*)
{
              fontdlg=new FXFontDialog(this,"Change Font",DECOR_BORDER|DECOR_TITLE);
	FXFontDesc fontdesc;
	fontdlg->FXDialogBox::execute();
	fontdlg->getFontSelection(fontdesc);
	delete myfont;
	myfont=new FXFont(getApp(),fontdesc);
	myfont->create();
	sample->setFont(myfont);
	return 1;
}
