/********************************************************************************
*                                                                               *
*                        textfield Test                                   *
*                                                                               *
***********************************************************
* Copyright (C) 2001 by Sarris Anastasios   All Rights Reserved.             *
***********************************************************/
#ifndef TEXTFIELDDIALOG_H
#define TEXTFIELDDIALOG_H

// Mini application object
class TextFieldDialog : public FXDialogBox
 {
  FXDECLARE(TextFieldDialog)
protected:
  FXTextField*		sample;        // Object being tested
  FXToolbar*	mdiTools;
  FXHorizontalFrame*	buttons;

  FXString	textfieldalign;
  FXFont*	myfont;
  FXFont*	mainFont;
  FXFontDialog*	fontdlg;
  FXText*	txtResults;
  FXButton*	btnFont;
  FXTextField*	txttextfield;
  FXTextField*	txtOwner;
  FXTextField*	txtName;
  FXTextField*	txtTarget;
  FXTextField*	txtSelector;
  FXTextField*	txtTooltip;
  FXColorDialog*	colordlg;
  FXCheckButton*	chkDeclare;
  FXCheckButton*	chkFont;
  FXCheckButton*	chkColors;
  FXSpinner*	spinCols;
  FXSpinner*	spinw;
 FXSpinner*	spinh;
 FXSpinner*	spinPosX;
 FXSpinner*	spinPosY;        FXColor	BaseColor;
 FXColor	ShadowColor;
 FXColor	BorderColor;
 FXColor	HiliteColor;
 FXColor	BackColor;
 FXColor	TextColor;
 FXButton* btnBaseColor;
 FXButton* btnShadowColor;
 FXButton* btnBorderColor;
 FXButton* btnHiliteColor;
 FXButton* btnBackColor;
 FXButton* btnTextColor;
 FXComboBox*	comboiconpos;
 FXComboBox*	comboalign;
 FXComboBox*	combolayout;
 FXComboBox*	comboframe;
 FXComboBox*	combostyle;
 FXButton*	btnOK;
 FXButton*	btnCancel;

private:
  TextFieldDialog(){}
public:
  enum {
    ID_RESULTS=FXDialogBox::ID_LAST,
    ID_TEXT,
    ID_TOOLBARGRIP,
    ID_TEXT_COLOR,
    ID_BASE_COLOR,
    ID_HILITE_COLOR,
    ID_SHADOW_COLOR,
    ID_BORDER_COLOR,
    ID_BACK_COLOR,
    ID_FONT,
    ID_FONT_DECLARE,
    ID_COLOR_DECLARE,
    ID_DECLARE,
    ID_OWNER,
    ID_NAME,
    ID_ALIGN,
    ID_LAYOUT,
    ID_FRAME,
    ID_TARGET,
    ID_SELECTOR,
    ID_COLS,
    ID_WIDTH,
    ID_HEIGHT,
    ID_POSX,
    ID_POSY,
    ID_TOOLTIP
    };
public:
  long onCmdName(FXObject*,FXSelector,void*);
  long onCmdText(FXObject*,FXSelector,void*);
  long onCmdDeclare(FXObject*,FXSelector,void*);
  long onCmdFont(FXObject*,FXSelector,void*);
  long onCmdFontDeclare(FXObject*,FXSelector,void*);
  long onCmdAlign(FXObject*,FXSelector,void*);
  long onCmdResults(FXObject*,FXSelector,void*);
  long onCmdLayout(FXObject*,FXSelector,void*);
  long onCmdFrame(FXObject*,FXSelector,void*);
  long onCmdTarget(FXObject*,FXSelector,void*);
  long onCmdSelector(FXObject*,FXSelector,void*);
  long onCmdWidth(FXObject*,FXSelector,void*);
  long onCmdHeight(FXObject*,FXSelector,void*);
  long onCmdPosX(FXObject*,FXSelector,void*);
  long onCmdPosY(FXObject*,FXSelector,void*);
  long onCmdCol(FXObject*,FXSelector,void*);
  long onCmdTextColor(FXObject*,FXSelector,void*);
  long onCmdBaseColor(FXObject*,FXSelector,void*);
  long onCmdBorderColor(FXObject*,FXSelector,void*);
  long onCmdHiliteColor(FXObject*,FXSelector,void*);
  long onCmdShadowColor(FXObject*,FXSelector,void*);
  long onCmdBackColor(FXObject*,FXSelector,void*);
  long onCmdColorDeclare(FXObject*,FXSelector,void*);
  long onCmdToolTip(FXObject*,FXSelector,void*);

public:
  TextFieldDialog(FXWindow* owner);
  virtual ~TextFieldDialog();
};

#endif
