//common variables
#include "/usr/local/include/fox/fx.h"
#include "vars.h"

extern const char * striconpos[5]={"ICON_UNDER_TEXT",
		       "ICON_AFTER_TEXT",
		       "ICON_BEFORE_TEXT",
		       "ICON_ABOVE_TEXT",
		       "ICON_BELOW_TEXT"};
		
extern const char * stralign[8] = {"JUSTIFY_NORMAL",
		    "JUSTIFY_CENTER_X",
		    "JUSTIFY_LEFT",
		    "JUSTIFY_RIGHT",
		    "JUSTIFY_HZ_APART",
		    "JUSTIFY_CENTER_Y",
		    "JUSTIFY_TOP",
		    "JUSTIFY_BOTTOM"};
		
extern const char * strlayout[20]={"LAYOUT_NORMAL",
		      "LAYOUT_SIDE_TOP",
		      "LAYOUT_SIDE_BOTTOM",
		      "LAYOUT_SIDE_LEFT",
                                  "LAYOUT_SIDE_RIGHT",
                                  "LAYOUT_FILL_COLUMN",
                                  "LAYOUT_FILL_ROW",
                                  "LAYOUT_LEFT",
                                  "LAYOUT_RIGHT",
                                  "LAYOUT_CENTER_X",
                                  "LAYOUT_FIX_X",
                                  "LAYOUT_TOP",
                                  "LAYOUT_BOTTOM",
                                  "LAYOUT_CENTER_Y",
                                  "LAYOUT_FIX_Y",
                                  "LAYOUT_FIX_WIDTH",
                                  "LAYOUT_FIX_HEIGHT",
                                  "LAYOUT_MIN_WIDTH",
                                  "LAYOUT_MIN_HEIGHT",
                                  "LAYOUT_FILL_X"};

extern const char * strframe[7]={"FRAME_NONE",
		   "FRAME_SUNKEN",
		   "FRAME_RAISED",
		   "FRAME_THICK",
		   "FRAME_GROOVE",
		   "FRAME_RIDGE",
		   "FRAME_LINE"};
		
extern const char * dirArrow[4]={"ARROW_UP",
		    "ARROW_DOWN",
		    "ARROW_LEFT",
		    "ARROW_RIGHT"};
		
extern const char * VarTypesStr[22]={"int","char","long","float","double","long double",
			"enum","unsigned char","unsigned int",
			"short int","unsigned long","FXMainWindow",
			"FXArrowButton","FXButton",
			"FXCheckButton","FXTextField",
			"FXFont","FXMatrix",
			"FXComboBox","FXList",
			"FXRadioButton"};
			
extern const char * strMtxStyle[2]={"MATRIX_BY_COLUMNS",
		        "MATRIX_BY_ROWS"};
		
extern const char*	strDialStyle[2]={"DIAL_HORIZONTAL","DIAL_VERTICAL"};

extern const char*	strSliderStyle[6]={"SLIDER_HORIZONTAL","SLIDER_VERTICAL",
			"SLIDER_HORIZONTAL|SLIDER_ARROW_UP",
			"SLIDER_HORIZONTAL|SLIDER_ARROW_DOWN",
			"SLIDER_VERTICAL|SLIDER_ARROW_LEFT",
			"SLIDER_VERTICAL|SLIDER_ARROW_RIGHT"};
			
extern const char*	strScrollBarStyle[2]={"SCROLLBAR_VERTICAL","SCROLLBAR_HORIZONTAL"};
extern const char*	strGroupStyle[3]={"GROUPBOX_TITLE_LEFT","GROUPBOX_TITLE_CENTER","GROUPBOX_TITLE_RIGHT"};
extern const char*	strMnuButtonDir[4]={"MENUBUTTON_DOWN","MENUBUTTON_UP",
			"MENUBUTTON_LEFT","MENUBUTTON_RIGHT"};
extern const char*	strPopupDir[2]={"POPUP_VERTICAL","POPUP_HORIZONTAL"};
extern const char*	strGrids[3]={"VER_GRIDLINES","HOR_GRIDLINES","VER_GRIDLINES|HOR_GRIDLINES"};

// Patterns
extern const FXchar* filepatterns[15]={
			"All Files","*",
			"All Source","*.cpp,*.cxx,*.cc,*.C,*.c,*.hpp,*.hxx,*.hh,*.H,*.h,*.y,*.l",
			"C++ Source Files","*.cpp,*.cxx,*.cc,*.C",
			"C++ Header Files","*.hpp,*.hxx,*.hh,*.H,*.h",
			"C Source Files","*.c",
			"C Header Files","*.h",
			"Text Files","*.txt",
			NULL
			};

extern const FXString ec="\"";
extern const FXchar b='\\';
extern const FXString AppFont="helvetica";
		FXMatrix*	mtxSamples;
                            FXIcon*		comboicon;		//icon declaration
		FXIcon*		checkicon;
		FXIcon*		buttonicon;
		FXIcon*		listboxicon;
		FXIcon*		spinnericon;
		FXIcon*		textboxicon;
		FXIcon*		multilineicon;
		FXIcon*		radioicon;
		FXIcon*		arrowbuttonicon;
		FXIcon*		labelicon;
		FXIcon* 	mainicon;
		FXIcon* 	matrixicon;
		FXIcon* 	menuicon;
		FXIcon*		createicon;
		FXIcon*		fonticon;
		FXIcon*		coloricon;
		FXIcon*		txtColorIcon;
		FXIcon*		newicon;
		FXIcon*		openicon;
		FXIcon*		saveicon;
		FXIcon*		saveasicon;
		FXIcon*		printicon;
		FXIcon*		cuticon;
		FXIcon*		copyicon;
		FXIcon*		pasteicon;
		FXIcon*		codeicon;
		FXIcon*		propertiesicon;
		FXIcon* 	toolboxicon;
		FXIcon*		cplusicon;
		FXIcon*		dialicon;
		FXIcon*		slidericon;
		FXIcon*		deleteicon;
		
		FXText*		editor;
		FXString	Total;
		FXString	DeclareStr;
		FXString	newObjectStr;
		FXbool		HasText;
		FXint		ObjType;
		
		
  FXList*	lstVars;                  //main
  FXList*	lstEnums;
  FXList*	lstMethods;
  FXComboBox*	cmbVarTypes;

  FXTextField*	txtAppName;
  FXTextField*	txtAppVendor;
  FXTextField*	txtClassName;
  FXTextField*	txtAddVar;
  FXTextField*	txtAddEnum;
  FXTextField*	txtAddMethod;
  FXCheckButton* chkStatusBar;
  FXCheckButton* chkToolBar;
  FXCheckButton* chkToolTip;
